/**
 * 资金账号登陆
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        global = require("gconfig").global,
        layerUtils = require("layerUtils"),
        gconfig = require("gconfig"),
        platform = require("gconfig").platform,
        shellPlugin = require("shellPlugin"),
        validatorUtil = require("validatorUtil"),
        startCountDown = null,
        _pageId = "#account_login",
        key = 1,
        steps = ["uploadimg", "idconfirm", "witness",
            "certintall", "capitalacct",
            "stkacct", "setpwd", "tpbank",
            "risksurvey", "visitsurvey", "success"
        ],
        stepMap = {"idconfirm": "account/showAccount", "uploadimg": "account/uploadPhotoChange", "witness": "account/vedioNotice", "certintall": "account/signProtocol", "risksurvey": "account/riskAssessment"},
    /*stepMap = {"account":"account/mainPage","survey":"account/knowledge","knowledge_level":"account/integrity","integrity_level":"account/riskInfo","risk_level":"account/riskInfo",
     "level":"account/comprehensiveScore","survey_level":"account/signProtocol","open_confirm":"account/questionsRevisit","open_finish":"account/result"
     },*/
        stepMap0 = {"uploadimg": "account/uploadPhotoChange", "witness": "account/digitalCertificate"};
    /* 私有业务模块的全局变量 end */

    var user_id = "";
    var external = require("external");

    function init() {


        //获取验证码
        codeRefresh();
        //add by fengxiang 2015-08-25
        // 启动时，检查当前客户端的版本号与服务器上最新的是否一致，根据需要更新客户端，只在启动时检查，started 为 true
        // 表示已启动，已启动就不检查
        if (appUtils.getSStorageInfo("started", true) != "true") {
            // 设置 session 中的 started 为 true ，表示已启动
            var param = {
                "moduleName": "open",
                "funcNo": "50030"
            };
            //判断是否有网络
            var result = external.callMessage(param);
            var error_no = result.error_no;
            var result = result.results[0];
            if (error_no == "0") { //查询网络成功
                if (result.network != "0") {	//判断是否有网络  0：断网，1：2G，2：3G，3：4G，4：WIFI，9：未定义
                    appUtils.setSStorageInfo("started", "true", true);
                    layerUtils.iLoading(true, "正在检查版本...");
                    setBestAddress(); // 设置最佳地址
                } else {
                    layerUtils.iAlert("请连接网络！");
                }
            } else {
                layerUtils.iAlert("查询网络失败,请稍后重试！");
            }
        }
        //end by fengxiang 2015-08-25

    }

    //更换验证码
    function codeRefresh() {
        $(_pageId + " .code_box img").attr("src", global.serverUrl + "/nImgServlet?key=" + Math.random());
    }

    function bindPageEvent() {
        /* 绑定返回事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_back"), function () {
            //是否是中焯的
            if (global.isZhongZhuo) {
                //add by fengxiang 2015-08-11 判断是否是从主页跳转过来的，是的话就返回主页，不是的话就返回中焯
                var preModule = appUtils.getSStorageInfo("preModule", true);
                if (preModule == "main") {
                    appUtils.sendDirect("../open/index.html#!/business/index.html");
                } else {
                    var param = {
                        "funcNo": "50101",
                        "moduleName": "open"
                    };
                    external.callMessage(param);
                    appUtils.clearSStorage(true);
                    $(_pageId).remove();
                }
                //end by fengxiang 2015-08-11 判断是否是从主页跳转过来的，是的话就返回主页，不是的话就返回中焯
            } else {
                //单独广州 跳转到首页
                appUtils.clearSStorage(true);
                appUtils.setSStorageInfo("started", "true", true);
                appUtils.sendDirect("../open/index.html#!/business/index.html");
            }
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            if (require("gconfig").platform != "1") {
                //ios 获取软件是否安装
                var param = {
                    "funcNo": "50200",
                    "moduleName": "open",
                    "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                };
                var result = external.callMessage(param);
                if (result.error_no == 0) {
                    var isInstall = result.results[0].isInstall;
                    //是否安装(0：否，1：是）
                    if (isInstall == "1") {
                        var param = {
                            "funcNo": "50109",
                            "moduleName": "open",
                            "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
//							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                        };
                        external.callMessage(param);
                    } else {
                        layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                            //进入appstore
                            var param = {
                                "funcNo": "50109",
                                "moduleName": "open",
                                "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                            };
                            external.callMessage(param);
                        }, null, "下载", "取消");
                    }
                } else {
                    layerUtils.iAlert("检测QQ失败");
                }
            } else {
                var param = {
                    "funcNo": "50109",
                    "moduleName": "open",
//					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                    "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                };
                external.callMessage(param);
            }
        });

        /* 切换图形验证码 */
        appUtils.bindEvent($(_pageId + " .btn_refresh"), function () {
            $(_pageId + " .code_box img").attr("src", global.serverUrl + "/nImgServlet?key=" + Math.random());
        });

        /* 校验图形验证码 */
        appUtils.bindEvent($(_pageId + " .mobile_form .pic_code"), function () {
        }, "input");

        /* 绑定资金密码输入*/
        appUtils.bindEvent($(_pageId + " .password"), function () {
            var password = $(_pageId + " .password").val();
            if (password != "") {
                $(_pageId + " .btn_clear").show();
            } else if (password == "") {
                $(_pageId + " .btn_clear").hide();
            }
            if (!$(_pageId + " btn_clear").is(":hidden")) {
                appUtils.bindEvent($(_pageId + " .btn_clear"), function () {
                    $(_pageId + " .password").val("");
                    $(_pageId + " .btn_clear").hide();
                });
            }
        }, "input");

        /* 下一步(继续开户) */
        appUtils.bindEvent($(_pageId + " .ct_btn a"), function () {
            //检查输入的信息
            if (checkInfo()) {
                //登陆资金账号
                loginAccount();
            }
        });

        /* 绑定输入账号验证只让输入数字*/
        appUtils.bindEvent($(_pageId + " .account"), function () {
            var accountNumStr = $(_pageId + " .account").val().trim();
            if (accountNumStr != "") {
                if (!validatorUtil.isNumeric(accountNumStr)) {
                    layerUtils.iMsg(-1, "请输入数字资金账号！");
                    var str = $(_pageId + " .account").val();
                    $(_pageId + " .account").val(str.substring(0, str.length - 1));
                    return false;
                }
            }
        }, "input");

        /* 绑定输入验证码只能输入数字和字母*/
        appUtils.bindEvent($(_pageId + " .code"), function () {
            var codeStr = $(_pageId + " .code").val().trim();
            if (codeStr != "") {
                if (!(validatorUtil.isNumeric(codeStr) || validatorUtil.isEnNumeric(codeStr))) {
                    layerUtils.iMsg(-1, "请正确输入验证码！");
                    $(_pageId + " .code").val("");
                    return false;
                }
            }
        }, "input");

        /* 绑定输入密码只能输入六位数字*/
        appUtils.bindEvent($(_pageId + " .password"), function () {
            var codeStr = $(_pageId + " .password").val().trim();
            if (codeStr != "") {
                if (!validatorUtil.isNumeric(codeStr)) {
                    layerUtils.iMsg(-1, "请输入数字密码！");
                    var str = $(_pageId + " .password").val();
                    $(_pageId + " .password").val(str.substring(0, str.length - 1));
                    return false;
                }
            }
        }, "input");

    }

    function destroy() {
        $(_pageId + " .account").val("");   //清除资金账号
        $(_pageId + " .password").val("");  //清除密码
        $(_pageId + " .code").val("");  // 清除验证码
        codeRefresh();
        service.destroy();
    }

    /* 验证输入信息*/
    function checkInfo() {
        var account_str = $(_pageId + " .account").val().length,
            password_str = $(_pageId + " .password").val().length,
            code_str = $(_pageId + " .code").val().length,
            accountStr = $(_pageId + " .account").val().trim();
        if ((accountStr.length) < 10 || (accountStr.length) > 11) {
            layerUtils.iMsg(-1, "请输入10~11位的资金账号！");
            codeRefresh();
            return false;
        }
        if (password_str == 0) {
            layerUtils.iMsg(-1, "请输入交易密码！");
            codeRefresh();
            return false;
        }
        if (code_str == 0) {
            layerUtils.iMsg(-1, "请输入验证码！");
            codeRefresh();
            return false;
        }
        if (!validatorUtil.isNumeric(accountStr)) {
            layerUtils.iMsg(-1, "请输入数字交易账号！");
            codeRefresh();
            return false;
        }
        if (!((6 <= password_str) && (password_str <= 20))) {
            layerUtils.iMsg(-1, "请输入6-20位的交易密码！");
            codeRefresh();
            return false;
        }
        return true;
    }

    //登陆资金账号
    function loginAccount() {
        service.getRSAKey({}, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;

            if (error_no == 0) {
                var modulus = result[0].modulus;
                var publicExponent = result[0].publicExponent;
                var endecryptUtils = require("endecryptUtils");

                var fund_account = $(_pageId + " .account").val(),
                    password = $(_pageId + " .password").val(),
                    code = $(_pageId + " .code").val();
                var tpassword = endecryptUtils.rsaEncrypt(modulus, publicExponent, password.trim());

                appUtils.setSStorageInfo("password", password, true);
                appUtils.setSStorageInfo("account_no", fund_account, true);
                var param = {
                    "fund_account": fund_account,
                    "password": tpassword,
                    "verify_code": code
                };
                //登陆资金账号
                service.loginAccount(param, loginAccountCall, false);
            } else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(error_info, -1);
            }
        }, false);

    }

    function loginAccountCall(data) {

        var error_no = data.error_no;
        var error_info = data.error_info;
        var result = data.results;

        if (error_no == "0" && result.length != 0) {
            user_id = result[0].user_id;
            if (result[0].login_flag == "1") {
                appUtils.setSStorageInfo("acct_fndacct", $(_pageId + " .account").val());
                appUtils.setSStorageInfo("login_info", JSON.stringify(result[0]));
                appUtils.setSStorageInfo("jsessionid", result[0].jsessionid);
                appUtils.setSStorageInfo("clientinfo", result[0].clientinfo);
                appUtils.setSStorageInfo("branchno", result[0].branchno);
                appUtils.setSStorageInfo("user_id", result[0].user_id);
                if (addition(result[0])) {
                    return;
                }
                service.queryAccountUpdateData(queryAccountUpdateData, {
                    "user_id": user_id
                }, false);
            } else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(result[0].login_reason, -1);
            }
        } else {
            layerUtils.iLoading(false);
            codeRefresh();
            layerUtils.iAlert(error_info, -1);
        }
    }

    /* 处理驳回补全资料的情况 */
    function addition(res) {
        // 驳回情况：身份证正面、反面、大头像、交易密码、资金密码、三方存管、转户驳回到视频见证
        var photoParam = {
            "needFront": res.need_photo_front != undefined ? res.need_photo_front : "0",
            "needBack": res.need_photo_back != undefined ? res.need_photo_back : "0",
            "needNohat": res.need_photo_nohat != undefined ? res.need_photo_nohat : "0"
        };
        var pwdParam = {
            "needBusinessPwd": res.need_business_password != undefined ? res.need_business_password : "0",
            "needFundPwd": res.need_fund_password != undefined ? res.need_fund_password : "0"
        };
        var thirdParam = {
            "needThirdDeposit": res.need_third_deposit != undefined ? res.need_third_deposit : "0"
        };
        var videoParam = {
            "need_video": res.need_video != undefined ? res.need_video : "0"
        };
        // 1.补全照片
        if (photoParam["needFront"] == 1 || photoParam["needBack"] == 1 || photoParam["needNohat"] == 1) {
            appUtils.setSStorageInfo("videoParam", JSON.stringify(videoParam));
            appUtils.setSStorageInfo("photoparam", JSON.stringify(photoParam));
            appUtils.pageInit("account/login", "account/backUploadPhoto", photoParam);
            return true;
        }
        // 2.驳回密码设置
        if (pwdParam["needBusinessPwd"] == 1 || pwdParam["needFundPwd"] == 1) {

            appUtils.pageInit("account/login", "account/backSetPwd", pwdParam);
            return true;
        }
        // 3.驳回三方存管
        if (thirdParam["needThirdDeposit"] == 1) {
            appUtils.pageInit("account/login", "account/backThirdDepository", thirdParam);
            return true;
        }
        // 4.驳回视频见证
        if (videoParam["need_video"] == 1) {
            appUtils.setSStorageInfo("backVedioNotice", "6");
            appUtils.setSStorageInfo("videoParam", JSON.stringify(videoParam));
            appUtils.pageInit("account/login", "account/vedioNotice", videoParam);
            return true;
        } else {
            return false;
        }
    }

    //流程控制
    function next_step() {

        var res = JSON.parse(appUtils.getSStorageInfo("login_info"));
        var pageCode = stepMap[res.lastcomplete_step];
        if (pageCode) {
            appUtils.pageInit("account/login", pageCode);
            return true;
        }

        return false;
    }

    function queryAccountUpdateData(data) {
        var error_no = data.error_no;
        var error_info = data.error_info;
        var result = data.results;
        if (data != null) {
            if (error_no == "0") {
                service.queryAccountInfoCurrent(queryAccountInfoCurrent, {"user_id": user_id}, true);
            } else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(error_info, -1);
            }

        } else {
            layerUtils.iLoading(false);
            layerUtils.iAlert("网络错误，登陆失败", -1);
        }
    }

    function queryAccountInfoCurrent(data) {
        var error_no = data.error_no;
        var error_info = data.error_info;
        //	var result = data.results;

        if (data) {
            if (error_no == "0") {
                //是否是中焯的  是中焯的就保存下渠道值
                if (global.isZhongZhuo) {
                    //add by fengxiang 2015-08-25 保存渠道数据
                    var param = {
                        "user_id": user_id,
                        "channela": getMemoryInfo("channelValue"),  //getMemoryInfo("channela")
                        "channelb": getMemoryInfo("channelb"),
                        "channelc": getMemoryInfo("channelc")
                    };
                    service.saveChannel(param, function (data) {
                        //只需要保存
                    });
                    //end by fengxiang 2015-08-25 保存渠道数据
                }

                if ((data.relenishResult)[0].relenish_result == "0") {

                    if (next_step()) {
                        return;
                    }
                    appUtils.setSStorageInfo("curstep", "account/msgConfirm");
                    appUtils.pageInit("account/login", "account/msgConfirm");
                } else {
                    appUtils.setSStorageInfo("curstep", "account/result");
                    appUtils.pageInit("account/login", "account/accountResult");
                }
            } else {
                layerUtils.iAlert(error_info, -1);
            }
        } else {
            layerUtils.iAlert("网络错误，登陆失败", -1);
        }
    }

    function nextStep(res) {
        if (res.back_step == "1" || res.back_step == "3" || res.back_step == "4") {
            appUtils.pageInit("account/login", "account/result");
        } else if (res.back_step == "2") {
            appUtils.pageInit("account/login", "account/integrity", {});
        } else if (!!res.current_step) {//!!res.current_step
            //流程控制
            var step = stepMap[res.current_step];
            if (!!step) {
                appUtils.pageInit("account/login", step, {});
            } else {
                appUtils.pageInit("account/login", "account/mainPage", {});
            }

        } else {
            appUtils.pageInit("account/login", "account/msgConfirm", {});
        }
    }

    /********************************start 自动更新************************************/
    /* 自动测速，选择最佳地址 */
    function setBestAddress() {
        // 检测更新最新版本
        detectUpdate();
    }

    /* 检测更新最新版本 */
    function detectUpdate() {
        var queryParam = {
            "by_type": "1",
            "terminal_type": platform == "1" ? "android" : "ios"
        };
        //是否是中焯的  // by_type 1: 中焯版本   2： 单独
        if (global.isZhongZhuo) {
            queryParam.by_type = "1";
        } else {
            queryParam.by_type = "2";
        }
        service.getVersion(queryParam, function (data) {
            //alert("8888:"+JSON.stringify(data));
            if (data.error_no == 0) {
                layerUtils.iLoading(false);
                // 服务器有数据返回时
                if (data.results.length != 0 && data.results[0].update_url != undefined) {
                    if (platform == "1") {
                        execUpdateAndroid(data.results); // 执行安卓更新
                    } else {
                        execUpdateIOS(data.results); // 执行IOS更新
                    }

                }
            } else // 查询地址失败
            {
                layerUtils.iLoading(false);
                layerUtils.iAlert("版本检查失败，请稍后重试！");
            }
        }, true, false);
    }

    // 执行安卓更新操作
    function execUpdateAndroid(results) {
        var param = {
            "funcNo": "50010",
            "moduleName": "common",
            "source": "open"
        };
        //获取当前版本
        var data = external.callMessage(param);
        if (data.error_no == "0") {
            //如果当前版本不是最新的 则下载更新
            var version = results[0].version; // 最新版本
            var version_now = data.results[0].versionSn; // 当前版本
            if (version > version_now) {
                var updateParam = {
                    "url": results[0].update_url,  // 更新地址
                    "type": "1",
                    "version": results[0].version,  // 最新版本号
                    // 只有一条记录取 0
                    "versionSn": results[0].version,
                    "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
                    "funcNo": "50201",
                    "moduleName": "common",
                    "source": "open"
                };
                external.callMessage(updateParam);
            }
        }
    }

    // 执行IOS更新操作
    function execUpdateIOS(results) {
        var updateParam = {
            "url": results[0].update_url,  // 更新地址
            "type": "1",
            "version": results[0].version,  // 最新版本号
            // 只有一条记录取 0
            "versionSn": results[0].version,
            "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
            "funcNo": "50201",
            "moduleName": "open"
        };
        external.callMessage(updateParam);
    }

    /********************************end 自动更新************************************/
        //add by fengxiang 2015-08-25  从内存缓存获取数据
    function getMemoryInfo(key) {
        var param = {
            "funcNo": "50041",
            "key": key
        };
        var result = external.callMessage(param);
        if (result.error_no == "0") { //获取缓存成功
            var value = result.results[0].value;
            return value;
        } else {
            layerUtils.iAlert("获取内存数据失败");
        }
    }

    //end by fengxiang 2015-08-25  从内存缓存获取数据

    var login = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    //暴露接口
    module.exports = login;
});
