/**
 * 修改电话号码
 */
define(function (require, exports, module) {
    var appUtils = require("appUtils"),
        gconfig = require("gconfig"),
        global = require("gconfig").global,
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        validatorUtil = require("validatorUtil"),
        utils = require("utils"),
        mobile_no = "",
        flag = "",
        layerUtils = require("layerUtils"),
        shellPlugin = require("shellPlugin"),
        startCountDown = null,
        address = "",
        steps = ["account", "survey", "knowledge_level",
            "integrity_level", "risk_level",
            "level", "survey_level", "open_confirm",
            "open_finish"
        ],
        _pageId = "#account_msgConfirm";

    var login_info;
    var account_info;
    var account_change;
    var myprovinceno = "",
        mycityno = "",
        hometown = "";
    var external = require("external");

    function init() {
        //add by fengxiang 2015-07-23 区分ios和安卓 使用日期的方式
        if (gconfig.platform != '1') {
            $(_pageId + " .divBeginDate").html("<span><a style=\"color:#D90003\">*</a>起始期限</span><input type=\"date\" class=\"t1 idBeginDate\" id=\"idBeginDate\"  value=\"\"/>");
            $(_pageId + " .divEndDate").html("<span><a style=\"color:#D90003\">*</a>结束期限</span><input type=\"date\" class=\"t1 idEndDate\" id=\"idEndDate\"  value=\"\" />");
        }
        //end by fengxiang 2015-07-23 区分ios和安卓 使用日期的方式

        login_info = JSON.parse(appUtils.getSStorageInfo("login_info"));
        account_change = {"user_id": login_info.user_id};

        window.calendarCallback = calendarCallback;
        cleanPage();
        /* 发送验证码后自动互调该方法 */
        window.getCode = getCode;
        flag = "fasle", mobile_no = "";
        // 获取应用版本versionName
        /*shellPlugin.callShellMethod("getVersionPlugin",function(data) {
         var versionName = JSON.stringify(data.versionName);
         mobversionName = versionName.replace(/^\"|\"$/g, '');
         var molileAttribution ="android|" + mobversionName; // 获取应用版本:例如:android|2.0.1
         account_change.mobversion = molileAttribution;
         }, null);*/

        //add by fengxiang 2015-08-25 升级
        var param = {
            "moduleName": "open",
            "funcNo": "50010"
        };
        var result = external.callMessage(param);
        if (result.error_no == "0") {
            var data = result.results[0];
            var versionName = JSON.stringify(data.version);
            var mobversionName = versionName.replace(/^\"|\"$/g, '');
            var molileAttribution = "android|" + mobversionName; // 获取应用版本:例如:android|2.0.1
            account_change.mobversion = molileAttribution;
        }
        //end by fengxiang 2015-08-25 升级

        initMsg();//填充个人资料
        // 获取职业大项
        queryOccupationBig();
        // 获取行业大项
        queryIndustryBig();

    }

    //填充个人资料
    function initMsg() {
        initPage(account_info);
        service.queryAccountInfo(function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;
            if (error_no == 0) {
                account_info = data;
                appUtils.setSStorageInfo("account_info", JSON.stringify(account_info));
                initPage(data);
                queryDataDict();

                hometown = (account_info.userInfo)[0].hometown;
                if (hometown == "") {
                    $(_pageId + " .select").show();
                    $(_pageId + " .onlyShow").hide();
                    getProvinceAndCity();
                } else {
                    $(_pageId + " .select").hide();
                    $(_pageId + " .onlyShow").show();
                    $(_pageId + " .hometown").val(hometown);
                }

            } else {
                layerUtils.iAlert(error_info, -1);
            }
        }, {"user_id": login_info.user_id});

    }

    //初始化页面
    function initPage(account_info) {
        $(_pageId + " .com_info_list li:eq(0) div").text(account_info ? (account_info.userInfo)[0].custname : "");
        $(_pageId + " .com_info_list li:eq(1) .idCardNo").val(account_info ? (account_info.userInfo)[0].idno : "");
        $(_pageId + " #idBeginDate").val(account_info ? (account_info.userInfo)[0].idbegindate : "");
        $(_pageId + " #idEndDate").val(account_info ? (account_info.userInfo)[0].idenddate : "");
        $(_pageId + " .address").val(account_info ? (account_info.userInfo)[0].addr : "");
        $(_pageId + " .mobileno").val(account_info ? (account_info.userInfo)[0].mobileno : "");

    }


    /**
     * @description 查询职业列表 -- 职业大项
     */
    function queryOccupationBig() {
        /* search_type为1，职业查询；parentid为空，顶级父级查询，即职业大项 */
        var param = {
            "search_type": "1",
            "parentid": ""
        };
        /* 加载职业大项的回调 */
        var callBack = function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            // 清空历史数据
            $(_pageId + " .bigJob ul li").remove();
            var occupational = data.OccupationList;
            if (error_no == "0" && occupational.length != 0) {
                var myContent = [];
                for (var i = 0; i < occupational.length; i++) {
                    // 职业大项列表
                    var occupHtml = "<li><span class='occupation0" + i + "' value='" + occupational[i].id + "'>" + occupational[i].name + "</span></li>";
                    myContent.push(occupHtml);
                }
                $(_pageId + " .bigJob ul").html(myContent.join(""));
            } else {
                layerUtils.iMsg(-1, error_info);
            }

        }
        service.queryOccupationAndIndustry(param, callBack, true, false);
    }

    /**
     * @description 查询职业列表 -- 职业小项
     * @param id  当前的职业大项
     */
    function queryOccupationListSmall(id) {
        /* search_type为1，职业查询；parentid不为空，为职业大项返回数据中的id值，即职业大项 */
        var param = {
            "search_type": "1",
            "parentid": id
        };
        /* 加载职业小项的回调 */
        var callBack = function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            // 清空历史数据
            $(_pageId + " .smallJob ul li").remove();
            var occupational = data.OccupationList;
            if (error_no == "0" && occupational.length != 0) {
                var myContent = [];
                for (var i = 0; i < occupational.length; i++) {
                    // 职业小项列表
                    var occupHtml = "<li><span class='occupation0" + i + "' occupation_old='" + occupational[i].occupation_old + "' value='" + occupational[i].id + "'>" + occupational[i].name + "</span></li>";
                    myContent.push(occupHtml);
                }
                $(_pageId + " .smallJob ul").html(myContent.join(""));
            } else {
                layerUtils.iMsg(-1, error_info);
            }
        }
        service.queryOccupationAndIndustry(param, callBack, true, false);
    }

    /**
     * @description 查询行业列表 -- 行业大项
     */
    function queryIndustryBig() {
        /* search_type为0，行业查询；parentid为空，顶级父级查询，即行业大项 */
        var param = {
            "search_type": "0",
            "parentid": ""
        };
        /* 加载行业大项的回调 */
        var callBack = function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            // 清空历史数据
            $(_pageId + " .selectBigIndustry_info ul li").remove();
            var industrys = data.IndustryList;
            if (error_no == "0" && industrys.length != 0) {
                var myContent = [];
                for (var i = 0; i < industrys.length; i++) {
                    // 职业大项列表
                    var industHtml = "<li><span class='industry0" + i + "' value='" + industrys[i].id + "'>" + industrys[i].name + "</span></li>";
                    myContent.push(industHtml);
                }
                $(_pageId + " .selectBigIndustry_info ul").html(myContent.join(""));
            } else {
                layerUtils.iMsg(-1, error_info);
            }
        }
        service.queryOccupationAndIndustry(param, callBack, true, false);
    }

    /**
     * @description 查询行业列表 -- 行业小项
     */
    function queryIndustrySmall(id) {
        /* search_type为0，行业查询；parentid为空，顶级父级查询，即行业大项 */
        var param = {
            "search_type": "0",
            "parentid": id
        };
        /* 加载行业小项的回调 */
        var callBack = function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            // 清空历史数据
            $(_pageId + " .selectSmallIndustry_info ul li").remove();
            var industrys = data.IndustryList;
            if (error_no == "0" && industrys.length != 0) {
                var myContent = [];
                for (var i = 0; i < industrys.length; i++) {
                    // 职业小项列表
                    var industHtml = "<li><span class='industry0" + i + "' industryid_old='" + industrys[i].industryid_old + "' value='" + industrys[i].id + "'>" + industrys[i].name + "</span></li>";
                    myContent.push(industHtml);
                }
                $(_pageId + " .selectSmallIndustry_info ul").html(myContent.join(""));
            } else {
                layerUtils.iMsg(-1, error_info);
            }
        }
        service.queryOccupationAndIndustry(param, callBack, true, false);
    }


    /* 获取职业与学历列表 */
    function queryDataDict() {

//        // 先获取职业
//        var occupationalParam = {
//            "enum_type": "occupational"
//        };
//        service.queryDataDict(occupationalParam,
//            function (data) {
//                var error_no = data.error_no,
//                    error_info = data.error_info;
//                // 首先移除数据
//                $(_pageId + " .sel_list:eq(0) ul li").remove();
//                if (error_no == "0" && data.results.length != 0) {
//                    var occupational = data.results;
//                    var profession_code = appUtils.getSStorageInfo("profession_code");
//                    for (var i = 0; i < occupational.length; i++) {
//                        var str = "<li><span class='occupation0" + i + "' value='" + occupational[i].item_value + "'>" + occupational[i].item_name + "</span></li>";
//                        $(_pageId + " .sel_list:eq(0) ul").append(str);
//                        if (profession_code != "" && occupational[i].item_value == profession_code) {
//                            $(_pageId + " .selectOccupation").text(occupational[i].item_name);
//                            $(_pageId + " .selectOccupation").val(occupational[i].item_value);
//                        }
//                        BindSelectOccupation(i); // 预绑定选择职业的事件
//                    }
//
//                    /** start by 2015-03-26 再获取行业**/
//                    var IndustryParam = {
//                        "enum_type": "occupation"
//                    };
//                    service.queryDataDict(IndustryParam,
//                        function (data) {
//                            var error_no = data.error_no,
//                                error_info = data.error_info;
//                            // 首先移除原有的数据
//                            $(_pageId + " .sel_list:eq(1) ul li").remove();
//                            if (error_no == "0" && data.results.length != 0) {
//                                var adapter = data.results;
//                                var industry_code = appUtils.getSStorageInfo("industry_code");
//                                for (var i = 0; i < adapter.length; i++) {
//                                    var str = "<li><span class='Industry0" + i + "' value='" + adapter[i].item_value + "'>" + adapter[i].item_name + "</span></li>";
//                                    $(_pageId + " .sel_list:eq(1) ul").append(str);
//                                    if (industry_code != "" && adapter[i].item_value == industry_code) {
//                                        $(_pageId + " .selectIndustry").text(adapter[i].item_name);
//                                        $(_pageId + " .selectIndustry").val(adapter[i].item_value);
//                                    }
//                                    BindSelectIndustry(i);
//                                }

        //获取民族
        var param = {"enum_type": "ethnicType"};
        service.queryDataDict(param, function (data) {
            var error_no = data.error_no,
                error_info = data.error_info;

            // 首先移除原有的数据
            $(_pageId + " .sel_list:eq(2) ul li").remove();
            if (error_no == "0" && data.results.length != 0) {
                var adapter = data.results;
                var ethnic_code = (account_info.userInfo)[0].ethnic;
                for (var i = 0; i < adapter.length; i++) {
                    var str = "<li><span class='ethnic0" + i
                        + "' value='"
                        + adapter[i].item_value + "'>"
                        + adapter[i].item_name
                        + "</span></li>";
                    $(_pageId + " .sel_list:eq(2) ul")
                        .append(str);
                    if (ethnic_code != ""
                        && adapter[i].item_value == ethnic_code) {
                        $(_pageId + " .selectNation")
                            .text(adapter[i].item_name);
                        $(_pageId + " .selectNation")
                            .val(adapter[i].item_value);
                    }
                    BindSelectNation(i); // 预绑定选择民族的事件
                }
            }
        });

//                            } else {
//                                layerUtils.iMsg(-1, error_info); // 提示错误信息
//                            }
//                        }, true);
//
//
//                } else {
//                    layerUtils.iMsg(-1, error_info); // 提示错误信息
//                }
//            }, false);

    }

    /* 预绑定选择职业的事件 */
    function BindSelectOccupation(i) {
        appUtils.bindEvent($(_pageId + " .sel_list:eq(0) ul .occupation0" + i),
            function (e) {
                $(_pageId + " .selectOccupation").attr("value", $(_pageId + " .occupation0" + i).attr("value"));
                $(this).parent().addClass("active").siblings().removeClass("active");
                var check_val = $(_pageId + " .occupation0" + i).text();
                // 去掉选中内容最后两个“确定”
                e.stopPropagation(); // 阻止冒泡
                // 绑定点击确定
                // appUtils.bindEvent($(_pageId+" .job .sel_info
                // a"),function(e){
                $(_pageId + " .selectOccupation").text(check_val);
                $(_pageId + " .sel_list:eq(0)").slideUp("fast",
                    function () {
                        $("body #bodyContent").css("overflow", "auto");
                    }); // 隐藏选择学历列表
                e.stopPropagation(); // 阻止冒泡
                // });
            });
    }

    /* 预绑定选择行业的事件 */
    function BindSelectIndustry(i) {
        appUtils.bindEvent($(_pageId + " .sel_list:eq(1) ul .Industry0" + i),
            function (e) {
                // strong 不能用 val() 方法设置 value ，用的话无效
                $(_pageId + " .selectIndustry").attr("value", $(_pageId + " .Industry0" + i).attr("value"));
                $(this).parent().addClass("active").siblings().removeClass("active");
                var check_val = $(_pageId + " .Industry0" + i).text();
                // 去掉选中内容最后两个“确定”
                $(_pageId + " .selectIndustry").text(check_val);
                $(_pageId + " .sel_list:eq(1)").slideUp("fast",
                    function () {
                        $("body #bodyContent").css("overflow", "auto");
                    }); // 隐藏选择学历列表
                e.stopPropagation(); // 阻止冒泡
                // });
            });
    }

    /* 预绑定选择民族的事件 */
    function BindSelectNation(i) {
        appUtils.bindEvent($(_pageId + " .sel_list:eq(2) ul .ethnic0" + i),
            function (e) {
                // strong 不能用 val() 方法设置 value ，用的话无效
                $(_pageId + " .selectNation").attr("value", $(_pageId + " .ethnic0" + i).attr("value"));
                $(this).parent().addClass("active").siblings().removeClass("active");
                var check_val = $(_pageId + " .ethnic0" + i).text();
                // 去掉选中内容最后两个“确定”
                $(_pageId + " .selectNation").text(check_val);
                $(_pageId + " .sel_list:eq(2)").slideUp("fast",
                    function () {
                        $("body #bodyContent").css("overflow", "auto");
                    }); // 隐藏选择学历列表
                e.stopPropagation(); // 阻止冒泡
                // });
            });
    }

    function getProvinceAndCity() {
        var param = {};
        service.getProvinceAndCity(param,
            function (data) {
                //  	alert(JSON.stringify(data));
                var error_no = data.error_no;
                var error_info = data.error_info;
                if (error_no == "0" && data.dsName) {
                    provinceList = data.provinceList; // 省份集合
                    cityList = data.cityList; // 城市集合
                    var plen = provinceList.length,
                        clen = cityList.length;
                    var pro_str = "", provContent = [];
                    for (var i = 0; i < plen; i++) {
                        var provinceno = provinceList[i].provinceno; // 省份id
                        var provincename = provinceList[i].provincename; // 省份名称
//                        pro_str += "<li pid='" + provinceno + "'><span>" + provincename + "</span></li>";
                        provContent.push("<li pid='" + provinceno + "'><span>" + provincename + "</span></li>");
                        /*2015-05-13                     if (myprovinceno != "" && provinceno == myprovinceno) {
                         alert(provincename+",:"+myprovinceno);
                         $(_pageId + " .selectProvince").text(provincename); // 选中值赋给选择框
                         $(_pageId + " .selectProvince").val(myprovinceno);
                         }*/
                    }
                    var mycity_str = "", cityContent = [];
                    if (mycityno != "") {
                        for (var i = 0; i < clen; i++) {
                            provincenno = cityList[i].provincenno;
                            cityno = cityList[i].cityno;
                            cityname = cityList[i].cityname;
                            if (myprovinceno == provincenno && mycityno == cityno) {
                                /* 2015-05-13                       	alert(cityname+",:"+cityno);
                                 $(_pageId + " .selectCity").text(cityname); // 选中值赋给选择框
                                 $(_pageId + " .selectCity").val(cityno);*/

                            }
                            if (provincenno == myprovinceno) {
//                                mycity_str += "<li cid='" + cityno + "'><span>" + cityname + "</span></li>";
                                cityContent.push("<li cid='" + cityno + "'><span>" + cityname + "</span></li>");
                            }

                        }

                    }
                    if (mycity_str != "") {
//                        $(_pageId + " .city ul").html(mycity_str); // 填充城市下拉框
                        $(_pageId + " .city ul").html(cityContent.join("")); // 填充城市下拉框
                    }
//                    $(_pageId + " .province ul").html(pro_str); // 填充城市下拉框
                    $(_pageId + " .province ul").html(provContent.join("")); // 填充城市下拉框
                    bindProvince(); // 点击省份
                } else {
                    layerUtils.iMsg(-1, "籍贯获取失败"); // 提示错误信息
                }

            });
    }

    function bindProvince() {
        appUtils.bindEvent($(_pageId + " .province ul li"),
            function (e) {
                var pid = $(this).attr("pid");
                $(this).addClass("active").siblings().removeClass("active");
                var provincename = $(this).text();
                myprovinceno = pid;

                var sel_pname = $(_pageId + " .selectProvince").text();
                e.stopPropagation(); // 阻止冒泡
                // 绑定点击确定
                // appUtils.bindEvent($(_pageId+" .province
                // .sel_info a"),function(e){
                $(_pageId + " .selectProvince").text(provincename); // 选中值赋给选择框
                $(_pageId + " .sel_list:eq(4)").slideUp("fast",
                    function () {
                        $("body #bodyContent").css("overflow", "auto");
                    }); // 隐藏选择学历列表
                /* 选中省份立即填充相应城市 */
                if (provincename != sel_pname) // 再次点击相同省份,下级菜单不改变
                {
                    $(_pageId + " .selectCity").text("请选择市");
                    $(_pageId + " .city ul").html("");
                }
                var provincenno = ""; // 省份ID
                var city_str = "";
                for (var i = 0; i < cityList.length; i++) {
                    provincenno = cityList[i].provincenno;
                    cityno = cityList[i].cityno;
                    cityname = cityList[i].cityname;
                    if (pid == provincenno) {
                        city_str += "<li cid='" + cityno + "'><span>" + cityname + "</span></li>";
                    }
                }
                $(_pageId + " .city ul").html(city_str); // 填充城市下拉框
                e.stopPropagation(); // 阻止冒泡
                bindCity(); // 点击城市
                // });
            });
    }

    /* 选中城市事件绑定 */
    function bindCity() {
        /* 选中城市事件绑定 */
        appUtils.bindEvent($(_pageId + " .city ul li"),
            function (e) {
                var cid = $(this).attr("cid");
                $(this).addClass("active").siblings().removeClass("active");
                var cityname = $(this).text();
                mycityno = cid;

                var sel_cname = $(_pageId + " .sel_city").text();
                $(_pageId + " .selectCity").text(cityname); // 选中值赋给选择框
                $(_pageId + " .hometown").val($(_pageId + " .selectProvince").text() + $(_pageId + " .selectCity").text());
                $(_pageId + " .sel_list:eq(3)").slideUp("fast",
                    function () {
                        $("body #bodyContent").css("overflow", "auto");
                    }); // 隐藏选择学历列表
                e.stopPropagation(); // 阻止冒泡
            });
    }

    function bindPageEvent() {

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            //连接客服
            customerService();
        });
        //获取验证码
        appUtils.bindEvent($(_pageId + " .blue_code"), function () {
            var mobileno = $(_pageId + " .mobileno").val();
            if (validatorUtil.isMobile(mobileno)) {
                sendSmsCode(mobileno);  //获取验证码

            }
            else {
                // 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
                var times = mobileno.length - 11;
                if (mobileno.length > 11) {
                    layerUtils.iMsg(-1, "您多输入&nbsp;" + times + "&nbsp;位电话号码，请重新输入！");
                }
                else if (mobileno.length < 11) {
                    layerUtils.iMsg(-1, "您少输入&nbsp;" + Math.abs(times) + "&nbsp;位电话号码，请重新输入！");
                } else {
                    layerUtils.iMsg(-1, "请输入正确的电话号码！");
                }
                return;
            }
        });

        //提交电话修改
        appUtils.bindEvent($(_pageId + " .ct_btn"), function () {
            if (verifyInfo()) {
                //				alert(JSON.stringify(account_change));
                service.updateUserInfoByTrade(account_change, function (data) {
                    var error_no = data.error_no,
                        error_info = data.error_info;

                    if (error_no == 0) {
                        appUtils.pageInit("account/msgConfirm", "account/showAccount");
                    } else {
                        layerUtils.iMsg(-1, error_info); // 提示错误信息
                    }
                });
            }
        });

        /* 绑定输入账号验证只让输入数字*/
        appUtils.bindEvent($(_pageId + " .mobileno"), function () {
            var accountNumStr = $(_pageId + " .mobileno").val().trim();
            if (accountNumStr != "") {
                if (!validatorUtil.isNumeric(accountNumStr)) {
                    layerUtils.iMsg(-1, "请正确输入号码！");
                    var str = $(_pageId + " .mobileno").val();
                    $(_pageId + " .mobileno").val(str.substring(0, str.length - 1));
                    return false;
                }
            }
        }, "input");

        /* 绑定输入验证码只让输入数字*/
        appUtils.bindEvent($(_pageId + " .code"), function () {
            var accountNumStr = $(_pageId + " .code").val().trim();
            if (accountNumStr != "") {
                if (!validatorUtil.isNumeric(accountNumStr)) {
                    layerUtils.iMsg(-1, "请正确输入验证码！");
                    var str = $(_pageId + " .code").val();
                    $(_pageId + " .code").val(str.substring(0, str.length - 1));
                    return false;
                }
            }
        }, "input");

        //处理返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            //清除所有缓存*/
            appUtils.clearSStorage();
            appUtils.setSStorageInfo("started", "true", true);
            // 清除项目中的html
            $("#bodyContent .page").each(function () {
                $(this).remove();
            });
            appUtils.pageInit("account/msgConfirm", "account/login");
        });

        //清空验证码输入框
        appUtils.bindEvent($(_pageId + " .code"), function () {
            $(this).val("");
        });

//        /* 选择职业 */
//        appUtils.bindEvent($(_pageId + " .selectOccupation"),
//            function (e) {
//                $(_pageId + " .job ul li").removeClass("active");
//                $(_pageId + " .sel_list:eq(0)").slideDown("fast",
//                    function () {
//                        $("body #bodyContent").css("overflow", "hidden");
//
//                    });
//                e.stopPropagation(); // 阻止冒泡
//            });
//
//        /* 选择行业 */
//        appUtils.bindEvent($(_pageId + " .selectIndustry"),
//            function (e) {
//                $(_pageId + " .selectIndustry_info ul li").removeClass("active");
//                $(_pageId + " .sel_list:eq(1)").slideDown("fast",
//                    function () {
//                        $("body #bodyContent").css("overflow", "hidden");
//
//                    }); // 显示选择学历的下拉列表
//                e.stopPropagation(); // 阻止冒泡
//            });

        /* 选择职业,弹出职业列表 */
        appUtils.bindEvent($(_pageId + " .selectBigOccupation"), function (e) {
            $(_pageId + " .bigJob ul li").removeClass("active");
            $(_pageId + " .bigJob").slideDown("fast", function () {
                $("body #bodyContent").css("overflow", "hidden");
            });
            e.stopPropagation(); // 阻止冒泡
        });

        appUtils.bindEvent($(_pageId + " .selectSmallOccupation"), function (e) {
            if ($(_pageId + " .selectBigOccupation").attr("value")) {
                $(_pageId + " .smallJob ul li").removeClass("active");
                $(_pageId + " .smallJob").slideDown("fast", function () {
                    $("body #bodyContent").css("overflow", "hidden");
                });
                e.stopPropagation(); // 阻止冒泡
            } else {
                layerUtils.iMsg(-1, "职业大项为必选项，请选择！");
                return;
            }

        });

        /* 选择职业大项 */
        appUtils.preBindEvent($(_pageId + " .bigJob ul"), "li", function (e) {
            $(this).addClass("active").siblings().removeClass("active");
            var parent_id = $(this).children().attr("value");
            $(_pageId + " .selectBigOccupation").attr("value", parent_id);
            // 原选择的职业大项
            var sel_occupation = $(_pageId + " .selectBigOccupation").text();
            // 当前选择的职业大项
            var occupation = $(this).children().text();
            $(_pageId + " .selectBigOccupation").text(occupation);
            if (occupation !== sel_occupation) {
                $(_pageId + " .selectSmallOccupation").text("职业小项");
            }
            $(_pageId + " .bigJob").slideUp("fast", function () {
                $("body #bodyContent").css("overflow", "auto");
                // 获取对应的小项
                queryOccupationListSmall(parent_id);
            });
            e.stopPropagation();    // 阻止冒泡
        });

        /* 选择职业小项 */
        appUtils.preBindEvent($(_pageId + " .smallJob ul"), "li", function (e) {
            $(this).addClass("active").siblings().removeClass("active");
            // 这里给旧职业value属性赋值
            $(_pageId + " .selectOccupation").val($(this).children().attr("occupation_old"));
            $(_pageId + " .selectSmallOccupation").attr("value", $(this).children().attr("value"));
            $(_pageId + " .selectSmallOccupation").text($(this).children().text());
            $(_pageId + " .smallJob").slideUp("fast", function () {
                $("body #bodyContent").css("overflow", "auto");
            });
            e.stopPropagation();    // 阻止冒泡
        });

        /* 选择行业，弹出行业列表 */
        appUtils.bindEvent($(_pageId + " .selectBigIndustry"), function (e) {
            $(_pageId + " .selectBigIndustry_info ul li").removeClass("active");
            // 显示选择学历的下拉列表
            $(_pageId + " .selectBigIndustry_info").slideDown("fast", function () {
                $("body #bodyContent").css("overflow", "hidden");
            });
            e.stopPropagation(); // 阻止冒泡
        });

        appUtils.bindEvent($(_pageId + " .selectSmallIndustry"), function (e) {
            if ($(_pageId + " .selectBigIndustry").attr("value")) {
                $(_pageId + " .selectSmallIndustry_info ul li").removeClass("active");
                // 显示选择学历的下拉列表
                $(_pageId + " .selectSmallIndustry_info").slideDown("fast", function () {
                    $("body #bodyContent").css("overflow", "hidden");
                });
                e.stopPropagation(); // 阻止冒泡
            } else {
                layerUtils.iMsg(-1, "行业大项为必选项，请选择！");
                return;
            }

        });

        /* 选择行业大项 */
        appUtils.preBindEvent($(_pageId + " .selectBigIndustry_info ul"), "li", function (e) {
            $(this).addClass("active").siblings().removeClass("active");
            var parent_id = $(this).children().attr("value");
            $(_pageId + " .selectBigIndustry").attr("value", parent_id);
            // 原选择行业大项
            var sel_industry = $(_pageId + " .selectBigIndustry").text();
            // 当前选择行业大项
            var industry = $(this).children().text();
            $(_pageId + " .selectBigIndustry").text(industry);
            if (industry !== sel_industry) {
                $(_pageId + " .selectSmallIndustry").text("行业小项");
            }
            $(_pageId + " .selectBigIndustry_info").slideUp("fast", function () {
                $("body #bodyContent").css("overflow", "auto");
                // 对应的小项
                queryIndustrySmall(parent_id);
            });
            e.stopPropagation();    // 阻止冒泡
        });

        /* 选择行业小项 */
        appUtils.preBindEvent($(_pageId + " .selectSmallIndustry_info ul"), "li", function (e) {
            $(this).addClass("active").siblings().removeClass("active");
            // 这里给旧职业value属性赋值
            $(_pageId + " .selectIndustry").val($(this).children().attr("industryid_old"));
            $(_pageId + " .selectSmallIndustry").attr("value", $(this).children().attr("value"));
            $(_pageId + " .selectSmallIndustry").text($(this).children().text());
            $(_pageId + " .selectSmallIndustry_info").slideUp("fast", function () {
                $("body #bodyContent").css("overflow", "auto");
            });
            e.stopPropagation();    // 阻止冒泡
        });

        /* 选择民族 */
        appUtils.bindEvent($(_pageId + " .selectNation"),
            function (e) {
                $(_pageId + " .selectNation_info ul li").removeClass("active");
                $(_pageId + " .sel_list:eq(2)").slideDown("fast",
                    function () {
                        $("body #bodyContent").css("overflow", "hidden");

                    }); // 显示选择学历的下拉列表
                e.stopPropagation(); // 阻止冒泡
            });

        /* 点击页面其他元素隐藏下拉列表 */
        appUtils.bindEvent($(_pageId),
            function (e) {
                $(_pageId + " .sel_list").slideUp("fast",
                    function () {
                        $("body #bodyContent").css("overflow", "auto");
                    });
                e.stopPropagation(); // 阻止冒泡
            });

        /* 绑定选择日期的事件 */
        appUtils.bindEvent($(_pageId + " input[date-plugin='true']"),
            function (e) {
                /* 通过壳子调用系统的日历插件 */
                utils.selectDate(this);
                $(this).css("color", "#1E1E1E");
            });

        /* 绑定选择省的事件 */
        appUtils.bindEvent($(_pageId + "  .selectProvince"),
            function (e) {
                /* 通过壳子调用系统的日历插件 */
                $(_pageId + " .province ul li").removeClass("active");
                $(_pageId + " .sel_list:eq(4)").slideDown("fast",
                    function () {
                        $("body #bodyContent").css("overflow", "hidden");

                    }); // 显示选择学历的下拉列表
                e.stopPropagation(); // 阻止冒泡
            });

        /* 绑定选择市的事件 */
        appUtils.bindEvent($(_pageId + "  .selectCity"),
            function (e) {
                /* 通过壳子调用系统的日历插件 */
                $(_pageId + " .city ul li").removeClass("active");
                $(_pageId + " .sel_list:eq(3)").slideDown("fast",
                    function () {
                        $("body #bodyContent").css("overflow", "hidden");

                    }); // 显示选择学历的下拉列表
                e.stopPropagation(); // 阻止冒泡
            });

    }

    /* 日历的回调函数 */
    function calendarCallback(data) {
        // 回调数据中的 data 是字符串，需解析a
        if (typeof(data) == 'string') {
            data = JSON.parse(data);
        }
        $(_pageId + " #" + data.selector).val(data.date);

    }

    function destroy() {
        service.destroy();
    }

    /* 信息提交校验 */
    function verifyInfo() {
        var now = new Date();
        var nowStr = now.format("yyyy-MM-dd");  //获取当前时间
        var name = $(_pageId + " .com_info_list li:eq(0) div").text().replace(/(^\s*)|(\s*$)/g, ''); // 姓名
        account_change.custname = name;
        var idCardNo = $(_pageId + " .com_info_list li:eq(1) .idCardNo").val().trim(); // 身份证
        account_change.idno = idCardNo;
//	        var signDepartment = $(_pageId + " .user_form .signDepartment").val(); // 签发机关
//	        var idCardAddress = $(_pageId + " .user_form .idCardAddress").val(); // 证件地址
        var address = $(_pageId + " .address").val().trim(); // 联系地址
        account_change.addr = address;
        var idBeginDate = $(_pageId + " .idBeginDate").val(); // 起始期限
        account_change.idbegindate = idBeginDate;
        var idEndDate = $(_pageId + " .idEndDate").val(); // 结束期限
        account_change.idenddate = idEndDate;
//	        var zipCode = $(_pageId + " .user_form .zipCode").val(); // 邮编
//        var selectOccupation = $(_pageId + " .input_form .selectOccupation").text(); // 职业
        account_change.writeInfo_vocation = $(_pageId + " .input_form .selectOccupation").attr("value");
        var selectBigOccupation = $(_pageId + " .input_form .selectBigOccupation").text(); // 新职业大项
        account_change.occupation_big_val = $(_pageId + " .input_form .selectBigOccupation").attr("value");
        var selectSmallOccupation = $(_pageId + " .input_form .selectSmallOccupation").text(); // 新职业小项
        account_change.occupation_small_val = $(_pageId + " .input_form .selectSmallOccupation").attr("value");
//	        var selectDegree = $(_pageId + " .input_form .selectDegree").text(); // 学历
//        var selectIndustry = $(_pageId + " .input_form .selectIndustry").text(); // 行业
        account_change.edu_input = $(_pageId + " .input_form .selectIndustry").attr("value");
        var selectBigIndustry = $(_pageId + " .input_form .selectBigIndustry").text(); // 新行业大项
        account_change.industry_big_val = $(_pageId + " .input_form .selectBigIndustry").attr("value");
        var selectSmallIndustry = $(_pageId + " .input_form .selectSmallIndustry").text(); // 新行业小项
        account_change.industry_small_val = $(_pageId + " .input_form .selectSmallIndustry").attr("value");
        var nation = $(_pageId + " .selectNation").text();
        account_change.ethnic = $(_pageId + " .selectNation").attr("value");
        var hometown = $(_pageId + " .hometown").val();
        account_change.hometown = hometown;
        var mobileno = $(_pageId + " .mobileno").val();
        account_change.mobileno = mobileno;
        var code = $(_pageId + " .code").val();
        account_change.code = code;

//        if (selectIndustry == "") {
//            layerUtils.iMsg(-1, "行业不能为空");
//            return false;
//        }
        if (selectBigIndustry === "行业大项" || selectSmallIndustry === "行业小项") {
            layerUtils.iMsg(-1, "行业不能为空");
            return false;
        }
        if (name == "") {
            layerUtils.iMsg(-1, "姓名不能为空");
            return false;
        }
        if (idCardNo == "") {
            layerUtils.iMsg(-1, "身份证不能为空");
            return false;
        }
        // 验证身份证的格式
        if (!validatorUtil.isCardID(idCardNo)) {
            layerUtils.iMsg(-1, "请输入正确的身份证号码!");
            return false;
        }
        //如果15位提示修改
        if (idCardNo.length == 15) {
            layerUtils.iMsg(-1, "请输入18位身份证号码");
            return false;
        }
        /*if (signDepartment == "") {
         layerUtils.iMsg( - 1, "签发机关不能为空");
         return false;
         }
         if (idCardAddress == "") {
         layerUtils.iMsg( - 1, "证件地址不能为空");
         return false;
         }*/

        if (idBeginDate == "") {
            layerUtils.iMsg(-1, "身份证起始期限不能为空");
            return false;
        }
        if (idEndDate == "") {
            layerUtils.iMsg(-1, "身份证结束期限不能为空");
            return false;
        }
        if (Date.parse(idEndDate) <= Date.parse(nowStr)) {
            layerUtils.iMsg(-1, "有效期已过期，请您重新上传身份证!");
            return false;
        }
        if (Date.parse(idBeginDate) > Date.parse(nowStr)) {
            layerUtils.iMsg(-1, "身份证起始期限不能大于当前日期");
            return false;
        }
        /* if (zipCode == "") {
         layerUtils.iMsg( - 1, "邮编不能为空");
         return false;
         }
         if (!require("validatorUtil").isPostalCode(zipCode)) {
         layerUtils.iMsg( - 1, "邮编格式不正确,请重新输入");
         return false;
         }*/
//        if (selectOccupation == "请选择职业") {
//            layerUtils.iMsg(-1, "职业不能为空");
//            return false;
//        }
        if (selectBigOccupation === "职业大项" || selectSmallOccupation === "职业小项") {
            layerUtils.iMsg(-1, "职业不能为空");
            return false;
        }

        /*  if (selectDegree == "请选择学历") {
         layerUtils.iMsg( - 1, "学历不能为空");
         return false;
         }*/

        if (nation == "请选择民族") {
            layerUtils.iMsg(-1, "民族不能为空");
            return false;
        }

        if (hometown == "") {
            layerUtils.iMsg(-1, "请选择籍贯");
            return false;
        }
        if (code == "") {
            layerUtils.iMsg(-1, "验证码不能为空");
            return false;
        }
        if (address == "") {
            layerUtils.iMsg(-1, "联系地址不能为空");
            return false;
        }
        // 发送身份证存在性检查之前，前端验证身份证的格式
        if (!validatorUtil.isCardID(idCardNo)) {

            layerUtils.iMsg(-1, "请输入正确的身份证号码!");
            return false;
        }
        // 对不满 18 周岁进行控制
        // 只考虑 18 为身份证
        if (idCardNo.length == 18) {
            var dateStr = idCardNo.substring(6, 10) + "/" + idCardNo.substring(10, 12) + "/" + idCardNo.substring(12, 14),
                userAge = new Date().getTime() - Date.parse(dateStr);
            userAge = userAge / (365 * 24 * 60 * 60 * 1000);
            if (parseInt(userAge) < 18) {
                layerUtils.iAlert("您的年龄未满 18 周岁，不允许开户!", -1);
                return false;
            }
        }
        /* if ($(_pageId + " .selectProvince").text() == "请选择省份") {
         layerUtils.iMsg( - 1, "请选择籍贯所在省份");
         return;
         }
         if ($(_pageId + " .selectCity").text() == "请选择市") {
         layerUtils.iMsg( - 1, "请选择籍贯所在市");
         return;
         }*/
        // 验证有效期的格式
        var dateReg = /^[1-3]\d{3}-(0|1)\d-[0-3]\d$/;
        if (!(dateReg.test(idBeginDate))) {
            layerUtils.iMsg(-1, "有效期的起始时间不符合格式!");
            return false;
        }
        if (!(dateReg.test(idEndDate))) {
            layerUtils.iMsg(-1, "有效期的结束时间不符合格式!");
            return false;
        }
        // 校验身份证期限是否符合格式
        if (Date.parse(idBeginDate) >= Date.parse(idEndDate)) {
            layerUtils.iMsg(-1, "有效期的起始时间必须小于结束时间!");
            return false;
        }

        if (validatorUtil.isMobile(mobileno)) {

        }
        else {
            // 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
            var times = mobileno.length - 11;
            if (mobileno.length > 11) {
                layerUtils.iMsg(-1, "您多输入&nbsp;" + times + "&nbsp;位电话号码，请重新输入！");
                return false;
            }
            else if (mobileno.length < 11) {
                layerUtils.iMsg(-1, "您少输入&nbsp;" + Math.abs(times) + "&nbsp;位电话号码，请重新输入！");
                return false;
            } else {
                layerUtils.iMsg(-1, "请输入正确的电话号码！");
                return false;
            }
            return;
        }
        /* // 页面入参的 身份证号 ，身份证号最多只允许修改五位
         var pageInIdCardNo = appUtils.getPageParam("idNo"),
         // 计算身份证修改的位数
         countDiffe = 0;
         $(_pageId + " .idCardNo").attr("borthday", idCardNo.substring(6, 10) + "-" + idCardNo.substring(10, 12) + "-" + idCardNo.substring(12, 14));*/
        return true;
    }

    /* 壳子获取验证码自动填充 */
    function getCode(data) {
        if (data) {
            $(_pageId + " .code").val(data);
        }
    }

    //发送验证码
    function sendSmsCode(mobileno) {
        var param = {
            "user_id": login_info.user_id,
            "mobile_no": mobileno
        };
        service.sendSmsCode(param, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;
            if (error_no == "0") {
                flag = true;
                // 计时器
                var sumTime = 120;
                //处理获取验证码时发生的动作
                var handleCount = function () {
                    // 获取验证码之后按钮隐藏
                    $(_pageId + " .blue_code").hide();
                    // 显示倒计时
                    $(_pageId + " .get_code").show();
                    $(_pageId + " .get_code").text(sumTime-- + "秒后重发");
                };
                handleCount();
                startCountDown = window.setInterval(function () {
                    handleCount();
                }, 1000);
                // 120 秒之后清除计时器
                var clearCountDown = setTimeout(function () {
                    flag = false;
                    // 显示按钮
                    $(_pageId + " .blue_code").show();
                    // 隐藏倒计时
                    $(_pageId + " .get_code").hide();
                    $(_pageId + " .get_code").text(120);
                    window.clearInterval(startCountDown);
                }, 121000);
                //发送完验证码后，通过判断输入手机号是否一致，否则重新发送验证码
                var c_phoneNum = mobileno;
                appUtils.bindEvent($(_pageId + " .mobileno"), function () {
                    c_phoneNum = $(_pageId + " .mobileno").val();
                    if (validatorUtil.isMobile(mobileno) && validatorUtil.isMobile(c_phoneNum)) {
                        //用户两次输入的手机号不同，重新获取验证码
                        if (c_phoneNum != mobileno) {
                            clearInterval(startCountDown);   //清除定时器
                            clearTimeout(clearCountDown);
                            $(_pageId + " .blue_code").show();  // 显示按钮
                            $(_pageId + " .get_code").hide();  // 隐藏倒计时
                            flag = false;
                        }
                    }
                }, "input");
                // 调用读取短信验证码插件
                //require("shellPlugin").callShellMethod("sMSReceiverPlugin",null,null,null);
            } else {
                layerUtils.iAlert(error_info, -1);
                return false;
            }
        });
    }

    //连接客服
    function customerService() {
        var branchID = appUtils.getSStorageInfo("branchno");
        var brokersno = appUtils.getSStorageInfo("recommendno");
        if (branchID == undefined) {
            branchID = "";
        }
        if (brokersno == undefined) {
            brokersno = "";
        }
        //如有选择了营业部或经纪人则需要传
        var param1 = {
            "userid": appUtils.getSStorageInfo("user_id"),
            "branchno": branchID,
            "brokersno": brokersno
        }
        console.log("================================ param1=" + JSON.stringify(param1));
        /*  added at 2015/09/02
         *  入参： user_id （客户id）
         出参：调用成功有两种情况，
         1.如果属于中焯渠道 会返回 status=1
         2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
        service.serachIsCompanyCustomer(param1, function (data) {
            console.log("================================ data=" + JSON.stringify(data));

            var error_no = data.error_no,
                error_info = data.error_info;
            if (error_no == "0") {
                var status = data.results[0].status;
                if (status == "0") {
                    $(".ly_shadow").show();
                    var branchname = data.results[0].branchname;
                    var brokersname = data.results[0].brokersname;
                    var servicephone = data.results[0].servicephone;
                    var brokersphone = data.results[0].brokersphone;
                    var address = data.results[0].address;
                    var info = "";
                    //有经纪人的
                    if (!!brokersname) {
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听经纪人电话事件
                        appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    } else {//无经纪人的
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    }
                } else {
                    if (require("gconfig").platform != "1") {
                        //ios 获取软件是否安装
                        var param = {
                            "funcNo": "50200",
                            "moduleName": "open",
                            "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                        };
                        var result = external.callMessage(param);
                        if (result.error_no == 0) {
                            var isInstall = result.results[0].isInstall;
                            //是否安装(0：否，1：是）
                            if (isInstall == "1") {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                    //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                };
                                external.callMessage(param);
                            } else {
                                layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                    //进入appstore
                                    var param = {
                                        "funcNo": "50109",
                                        "moduleName": "open",
                                        "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                    };
                                    external.callMessage(param);
                                }, null, "下载", "取消");
                            }
                        } else {
                            layerUtils.iAlert("检测QQ失败");
                        }
                    } else {
                        var param = {
                            "funcNo": "50109",
                            "moduleName": "open",
                            //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                        };
                        external.callMessage(param);
                    }
                }
            } else {
                layerUtils.iAlert(error_info);
            }
        });
    }

    //清空页面信息
    function cleanPage() {
        $(_pageId + " .selectOccupation").text("请选择职业");     //清理职业选择
        $(_pageId + " .selectIndustry").text("请选择行业");
        $(_pageId + " .selectNation").text("请选择民族");
        $(_pageId + " .selectProvince").text("请选择省份");
        $(_pageId + " .selectCity").text("请选择市");
        $(_pageId + " .hometown").val("");
        $(_pageId + " .code").val("");
        $(_pageId + " .blue_code").show();  // 显示按钮
        $(_pageId + " .get_code").hide();  // 隐藏倒计时
    }

    var msgConfirm = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = msgConfirm;
});