/**
 * 风险测评结果
 */
define(function (require, exports, module) {
    var appUtils = require("appUtils"),
        utils = require("utils"),
        service = require("serviceImp").getInstance(),
        global = require("gconfig").global, _pageId = "#account_riskAssessmentResult";
    var service = require("serviceImp").getInstance();  //业务层接口，请求数据

    var login_info;
    var external = require("external");

    function init() {

        login_info = JSON.parse(appUtils.getSStorageInfo("login_info"));

        // 设置按钮显示提示文字
        if (appUtils.getSStorageInfo("openChannel") == "change") {
            $(_pageId + " .fix_bot .ct_btn a").html("继续转户 >");
        } else {
            $(_pageId + " .fix_bot .ct_btn a").html("继续开户 >");
        }

        // 只有从 riskAssessment 跳转过来时，才设置页面的填充数据
        if (appUtils.getSStorageInfo("_prePageCode") == "account/riskAssessment") {
            var remark = appUtils.getPageParam("remark"); // 风险等级
            var riskdesc = appUtils.getPageParam("riskdesc"); // 风险等级描述
            var showStr = riskdesc;
            // 清空原有内容
            $(_pageId + " div[class='test_level']").text("");
            $(_pageId + " div[class='test_level']").append(showStr);
        }
    }

    function bindPageEvent() {
        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            customerService();
        });

        // 重新测评绑定事件
        appUtils.bindEvent($(_pageId + " .test_result p:eq(1) a"), function () {
            appUtils.pageInit("account/riskAssessmentResult", "account/riskAssessment", {});
        });

        /**
         * 9.1 风险测评结果页面进入问卷回访页面
         */
        appUtils.bindEvent($(_pageId + " .ct_btn"), function () {
            service.modifyUserFinishFlag({"user_id": login_info.user_id}, function (data) {

                var error_no = data.error_no;
                var error_info = data.error_info;
                if (error_no == 0) {
                    appUtils.pageInit("account/riskAssessmentResult", "account/accountResult", {});
                } else {
                    layerUtils.iAlert(error_info, -1);
                }
            });

            // if(global.needConfirm)
            // {
            // appUtils.pageInit("account/riskAssessmentResult","account/openConfirm",{});
            // }
            // else
            // {
            // appUtils.pageInit("account/riskAssessmentResult","account/accountResult",{});
            // }
        });
    }


    //连接客服
    function customerService() {
        var branchID = appUtils.getSStorageInfo("branchno");
        var brokersno = appUtils.getSStorageInfo("recommendno");
        if (branchID == undefined) {
            branchID = "";
        }
        if (brokersno == undefined) {
            brokersno = "";
        }
        //如有选择了营业部或经纪人则需要传
        var param1 = {
            "userid": appUtils.getSStorageInfo("user_id"),
            "branchno": branchID,
            "brokersno": brokersno
        }
        console.log("================================ param1=" + JSON.stringify(param1));
        /*  added at 2015/09/02
         *  入参： user_id （客户id）
         出参：调用成功有两种情况，
         1.如果属于中焯渠道 会返回 status=1
         2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
        service.serachIsCompanyCustomer(param1, function (data) {
            console.log("================================ data=" + JSON.stringify(data));

            var error_no = data.error_no,
                error_info = data.error_info;
            if (error_no == "0") {
                var status = data.results[0].status;
                if (status == "0") {
                    $(".ly_shadow").show();
                    var branchname = data.results[0].branchname;
                    var brokersname = data.results[0].brokersname;
                    var servicephone = data.results[0].servicephone;
                    var brokersphone = data.results[0].brokersphone;
                    var address = data.results[0].address;
                    var info = "";
                    //有经纪人的
                    if (!!brokersname) {
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听经纪人电话事件
                        appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    } else {//无经纪人的
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    }
                } else {
                    if (require("gconfig").platform != "1") {
                        //ios 获取软件是否安装
                        var param = {
                            "funcNo": "50200",
                            "moduleName": "open",
                            "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                        };
                        var result = external.callMessage(param);
                        if (result.error_no == 0) {
                            var isInstall = result.results[0].isInstall;
                            //是否安装(0：否，1：是）
                            if (isInstall == "1") {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                    //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                };
                                external.callMessage(param);
                            } else {
                                layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                    //进入appstore
                                    var param = {
                                        "funcNo": "50109",
                                        "moduleName": "open",
                                        "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                    };
                                    external.callMessage(param);
                                }, null, "下载", "取消");
                            }
                        } else {
                            layerUtils.iAlert("检测QQ失败");
                        }
                    } else {
                        var param = {
                            "funcNo": "50109",
                            "moduleName": "open",
                            //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                        };
                        external.callMessage(param);
                    }
                }
            } else {
                layerUtils.iAlert(error_info);
            }
        });
    }

    function destroy() {
    }

    var riskAssessmentResult = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = riskAssessmentResult;
});