/**
 * 资金账号登陆
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        global = require("gconfig").global,
        layerUtils = require("layerUtils"),
        utils = require("utils"),
        platform = require("gconfig").platform,
        shellPlugin = require("shellPlugin"),
        validatorUtil = require("validatorUtil"),
        startCountDown = null,
        _pageId = "#account_showAccount";

    var account_info;
    var login_info;

    var szHasAccount,//深A
        szAaccount,
        shHasAccount,//沪B
        shAaccount,
        sha_regflag;//沪A是否指定交易
    var external = require("external");


    function init() {
        account_info = JSON.parse(appUtils.getSStorageInfo("account_info"));
        login_info = JSON.parse(appUtils.getSStorageInfo("login_info"));

        hide();

        if (!account_info) {
            service.queryAccountInfo(function (data) {
                var error_no = data.error_no;
                var error_info = data.error_info;
                var result = data.results;
                if (error_no == 0) {
                    account_info = data;
                    appUtils.setSStorageInfo("account_info", JSON.stringify(account_info));
                    initPage();
                } else {
                    layerUtils.iAlert(error_info, -1);
                }
            }, {"user_id": login_info.user_id});
        } else {
            initPage();
        }
    }

    //初始化页面
    function initPage() {
        var stockAccountList = account_info.stockAccountList;

        for (var k in stockAccountList) {
            var result = stockAccountList[k];
            if (result["stock_type"] == "sz_a") {
                szHasAccount = true;
                szAaccount = result["stock_account"];
            }
            if (result["stock_type"] == "sh_a") {
                shHasAccount = true;
                shAaccount = result["stock_account"];
                sha_regflag = result["regflag"];
                //当沪A未指定的时候 可以选择沪A
                if (sha_regflag == 0) {
                    shHasAccount = false;
                }
            }
        }

        var str = "";
        szHasAccount && (str = str + "<p class='tip'>深A(" + szAaccount + ")</p>") || $(_pageId + " .icon_radio:eq(1)").show();
        (shHasAccount && sha_regflag != 0) && (str = str + "<p class='tip'>沪A(" + shAaccount + ")</p>") || $(_pageId + " .icon_radio:eq(0)").show();

//		(szHasAccount&&shHasAccount)&&(str=str+"<p class='tip'>您目前在我司已开通了深A沪A证券账户。<p>");
        str == "" && (str = "<p class='tip'>您目前在我司未开通深A沪A证券账户。</p>");

        $(_pageId + " .gz_zhlist").text("");
        $(_pageId + " .gz_zhlist").html(str);
    }

    function bindPageEvent() {

        //
        appUtils.bindEvent($(_pageId + " .icon_check"), function () {
            $(this).toggleClass("checked");
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            customerService();
        });

        //返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
//			appUtils.pageBack();
            appUtils.pageInit("account/showAccount", "account/msgConfirm");

        });

        //绑定选择账户
        appUtils.bindEvent($(_pageId + " .icon_radio"), function () {
            $(_pageId + " .icon_radio").hasClass("checked") && $(_pageId + " .icon_radio").removeClass("checked") || $(_pageId + " .icon_radio").addClass("checked")
        });

        //绑定下一步
        appUtils.bindEvent($(_pageId + " .ct_btn"), function () {
            if (szHasAccount && shHasAccount) {
                layerUtils.iAlert("您的沪深证券账户都已开通，状态正常");
                return;
            }

            var stk_str = "";
            (szHasAccount != true && $(_pageId + " .icon_radio:eq(1)").hasClass("checked")) && (stk_str += "|sz_a,,0");
            (shHasAccount != true && $(_pageId + " .icon_radio:eq(0)").hasClass("checked")) && (stk_str += "|sh_a,,0");
            stk_str = stk_str.substring(1);
            if (stk_str == "") {
                layerUtils.iAlert("请选择账户");
            } else if (!$(_pageId + " .icon_check").hasClass("checked")) {
                layerUtils.iAlert("请阅读并勾选相关提示");
            } else {
                var param = {"user_id": login_info.user_id,
                    "handle_str": stk_str};
                service.submitUserSelectAccount(param, function (data) {
                    var error_no = data.error_no;
                    var error_info = data.error_info;
                    if (error_no == 0) {
                        var param = {
                            "user_id": login_info.user_id,
                            "next_step": "uploadimg_flag"
                        };
                        service.recordProcess(param, function (data) {
                            if (data.error_no == 0) {
                                if ((account_info.userInfo)[0].uploadIdcard_flag == "1") {
                                    appUtils.pageInit("account/showAccount", "account/uploadPhotoChange");
                                } else if ((account_info.userInfo)[0].needVedioWitness_flag == "1") {
                                    appUtils.pageInit("account/showAccount", "account/vedioNotice");
                                } else {

                                }
                            } else {
                                layerUtils.iAlert(data.error_info);
                            }
                        });

                    } else {
                        layerUtils.iLoading(false);
                        layerUtils.iAlert(error_info, -1);
                    }
                }, false);
            }
        });
    }

    function hide() {
        $(_pageId + " .icon_radio:eq(1)").hide();
        $(_pageId + " .icon_radio:eq(0)").hide()

    }


    //连接客服
    function customerService() {
        var branchID = appUtils.getSStorageInfo("branchno");
        var brokersno = appUtils.getSStorageInfo("recommendno");
        if (branchID == undefined) {
            branchID = "";
        }
        if (brokersno == undefined) {
            brokersno = "";
        }
        //如有选择了营业部或经纪人则需要传
        var param1 = {
            "userid": appUtils.getSStorageInfo("user_id"),
            "branchno": branchID,
            "brokersno": brokersno
        }
        console.log("================================ param1=" + JSON.stringify(param1));
        /*  added at 2015/09/02
         *  入参： user_id （客户id）
         出参：调用成功有两种情况，
         1.如果属于中焯渠道 会返回 status=1
         2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
        service.serachIsCompanyCustomer(param1, function (data) {
            console.log("================================ data=" + JSON.stringify(data));

            var error_no = data.error_no,
                error_info = data.error_info;
            if (error_no == "0") {
                var status = data.results[0].status;
                if (status == "0") {
                    $(".ly_shadow").show();
                    var branchname = data.results[0].branchname;
                    var brokersname = data.results[0].brokersname;
                    var servicephone = data.results[0].servicephone;
                    var brokersphone = data.results[0].brokersphone;
                    var address = data.results[0].address;
                    var info = "";
                    //有经纪人的
                    if (!!brokersname) {
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听经纪人电话事件
                        appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    } else {//无经纪人的
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    }
                } else {
                    if (require("gconfig").platform != "1") {
                        //ios 获取软件是否安装
                        var param = {
                            "funcNo": "50200",
                            "moduleName": "open",
                            "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                        };
                        var result = external.callMessage(param);
                        if (result.error_no == 0) {
                            var isInstall = result.results[0].isInstall;
                            //是否安装(0：否，1：是）
                            if (isInstall == "1") {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                    //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                };
                                external.callMessage(param);
                            } else {
                                layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                    //进入appstore
                                    var param = {
                                        "funcNo": "50109",
                                        "moduleName": "open",
                                        "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                    };
                                    external.callMessage(param);
                                }, null, "下载", "取消");
                            }
                        } else {
                            layerUtils.iAlert("检测QQ失败");
                        }
                    } else {
                        var param = {
                            "funcNo": "50109",
                            "moduleName": "open",
                            //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                        };
                        external.callMessage(param);
                    }
                }
            } else {
                layerUtils.iAlert(error_info);
            }
        });
    }

    function destroy() {
        service.destroy();
    }

    var login = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    //暴露接口
    module.exports = login;
});
