/**
 * 签署协议
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        global = require("gconfig").global,
        layerUtils = require("layerUtils"),
        utils = require("utils"),
        Map = require("map"),
        fristMap = null,  //  存放所有相关协议
        countProtocol = 0, // 计算签署成功的数量
        signFlag = "",  //1代表签了协议，2代表未签协议
        _pageId = "#account_signProtocol";

    var login_info;
    var account_info;
    var protocolArray;  // 存放协议签名值
    var external = require("external");

    function init() {
        login_info = JSON.parse(appUtils.getSStorageInfo("login_info"));

        signFlag = "2";
        appUtils.setSStorageInfo("signFlag", signFlag);
        //查询协议
        getSign();
    }

    //绑定
    function bindPageEvent() {
        /* 绑定签署协议*/
        appUtils.bindEvent($(_pageId + " .rule_check a"), function () {
            $(this).toggleClass("checked"); //  切换勾选样式
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            customerService();
        });

        //绑定提交申请
        appUtils.bindEvent($(_pageId + " .ct_btn"), function () {
            //验签
            protocolArray = new Array();  // 存放协议签名值
            getSignProtocl();

        });

        //绑定返回按钮
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
        });
    }

    function destroy() {
        service.destroy();
    }

    //获取协议
    function getSign() {
        var cate = 1;
        var param = {
            "category_englishname": "",
            "category_no": cate,
            "econtract_no": ""
        };
        var allProtocols = "";

        function getSignCall(data) {
            var error_no = data.error_no,
                error_info = data.error_info,
                result = data.results;
            if (error_no == "0") {
                fristMap = new Map();
                var results = data.results;
                var protocolMap = null;
                for (var i = 0; i < results.length; i++) {
                    if (results[i].econtract_no != "8002" && results[i].econtract_no != "8000" && results[i].econtract_no != "8003") continue;
                    protocolMap = new Map();
                    protocolMap.put("protocolid", results[i].econtract_no);	//协议id
                    protocolMap.put("protocolname", results[i].econtract_name);	//协议名
                    protocolMap.put("summary", results[i].econtract_md5);	//协议内容MD5,签名摘要信息
                    allProtocols += "<li><a href=\"javascript:;\" protocol-id=\"" + results[i].econtract_no + "\" id=\"protocol0" + i + "\">《" +
                        results[i].econtract_name + "》</a></li>";
                    // 预绑定查看协议的事件
                    appUtils.preBindEvent($(_pageId + " .rule_list ul"), "#protocol0" + i, function (e) {
                        appUtils.pageInit("account/signProtocol", "account/showProtocol", {"protocol_id": $(this).attr("protocol-id")});
                        e.stopPropagation();
                    });
                    fristMap.put(i, protocolMap);
                }
                if (cate == 2) {
                    $(_pageId + " .rule_list ul").html(allProtocols);
                }
                if (cate == 1) {
                    cate++;
                    param.category_no = cate;
                    service.getSign(param, getSignCall, true, true, handleTimeout);
                }
            } else {
                layerUtils.iAlert(error_info, -1);
            }
        }

        service.getSign(param, getSignCall, false, true, handleTimeout);
    }

    /* 处理请求超时 */
    function handleTimeout() {
        layerUtils.iConfirm("请求超时，是否重新加载？", function () {
            getSign();  // 再次获取协议
        });
    }

    /* 获取签名值 */
    function getSignProtocl() {
        var keys = fristMap.keys();  // 协议的数量
        // 检查是否勾选签署协议
        if ($(_pageId + " .rule_check a").hasClass("checked")) {
            layerUtils.iLoading(true);  // 开启等待层。。。
            var oneData = fristMap.get(keys[countProtocol]); // 取出一个协议
            var protocolid = oneData.get("protocolid"); // 协议ID
            var protocolname = oneData.get("protocolname");  //协议名称
            var summary = oneData.get("summary");  // 协议内容MD5,签名摘要信息
            // 添加值到数组中
            var protocol = {
                "protocol_id": protocolid,
                "protocol_content": summary
            }
            protocolArray.push(protocol);
            countProtocol++;
            if (countProtocol < keys.length)  // 通过比较，获取每个协议的签名值
            {
                getSignProtocl();
            } else {
                submitProtocol();  //提交协议
            }
        }
        else {
            layerUtils.iAlert("请阅读并勾选同意签署以上全部协议！", -1);
            return false;
        }
    }

    // 提交协议
    function submitProtocol() {
        countProtocol = 0;  // 将签署协议的计数器置为 0
        var signProtocolParam = {
            "user_id": login_info.user_id,
            "jsondata": JSON.stringify(protocolArray),
            "checksign": "0"
        };
        service.queryOpenCheckSign(signProtocolParam, function (data) {
            var error_no = data.error_no,
                error_info = data.error_info;
            if (error_no == "0") {
                var param = {
                    "user_id": login_info.user_id,
                    "next_step": "risksurvey_flag"
                };
                service.recordProcess(param, function (data) {
                    if (data.error_no == 0) {
                        signFlag = "1";
                        appUtils.setSStorageInfo("signFlag", signFlag);
                        appUtils.pageInit("account/signProtocol", "account/riskAssessment");
                    } else {
                        layerUtils.iAlert(data.error_info);
                    }
                });

            } else {
                signFlag = "2";
                layerUtils.iAlert(error_info, -1);
                layerUtils.iLoading(false);
            }
        }, false);
    }

    /*保存步骤*/
    function saveStep() {
        var param = {
            user_id: appUtils.getSStorageInfo("user_id"),
            current_step: "open_confirm"
        };
        service.saveUserTemp(function (data) {
            var errorNo = data.error_no;
            var errorInfo = data.error_info;
            if (errorNo == "0") {
                appUtils.setSStorageInfo("current_step", "open_confirm");
                appUtils.pageInit("account/signProtocol", "account/mainPage", {});
            } else {
                layerUtils.iAlert(errorInfo, -1);
            }
        }, param);

    }

    //连接客服
    function customerService() {
        var branchID = appUtils.getSStorageInfo("branchno");
        var brokersno = appUtils.getSStorageInfo("recommendno");
        if (branchID == undefined) {
            branchID = "";
        }
        if (brokersno == undefined) {
            brokersno = "";
        }
        //如有选择了营业部或经纪人则需要传
        var param1 = {
            "userid": appUtils.getSStorageInfo("user_id"),
            "branchno": branchID,
            "brokersno": brokersno
        }
        console.log("================================ param1=" + JSON.stringify(param1));
        /*  added at 2015/09/02
         *  入参： user_id （客户id）
         出参：调用成功有两种情况，
         1.如果属于中焯渠道 会返回 status=1
         2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
        service.serachIsCompanyCustomer(param1, function (data) {
            console.log("================================ data=" + JSON.stringify(data));

            var error_no = data.error_no,
                error_info = data.error_info;
            if (error_no == "0") {
                var status = data.results[0].status;
                if (status == "0") {
                    $(".ly_shadow").show();
                    var branchname = data.results[0].branchname;
                    var brokersname = data.results[0].brokersname;
                    var servicephone = data.results[0].servicephone;
                    var brokersphone = data.results[0].brokersphone;
                    var address = data.results[0].address;
                    var info = "";
                    //有经纪人的
                    if (!!brokersname) {
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听经纪人电话事件
                        appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    } else {//无经纪人的
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    }
                } else {
                    if (require("gconfig").platform != "1") {
                        //ios 获取软件是否安装
                        var param = {
                            "funcNo": "50200",
                            "moduleName": "open",
                            "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                        };
                        var result = external.callMessage(param);
                        if (result.error_no == 0) {
                            var isInstall = result.results[0].isInstall;
                            //是否安装(0：否，1：是）
                            if (isInstall == "1") {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                    //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                };
                                external.callMessage(param);
                            } else {
                                layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                    //进入appstore
                                    var param = {
                                        "funcNo": "50109",
                                        "moduleName": "open",
                                        "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                    };
                                    external.callMessage(param);
                                }, null, "下载", "取消");
                            }
                        } else {
                            layerUtils.iAlert("检测QQ失败");
                        }
                    } else {
                        var param = {
                            "funcNo": "50109",
                            "moduleName": "open",
                            //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                        };
                        external.callMessage(param);
                    }
                }
            } else {
                layerUtils.iAlert(error_info);
            }
        });
    }

    var signProtocol = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = signProtocol;
});