/**
 * 上传身份证照片
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),
    // 业务层接口，请求数据
        layerUtils = require("layerUtils"),
        gconfig = require("gconfig"),
        global = gconfig.global,
        utils = require("utils"),
        serverPath = global.serverPath,
        idCardModify = false,
    // 身份证是否被手工修改
        _pageId = "#account_uploadPhotoChange",
    // 填写资料的页面入参，属性由 imgState 方法赋值
        fillInformationInParam = {
            "idNo": "",
            // 身份证号
            "custname": "",
            // 客户姓名
            "ethnicname": "",
            // 民族
            "native": "",
            // 证件地址
            "policeorg": "",
            // 签发机关
            "borthday": "",
            // 出生日期
            "idBeginDate": "",
            // 证件开始日期
            "idEndDate": "",
            // 证件结束日期
            "gender": "",
            // 用户性别
            "imgPath": "",
            // 图片的显示地址
            "imgId": "",
            // 图片 id
            "branchno": "",
            // 营业部Id
            "commission": "",
            // 佣金套餐
            "zipCode": "" // 邮编
        };
    var checkSubmitFlg;
    /* 私有业务模块的全局变量 end */
    var account_info;
    var login_info;
    var external = require("external");

    function init() {

        account_info = JSON.parse(appUtils.getSStorageInfo("account_info"));
        login_info = JSON.parse(appUtils.getSStorageInfo("login_info"));

        if (!account_info) {
            service.queryAccountInfo(function (data) {
                var error_no = data.error_no;
                var error_info = data.error_info;
                var result = data.results;
                if (error_no == 0) {
                    account_info = data;
                    appUtils.setSStorageInfo("account_info", JSON.stringify(account_info));
                } else {
                    layerUtils.iAlert(error_info, -1);
                }
            }, {"user_id": login_info.user_id});
        }

        layerUtils.iLoading(false);
        checkSubmitFlg = false;

        var data = appUtils.getLStorageInfo("imgData");
        data = JSON.parse(data);
        if (data != undefined && (appUtils.getSStorageInfo("_prePageCode") == "account/vedioNotice")) {
            for (var i = 0; i < data.length; i++) {
                // 返回的是 json 串
                var base64Str = "data:image/jpg;base64," + data[i].media_content;
                if (data[i].img_type != "" || data[i].img_type != undefined || data[i].media_content != "" || data[i].media_content != undefined) {
                    var maxheight = $(_pageId + " .upload_box").height() + "px";
                    $(_pageId + " .upload_box").css("height", maxheight); // 设置回显照片区域高度不变
                    switch (parseInt(data[i].img_type)) {
                        // 大头像
                        case 2:
                            // 先将 li 置空
                            $(_pageId + " .headpic").text("");
                            // 显示照片
                            $(_pageId + " .headpic").append("<dd><img src=\"" + base64Str + "\"/></dd>"); // 显示照片
                            break;
                        // 正面照
                        case 4:
                            // 先将 li 置空
                            $(_pageId + " .positive").text("");
                            // 设置 uploaded 属性，标识图片是否是否已经上传
                            $(_pageId + " .positive").attr("uploaded", "true");
                            // 显示照片
                            $(_pageId + " .positive").append("<dd><img src=\"" + base64Str + "\"/></dd>"); // 显示照片
                            break;
                        // 反面照
                        case 5:
                            // 先将 li 置空
                            $(_pageId + " .negative").text("");
                            // 设置 uploaded 属性，标识图片是否已经上传
                            $(_pageId + " .negative").attr("uploaded", "true");
                            // 显示照片
                            $(_pageId + " .negative").append("<dd><img src=\"" + base64Str + "\"/></dd>"); // 显示照片
                            break;
                    }
                    // 设置图片展示大小
                    $(_pageId + " .upload_box img").css("max-height", maxheight);
                }

            }
        }
    }

    function bindPageEvent() {
        /* 点击页面隐藏按钮 */
        appUtils.bindEvent($(_pageId),
            function () {
                // 将按钮的自定义属性 last-media-id 设为 当前的 media-id
                $(_pageId + " .upload_btn li").attr("last-media-id", $(_pageId + " .upload_btn li:eq(0)").attr("media-id"));
                // 将按钮的自定义属性 media-id 设为 null
                $(_pageId + " .upload_btn li").attr("media-id", "null");
                // 隐藏照片上传按钮
                $(_pageId + " .upload_btn").slideUp("fast");
                $(_pageId + " .upload_box").removeClass("active");
            });

        /* 绑定返回 */
        appUtils.bindEvent($(_pageId + " .header .icon_back"), function () {
            appUtils.pageInit("account/uploadPhotoChange", "account/showAccount");
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            customerService();
        });

        /* 绑定上传正面身份证照 */
        appUtils.bindEvent($(_pageId + " .upload_main .positive"),
            function (e) {
                $(_pageId + " .upload_main .negative").removeClass("active");
                $(_pageId + " .upload_main .headpic").removeClass("active");
                var isActive = $(this).hasClass("active");
                switchCss($(_pageId + " .upload_main .positive"), isActive, 4);
                $(_pageId + " .upload_btn h5").html("<p>上传身份证正面</p><p>请使用手机背面摄像头横向拍照</p><p>请将手机放到身份证正上方拍照</p>");
                // 阻止冒泡
                e.stopPropagation();
            });

        /* 绑定上传反面身份证照 */
        appUtils.bindEvent($(_pageId + " .upload_main .negative"),
            function (e) {
                $(_pageId + " .upload_main .positive").removeClass("active");
                $(_pageId + " .upload_main .headpic").removeClass("active");
                var isActive = $(this).hasClass("active");
                switchCss($(_pageId + " .upload_main .negative"), isActive, 5);
                $(_pageId + " .upload_btn h5").html("<p>上传身份证反面</p><p>请使用手机背面摄像头横向拍照</p><p>请将手机放到身份证正上方拍照</p>");
                // 阻止冒泡
                e.stopPropagation();
            });

        /* 大头像 */
        appUtils.bindEvent($(_pageId + " .upload_main .headpic"),
            function (e) {
                $(_pageId + " .upload_main .positive").removeClass("active");
                $(_pageId + " .upload_main .negative").removeClass("active");
                var isActive = $(this).hasClass("active");
                switchCss($(_pageId + " .upload_main .headpic"), isActive, 3);
                $(_pageId + " .upload_btn h5").html("<p>上传大头像</p><p>请选择手机前面摄像头自拍</p>");
                // 阻止冒泡
                e.stopPropagation();
            });

        /* 点击相册 */
        appUtils.bindEvent($(_pageId + " .upload_btn li:eq(0)"),
            function (e) {
                // 相册上传的参数
                var phoneConfig = {
                    "funcNo": "60002",
                    "moduleName": "open",
                    "funcNum": $(this).attr("media-id") == "3" ? "501526" : "501525",
                    "uuid": "index",
                    "r": Math.random(),
                    "userId": login_info.user_id,
                    "photoType": $(this).attr("media-id") == "3" ? "人像正面" : "身份证",// 影像名称
                    "action": "phone", // 照片来源类别，phone 相册，pai 相机
                    "imgType": $(this).attr("media-id"),
                    "key": "index", // key 和 uuid 只需要写一个
                    "url": global.serverPath,
                    "needUpload": "",
                    "clientInfo": "clientInfo", //add by fengxiang 可不传 但是不传又报错 所以传了个字符串
                    "jsessionId": login_info.jsessionid
                };
                console.log(JSON.stringify(phoneConfig));
                if (checkSubmit()) {
                    external.callMessage(phoneConfig);
                }
                // 隐藏照片上传按钮
                $(_pageId + " .upload_btn").slideUp("fast");
                $(_pageId + " .upload_box").removeClass("active");
                // 将按钮的自定义属性 last-media-id 设为 当前的 media-id
                $(_pageId + " .upload_btn li").attr("last-media-id", $(_pageId + " .upload_btn li:eq(0)").attr("media-id"));
                // 将按钮的自定义属性 media-id 设为 null
                $(_pageId + " .upload_btn li").attr("media-id", "null");
                // 阻止冒泡
                e.stopPropagation();
            });

        /* 点击拍照 */
        appUtils.bindEvent($(_pageId + " .upload_btn li:eq(1)"),
            function (e) {
                // 相机上传的参数
                var paiConfig = {
                    "funcNo": "60002",
                    "moduleName": "open",
                    "funcNum": $(this).attr("media-id") == "3" ? "501526" : "501525",
                    "uuid": "index",
                    "r": Math.random(),
                    "userId": login_info.user_id,
                    "photoType": $(this).attr("media-id") == "3" ? "人像正面" : "身份证", // 影像名称
                    "action": "pai",   // 照片来源类别，phone 相册，pai 相机
                    "imgType": $(this).attr("media-id"),
                    "key": "index", // key 和 uuid 只需要写一个
                    "url": global.serverPath,
                    "needUpload": "",
                    "clientInfo": "clientInfo", //add by fengxiang 可不传 但是不传又报错 所以传了个字符串
                    "jsessionId": login_info.jsessionid
                };
                if (checkSubmit()) {
                    external.callMessage(paiConfig);
                }
                // 隐藏照片上传按钮
                $(_pageId + " .upload_btn").slideUp("fast");
                $(_pageId + " .upload_box").removeClass("active");
                // 将按钮的自定义属性 last-media-id 设为 当前的 media-id
                $(_pageId + " .upload_btn li").attr("last-media-id", $(_pageId + " .upload_btn li:eq(0)").attr("media-id"));
                // 将按钮的自定义属性 media-id 设为 null
                $(_pageId + " .upload_btn li").attr("media-id", "null");
                // 阻止冒泡
                e.stopPropagation();
            });

        /* 绑定同意签署协议 */
        appUtils.bindEvent($(_pageId + " .upload_main .icon_check"),
            function () {
                $(this).toggleClass("checked");
            });

        /* 绑定下一步 */
        appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"),
            function () {
                // 验证完成步骤
                // 隐藏照片按钮
                if ($(_pageId + " .positive img").length == 0) {
                    layerUtils.iMsg(-1, "请先上传身份证正面照！");
                    return false;
                }
                if ($(_pageId + " .negative img").length == 0) {
                    layerUtils.iMsg(-1, "请先上传身份证反面照！");
                    return false;
                }
                if ($(_pageId + " .headpic img").length == 0) {
                    layerUtils.iMsg(-1, "请先上传大头像！");
                    return false;
                }
//            var ischecked = $(_pageId + " .upload_main .icon_check").hasClass("checked");
                var ischecked = true;
                // 检查是否勾选签署协议
                if (ischecked) {
                    var param = {
                        "user_id": login_info.user_id,
                        "next_step": "witness_flag"
                    };
                    service.recordProcess(param, function (data) {
                        if (data.error_no == 0) {
                            if ((account_info.userInfo)[0].needVedioWitness_flag == "1") {
                                appUtils.pageInit("account/uploadPhotoChange", "account/vedioNotice");
                            } else {
                                appUtils.pageInit("account/uploadPhotoChange", "account/signProtocol");
                            }
                        } else {
                            layerUtils.iAlert(data.error_info);
                        }
                    });

                } else {
                    layerUtils.iMsg(-1, "请先签署协议！");
                }
            });
    }

    /**
     * added at 2015/07/01 解决重复提交问题
     */
    function checkSubmit() {
        if (checkSubmitFlg == true) {
            return false; //当表单被提交过一次后checkSubmitFlg将变为true,根据判断将无法进行提交。
        }
        checkSubmitFlg == true;
        return true;
    }

    function destroy() {
//       service.destroy();
    }

    /* 处理点击上传身份证正面、反面效果 */
    function switchCss(ele, isActive, media) {
        if (isActive) {
            $(_pageId + " .upload_btn").slideUp("fast");
            $(_pageId + " .upload_btn li").attr("media-id", "null");
        } else {
            $(_pageId + " .upload_btn").slideDown("fast");
            $(_pageId + " .upload_btn li").attr("media-id", media);
        }
        $(ele).toggleClass("active");
    }

    /**
     * 照片上传完成后，会自动调用 imgState 方法，但是该方法只能写在 m/index.html 或者暴露给 window ，否则无法调用 已在
     * init 中暴露给 window
     * imgState(mediaId, data)
     */
    function imgState(data) {
        var base64Str = (data.base64).replace(/[\n\r]*/g, "");
        /**
         * 只有当返回的数据不为空时，才设置 fillInformationInParam 的属性，确保取识别出来的并集
         */
        // 当上传是身份证时
        if ($(_pageId + " .upload_btn li:eq(0)").attr("last-media-id") == 4 || $(_pageId + " .upload_btn li:eq(0)").attr("last-media-id") == 5) {
            // 身份证号
            if (data.idNo.length != 0) {
                fillInformationInParam.idNo = data.idNo;
            }
            // 客户姓名
            if (data.custName.length != 0) {
                fillInformationInParam.custname = data.custName;
            }
            // 证件地址
            if (data.native.length != 0) {
                fillInformationInParam.native = data.native;
            }
            // 民族
            if (data.ethnicName.length != 0) {
                fillInformationInParam.ethnicname = data.ethnicName;
            }
            // 签发机关
            if (data.policeOrg.length != 0) {
                fillInformationInParam.policeorg = data.policeOrg;
            }
            // 出生日期
            if (data.birthday.length != 0) {
                fillInformationInParam.borthday = data.birthday;
            }
            // 证件开始日期
            if (data.idbeginDate.length != 0) {
                fillInformationInParam.idBeginDate = data.idbeginDate;
            }
            // 证件结束日期
            if (data.idendDate.length != 0) {
                fillInformationInParam.idEndDate = data.idendDate;
            }
            // 用户性别
            if (data.userSex.length != 0) {
                fillInformationInParam.gender = data.userSex;
            }
        }
        var maxheight = $(_pageId + " .upload_box").height() + "px";
        $(_pageId + " .upload_box").css("height", maxheight); // 设置回显照片区域高度不变
        switch (Number($(_pageId + " .upload_btn li:eq(0)").attr("last-media-id"))) {
            // 大头像
            case 3:
                // 先将 li 置空
                $(_pageId + " .headpic").text("");
                // 显示照片
                $(_pageId + " .headpic").html("<img>").children().attr("src", base64Str); // 显示照片
                break;
            // 正面照
            case 4:
                if (fillInformationInParam.idNo.length == 0) {
                    layerUtils.iAlert("身份证号码识别失败，需重新拍摄，请注意拍摄的角度和光线！", -1);
                    // 先将 li 置空
                    $(_pageId + " .positive").text("");
                    // 设置 uploaded 属性，标识图片是否已经上传
                    $(_pageId + " .positive").attr("uploaded", "false");
                    // 显示上传照片
                    $(_pageId + " .positive").append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
                    return;
                } else if (fillInformationInParam.gender.length == 0) {
                    layerUtils.iAlert("性别识别失败，需重新拍摄，请注意拍摄的角度和光线！", -1);
                    // 先将 li 置空
                    $(_pageId + " .positive").text("");
                    // 设置 uploaded 属性，标识图片是否已经上传
                    $(_pageId + " .positive").attr("uploaded", "false");
                    // 显示上传照片
                    $(_pageId + " .positive").append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
                    return;
                }
                // 先将 li 置空
                $(_pageId + " .positive").text("");
                // 设置 uploaded 属性，标识图片是否是否已经上传
                $(_pageId + " .positive").attr("uploaded", "true");
                // 显示照片
                // $(_pageId+" #positiveImg").attr("src",base64Str);
                $(_pageId + " .positive").html("<img>").children().attr("src", base64Str); // 显示照片
                break;
            // 反面照
            case 5:
                if (fillInformationInParam.idBeginDate.length == 0) {
                    layerUtils.iAlert("身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！", -1);
                    // 先将 li 置空
                    $(_pageId + " .negative").text("");
                    // 设置 uploaded 属性，标识图片是否是否已经上传
                    $(_pageId + " .negative").attr("uploaded", "false");
                    // 显示上传照片
                    $(_pageId + " .negative").append("<dd><p>点击上传身份证</p><h5>反 面</h5></dd>");
                    return;
                } else if (fillInformationInParam.idEndDate.length == 0) {
                    layerUtils.iAlert("身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！", -1);
                    // 先将 li 置空
                    $(_pageId + " .negative").text("");
                    // 设置 uploaded 属性，标识图片是否已经上传
                    $(_pageId + " .negative").attr("uploaded", "false");
                    // 显示上传照片
                    $(_pageId + " .negative").append("<dd><p>点击上传身份证</p><h5>反 面</h5></dd>");
                    return;
                }
                // 先将 li 置空
                $(_pageId + " .negative").text("");
                // 设置 uploaded 属性，标识图片是否已经上传
                $(_pageId + " .negative").attr("uploaded", "true");
                // 显示照片
                $(_pageId + " .negative").html("<img>").children().attr("src", base64Str); // 显示照片
                break;
        }
        // 设置图片展示大小
        $(_pageId + " .upload_box img").css("max-height", maxheight);
    }

    /* 获取数字证书协议 */
    function queryCertAgreement() {
        // category_englishname
        // 中登证书协议：certprotcl 自建证书协议：zjcertprotcl
        var getDigitalParam = {
            "category_englishname": "certprotcl"
        };
        service.queryProtocolList(getDigitalParam,
            function (data) {
                $(_pageId + " #icon_Check").html("已阅读并同意");
                var error_no = data.error_no,
                    error_info = data.error_info;
                if (error_no == 0 && data.results) {
                    // 《中登个人数字证书申请责任书》
                    if (data.results[0] != undefined) {
                        $(_pageId + " #icon_Check").append("<a href=\"javascript:void(0)\" id=\"protocol00\">《" + data.results[0].econtract_name + "》</a>");
                    }
                    // 《电子签名约定书》
                    if (data.results[1] != undefined) {
                        $(_pageId + " #icon_Check").append("<a href=\"javascript:void(0)\" id=\"protocol01\">《" + data.results[1].econtract_name + "》</a>");
                    }

                    // 预绑定查看协议的事件
                    appUtils.preBindEvent($(_pageId + " #icon_Check"), "#protocol00",
                        function (e) {
                            // 阻止冒泡
                            e.stopPropagation();
                            appUtils.pageInit("account/uploadPhotoChange", "account/showDigitalProtocol", {
                                "protocolId": data.results[0].econtract_no
                            });
                        });
                    // 预绑定查看协议的事件
                    appUtils.preBindEvent($(_pageId + " #icon_Check"), "#protocol01",
                        function (e) {
                            // 阻止冒泡
                            e.stopPropagation();
                            appUtils.pageInit("account/uploadPhotoChange", "account/showDigitalProtocol", {
                                "protocolId": data.results[1].econtract_no
                            });
                        });
                } else {
                    layerUtils.iAlert(data.error_info);
                }
            });
    }

    //连接客服
    function customerService() {
        var branchID = appUtils.getSStorageInfo("branchno");
        var brokersno = appUtils.getSStorageInfo("recommendno");
        if (branchID == undefined) {
            branchID = "";
        }
        if (brokersno == undefined) {
            brokersno = "";
        }
        //如有选择了营业部或经纪人则需要传
        var param1 = {
            "userid": appUtils.getSStorageInfo("user_id"),
            "branchno": branchID,
            "brokersno": brokersno
        }
        console.log("================================ param1=" + JSON.stringify(param1));
        /*  added at 2015/09/02
         *  入参： user_id （客户id）
         出参：调用成功有两种情况，
         1.如果属于中焯渠道 会返回 status=1
         2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
        service.serachIsCompanyCustomer(param1, function (data) {
            console.log("================================ data=" + JSON.stringify(data));

            var error_no = data.error_no,
                error_info = data.error_info;
            if (error_no == "0") {
                var status = data.results[0].status;
                if (status == "0") {
                    $(".ly_shadow").show();
                    var branchname = data.results[0].branchname;
                    var brokersname = data.results[0].brokersname;
                    var servicephone = data.results[0].servicephone;
                    var brokersphone = data.results[0].brokersphone;
                    var address = data.results[0].address;
                    var info = "";
                    //有经纪人的
                    if (!!brokersname) {
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听经纪人电话事件
                        appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    } else {//无经纪人的
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    }
                } else {
                    if (require("gconfig").platform != "1") {
                        //ios 获取软件是否安装
                        var param = {
                            "funcNo": "50200",
                            "moduleName": "open",
                            "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                        };
                        var result = external.callMessage(param);
                        if (result.error_no == 0) {
                            var isInstall = result.results[0].isInstall;
                            //是否安装(0：否，1：是）
                            if (isInstall == "1") {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                    //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                };
                                external.callMessage(param);
                            } else {
                                layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                    //进入appstore
                                    var param = {
                                        "funcNo": "50109",
                                        "moduleName": "open",
                                        "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                    };
                                    external.callMessage(param);
                                }, null, "下载", "取消");
                            }
                        } else {
                            layerUtils.iAlert("检测QQ失败");
                        }
                    } else {
                        var param = {
                            "funcNo": "50109",
                            "moduleName": "open",
                            //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                        };
                        external.callMessage(param);
                    }
                }
            } else {
                layerUtils.iAlert(error_info);
            }
        });
    }

    var uploadPhotoChange = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy,
        "imgState": imgState
    };

    /* 暴露对外的接口 */
    module.exports = uploadPhotoChange;
});