/**
 * 视频见证注意事项
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),
    // 业务层接口，请求数据
        utils = require("utils"),
        global = require("gconfig").global,
        layerUtils = require("layerUtils"),
        networkUrl = null,//视频IP
        _pageId = "#account_vedioNotice";
    /* 私有业务模块的全局变量 end */

    var login_info;
    var account_info;
    var external = require("external");

    function init() {

        account_info = JSON.parse(appUtils.getSStorageInfo("account_info"));
        login_info = JSON.parse(appUtils.getSStorageInfo("login_info"));

        if (!account_info) {
            service.queryAccountInfo(function (data) {
                var error_no = data.error_no;
                var error_info = data.error_info;
                var result = data.results;
                if (error_no == 0) {
                    account_info = data;
                    appUtils.setSStorageInfo("account_info", JSON.stringify(account_info));
                } else {
                    layerUtils.iAlert(error_info, -1);
                }
            }, {"user_id": login_info.user_id});
        }

        _pageId = "#account_vedioNotice";
        //   	networkUrl = global.vedioIp; //默认域名ip
        //   	layerUtils.iLoading(false);  //关闭等待层
        window.videoSuccess = videoSuccess; // 见证成功
        window.videoFail = videoFail;  // 见证中断
        //     window.videoReject = videoReject;  // 见证驳回
        // 获取营业部视频端口
        getVedioport();
//        queryQQOfflineState();
    }

    function bindPageEvent() {

        /* 绑定返回 */
        appUtils.bindEvent($(_pageId + " .header .icon_back"), function () {
//            appUtils.pageBack();
            if ((account_info.userInfo)[0].uploadIdcard_flag == "1") {
                if (appUtils.getSStorageInfo("_prePageCode") == "account/uploadPhotoChange") {
                    appUtils.pageBack();
                } else {
                    pageBack();
                }
            } else {
                appUtils.pageInit("account/vedioNotice", "account/showAccount");
            }
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            customerService();
        });

        /* 在线视频视频见证 */
        appUtils.bindEvent($(_pageId + " .ct_btn:eq(0)"),
            function () {
                if ($(_pageId + " .my_network .icon_radio").hasClass("checked")) {
                    //查询网络

                    //add by fengxiang 2015-08-25 升级
                    var param = {
                        "moduleName": "open",
                        "funcNo": "50030"
                    };
                    var result = external.callMessage(param);
                    var error_no = result.error_no;
                    if (error_no == "0") {
                        var data = result.results[0];
                        if (data.network == "1") {
                            appUtils.setSStorageInfo("netWorkStatus", "2G");
                        }
                        if (data.network == "2") {
                            appUtils.setSStorageInfo("netWorkStatus", "3G");
                        }
                        if (data.network == "3") {
                            appUtils.setSStorageInfo("netWorkStatus", "4G");
                        }
                        if (data.network == "4") {
                            appUtils.setSStorageInfo("netWorkStatus", "WIFI");
                        }
                        // 如果网络是2G，给出提示
                        if (data.network == "1" || data.network == "0") {
                            layerUtils.iAlert("你当前使用的网络网速较慢，请在3G,4G或者wifi等网路状态下进行视频见证", -1, function () {
                                //申请anychat视频见证
                                anychatVideoApply();
                            });
                        } else {
                            //申请anychat视频见证
                            anychatVideoApply();
                        }
                    } else {
                        layerUtils.iLoading(false);  // 关闭等待层。。。
                    }
                    //end by fengxiang 2015-08-25 升级


                } else {
                    layerUtils.iAlert("请选择网络！");
                }
            });

        /*绑定选择使用的网络*/
        appUtils.bindEvent($(_pageId + " .my_network .icon_radio"),
            function () {
                //$(this).attr("");

                if ($(this).html() == "联通网络") {

                    $(_pageId + " .my_network .icon_radio :eq(2)").addClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(0)").removeClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(1)").removeClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(3)").removeClass("checked");
                    var addrtype = 2;  //视频ip类型标识    1 :为电信   2:为联通  3 :为移动  4 :为我不知道
                    getVedioIp(addrtype);//获取视频IP
                }
                else if ($(this).html() == "我不知道") {

                    $(_pageId + " .my_network .icon_radio :eq(0)").addClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(2)").removeClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(1)").removeClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(3)").removeClass("checked");
                    var addrtype = 4;  //视频ip类型标识    1 :为电信   2:为联通  3 :为移动  4 :为我不知道
                    getVedioIp(addrtype);//获取视频IP
                }
                else if ($(this).html() == "电信网络") {

                    $(_pageId + " .my_network .icon_radio :eq(1)").addClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(2)").removeClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(0)").removeClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(3)").removeClass("checked");
                    var addrtype = 1;  //视频ip类型标识    1 :为电信   2:为联通  3 :为移动  4 :为我不知道
                    getVedioIp(addrtype);//获取视频IP
                }
                else if ($(this).html() == "移动网络") {

                    $(_pageId + " .my_network .icon_radio :eq(3)").addClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(2)").removeClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(0)").removeClass("checked");
                    $(_pageId + " .my_network .icon_radio :eq(1)").removeClass("checked");
                    var addrtype = 3;  //视频ip类型标识    1 :为电信   2:为联通  3 :为移动  4 :为我不知道
                    getVedioIp(addrtype);//获取视频IP
                }
                else {
                    $(this).removeClass("checked");
                }

            });

    }

    //调用anychat视频见证
    function anychatVideoApply() {

        //add by fengxiang 2015-08-25
        var param = {
            "funcNo": "60005",
            "moduleName": "open",
            "url": global.serverPath,
            "userId": login_info.user_id,
            "userName": login_info.custname,
            "orgId": login_info.branchno,
            "jsessionId": login_info.jsessionid,
            "netWorkStatus": appUtils.getSStorageInfo("netWorkStatus")  //网络状态
        };
        external.callMessage(param);
        //end by fengxiang 2015-08-25
    }

    function destroy() {
        service.destroy();
    }

    /* 获取营业部视频端口 */
    function getVedioport() {
        getVedioIp(4);
        if (appUtils.getSStorageInfo("_prePageCode") == "account/showAccount") {
            queryQQOfflineState();  // 查询视频通过状态
        } else {
            layerUtils.iLoading(false);  //关闭等待层
        }
    }

    /* 查询离线视频通过状态 */
    function queryQQOfflineState() {
        var lookVedioStateParam = {
            "user_id": login_info.user_id
        };
        service.queryQQOfflineState(lookVedioStateParam, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            if (error_no == 0 && data.results.length != 0) {
                // 视频通过状态，0：未见证、2：已预约离线见证未完成见证、1：视频见证完成、3：见证失败
                // 未见证不需要做处理
                var witnessFlag = data.results[0].witness_flag;
                var videoParam = appUtils.getSStorageInfo("videoParam");
                videoParam = eval("(" + videoParam + ")");

                if (witnessFlag == 1) {
                    if (appUtils.getSStorageInfo("backVedioNotice") != undefined || appUtils.getSStorageInfo("backVedioNotice") != null) {//视频驳回
                        if (appUtils.getSStorageInfo("backVedioNotice") == "6" || videoParam.need_video == 1) {
                            var param = {
                                "userid": login_info.user_id,
                                "fieldname": "video"
                            }
                            service.rejectStep(param, function (data) {
                                if (data.error_no == 0) {
                                    appUtils.clearSStorage("backVedioNotice");
                                    appUtils.pageInit("account/vedioNotice", "account/accountResult", {});
                                } else {
                                    layerUtils.iAlert(data.error_info);
                                }
                            });//驳回后修改资料

                        }
                    }
                    else if (appUtils.getSStorageInfo("isBackVedioNotice") != undefined || appUtils.getSStorageInfo("isBackVedioNotice") != null) {//照片、视频同时驳回
                        if (appUtils.getSStorageInfo("isBackVedioNotice") == "8") {
                            var param = {
                                "userid": login_info.user_id,
                                "fieldname": "video"
                            }
                            service.rejectStep(param, function (data) {
                                if (data.error_no == 0) {
                                    appUtils.clearSStorage("isBackVedioNotice");
                                    appUtils.pageInit("account/vedioNotice", "account/accountResult", {});
                                } else {
                                    layerUtils.iAlert(data.error_info);
                                }
                            });//驳回后修改资料

                        }
                    }
                    else {
                        /**
                         * added at 2015/07/01
                         */
                        /*setTimeout(function() {
                         appUtils.pageInit("account/vedioNotice", "account/signProtocol", {});
                         },
                         1000);*/

                        var param = {
                            "user_id": login_info.user_id,
                            "next_step": "certintall_flag"
                        };
                        service.recordProcess(param, function (data) {
                            if (data.error_no == 0) {
                                layerUtils.iAlert("您的视频审核已通过", 0, function () {
                                    //appUtils.pageInit("account/vedioNotice","account/digitalCertificate",{});
                                    //appUtils.pageInit("account/vedioNotice", "account/setPwdCertificate", {});
                                    appUtils.pageInit("account/vedioNotice", "account/signProtocol", {});
                                });
                            } else {
                                layerUtils.iAlert(data.error_info);
                            }
                        });
                    }

                }
                else if (witnessFlag == 2) {
                    layerUtils.iAlert("您的预约信息已经提交，我们的客服将尽快联系您！", 0);
                }
                else if (witnessFlag == 3) {
                    appUtils.setSStorageInfo("backVedioNotice", "6");
                    layerUtils.iAlert("视频见证失败，请重新申请见证！");
                }
                else if (witnessFlag == 4) {
                    layerUtils.iAlert("资料审核中，工作人员会尽快给您回复，请耐心等候！");
                }
            }
            else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(data.error_info);
            }
        }, false, true, 1000);
    }

    /* 见证通过 */
    function videoSuccess() {
        // 延迟50ms跳转
        // 跳转到安装证书界面
        /*        setTimeout(function() {
         appUtils.pageInit("account/vedioNotice", "account/setPwdCertificate", {});
         },
         50)*/
        queryQQOfflineState();  // 查询视频通过状态
    }

    /* 见证不通过 */
    function videoFail() {
    }

    /* 见证驳回 */
    function videoReject() {
    }

    //视屏回调
    function videoFlag(videoFlag) {
        var videoFlag = videoFlag.videoFlag;
        if (videoFlag == "0") {
            //见证通过
            videoSuccess();
        } else if (videoFlag == "1") {
            //见证失败
            videoFail();
        } else if (videoFlag == "2") {
            //见证驳回
            videoReject();
        }
    }

    /**
     * 获取视频ip
     */
    function getVedioIp(addrtype) {
        var param = {
            "user_id": login_info.user_id,
            "addrtype": addrtype,
            "branchno": login_info.branchno
        }
        //获取视频ip
        service.getVedioIp(param, function (data) {

            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;
            if (error_no == 0) {
                if (result[0].addressip) {
                    networkUrl = result[0].addressip;
                }
                else {
                    networkUrl = global.vedioIp;
                }

            }
            else {
                layerUtils.iAlert(error_info);
            }
        });
    }

    //连接客服
    function customerService() {
        var branchID = appUtils.getSStorageInfo("branchno");
        var brokersno = appUtils.getSStorageInfo("recommendno");
        if (branchID == undefined) {
            branchID = "";
        }
        if (brokersno == undefined) {
            brokersno = "";
        }
        //如有选择了营业部或经纪人则需要传
        var param1 = {
            "userid": appUtils.getSStorageInfo("user_id"),
            "branchno": branchID,
            "brokersno": brokersno
        }
        console.log("================================ param1=" + JSON.stringify(param1));
        /*  added at 2015/09/02
         *  入参： user_id （客户id）
         出参：调用成功有两种情况，
         1.如果属于中焯渠道 会返回 status=1
         2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
        service.serachIsCompanyCustomer(param1, function (data) {
            console.log("================================ data=" + JSON.stringify(data));

            var error_no = data.error_no,
                error_info = data.error_info;
            if (error_no == "0") {
                var status = data.results[0].status;
                if (status == "0") {
                    $(".ly_shadow").show();
                    var branchname = data.results[0].branchname;
                    var brokersname = data.results[0].brokersname;
                    var servicephone = data.results[0].servicephone;
                    var brokersphone = data.results[0].brokersphone;
                    var address = data.results[0].address;
                    var info = "";
                    //有经纪人的
                    if (!!brokersname) {
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听经纪人电话事件
                        appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    } else {//无经纪人的
                        info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                            + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                            + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        //监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        //监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); //打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    }
                } else {
                    if (require("gconfig").platform != "1") {
                        //ios 获取软件是否安装
                        var param = {
                            "funcNo": "50200",
                            "moduleName": "open",
                            "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                        };
                        var result = external.callMessage(param);
                        if (result.error_no == 0) {
                            var isInstall = result.results[0].isInstall;
                            //是否安装(0：否，1：是）
                            if (isInstall == "1") {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                    //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                };
                                external.callMessage(param);
                            } else {
                                layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                    //进入appstore
                                    var param = {
                                        "funcNo": "50109",
                                        "moduleName": "open",
                                        "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                    };
                                    external.callMessage(param);
                                }, null, "下载", "取消");
                            }
                        } else {
                            layerUtils.iAlert("检测QQ失败");
                        }
                    } else {
                        var param = {
                            "funcNo": "50109",
                            "moduleName": "open",
                            //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                        };
                        external.callMessage(param);
                    }
                }
            } else {
                layerUtils.iAlert(error_info);
            }
        });
    }


    /* 处理返回按钮 */
    function pageBack() {
        layerUtils.iLoading(false);
        var param = {
            "user_id": appUtils.getSStorageInfo("user_id")
        };
        // 查询身份证和大头像进行回显
        service.getPhoto(param, function (data) {
            if (data.error_no == 0) {
                appUtils.setLStorageInfo("imgData", JSON.stringify(data.results));//保存查询出来的上传影像数据
                appUtils.pageInit("account/vedioNotice", "account/uploadPhotoChange", {});
            } else {
                layerUtils.iAlert(data.error_info);
            }

        });
    }

    var vedioNotice = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy,
        "videoFlag": videoFlag
    };

    // 暴露对外的接口
    module.exports = vedioNotice;
});