/**
 * 风险测评
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"), service = require("serviceImp")
            .getInstance(), // 业务层接口，请求数据
        utils = require("utils"), global = require("gconfig").global, layerUtils = require("layerUtils"), _pageId = "#account_riskAssessment", Map = require("map");
    var checkSubmitFlg;
    /* 私有业务模块的全局变量 end */
    var sub_id = "";
    var login_info;
    var external = require("external");

    function init() {

        login_info = JSON.parse(appUtils.getSStorageInfo("login_info"));

        checkSubmitFlg = false;
        fristMap = new Map();
        getRiskAssessQuestions();
        /*
         * // 如果是从 短信验证码 或者 三方存管进入本页面，执行初始化操作，否则不执行初始化操作 if
         * (appUtils.getSStorageInfo("_prePageCode") == "account/msgVerify" ||
         * appUtils.getSStorageInfo("_prePageCode") ==
         * "account/thirdDepository") {
         *
         * getRiskAssessQuestions(); // 获取问卷答题 } else { //
         * 虽然必定是上面的流程，但为保证后续修改导致bug，这里手动关闭等待层 layerUtils.iLoading(false); }
         */
    }

    function bindPageEvent() {
        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            // 连接客服
            customerService();
        });
        /* 提交答题 */
        appUtils.preBindEvent($(document), _pageId + " .ct_btn", function () {
            var keys = fristMap.keys();
            if (checkSubmit()) {
                postRiskAssessmentData(keys);
            }
        });

        // 返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
        });
    }

    /**
     * added at 2015/07/01 解决重复提交问题
     */
    function checkSubmit() {
        if (checkSubmitFlg == true) {
            return false; // 当表单被提交过一次后checkSubmitFlg将变为true,根据判断将无法进行提交。
        }
        checkSubmitFlg == true;
        return true;
    }

    /**
     * 获取风险测评题库 接口号501539
     */
    function getRiskAssessQuestions() {
        var userid = appUtils.getSStorageInfo("user_id");
        var queryTestParam = {
            "user_id": login_info.user_id
        };
        // 查询风险评测
        service.queryRiskQuestion(function (data) {
            var errorNo = data.error_no;
            var errorInfo = data.error_info;

            if (errorNo == 0 && data.results.length != 0) // 调用成功,跳转到风险测评页面
            {
                var results = data.results;
                var questionHtml = "";
                $(_pageId + " .test_main").html("");
                sub_id = results[0].sub_id;
                for (var i = 0; i < results.length; i++)// 先遍历
                {
                    var oneEle = results[i];
                    var queid = oneEle.que_id; // que_id 题目编号
                    var type = oneEle.type; // type 问题类型（0：单选，1：多选）
                    var qname = oneEle.q_name; // q_name 题目描述
                    var str = type + "-" + queid + "-" + qname;
                    var secondMap = null;
                    if (!fristMap.containsKey(str))// 若map中没有对应的问题号，则存入问题号
                    {
                        secondMap = new Map();
                        secondMap.put(oneEle.ans_id, oneEle);
                        fristMap.put(str, secondMap); // fristMap每一个Key对应一个问题
                    } else {
                        fristMap.get(str).put(oneEle.ans_id, oneEle);
                    }
                }

                var keys = fristMap.keys();
                for (var j = 0; j < keys.length; j++) {
                    var oneData = fristMap.get(keys[j]);// 取出一个问题
                    questionHtml += createRiskAccessElement(oneData,
                        keys[j], j + 1);
                }
                $(_pageId + " .test_main").html(questionHtml);
                // 当题目过多，则设置下一步按钮悬浮底部
                if ($(document.body).height() < $(_pageId).height()) {

                    $(_pageId + " .fix_bot").css("position", "fixed");
                } else {
                    $(_pageId + " .fix_bot")
                        .css("position", "absolute");
                }
                // 为选择按钮添加事件
                appUtils.bindEvent($(_pageId
                        + " .test_main .icon_radio"),
                    function () {
                        var quetype = $(this).attr("que-type"); // 问题类型0：单选，1：多选
                        var queid = $(this).attr("id");
                        if (quetype == 1) {
                            $(this).toggleClass("checked");
                        } else {
                            if ($(this).hasClass("checked")) {
                                $(this).parent().parent()
                                    .prev("h5").css("color",
                                    "red"); // 未选择答案，则将该题标记为红色
                                $(this).removeClass("checked");
                            } else {
                                $(_pageId + " .test_main #" + queid)
                                    .removeClass("checked");
                                $(this).parent().parent()
                                    .prev("h5").css("color",
                                    "#666666"); // 题目红色标记恢复黑色
                                $(this).addClass("checked");
                            }
                        }
                    });

                // 设置默认的答案，默认是最低风险承受能力
                // setDefaultAnswer();
            } else {
                // layerUtils.iLoading(false);
                require("layerUtils").iMsg("-1", errorInfo);
            }
        }, queryTestParam);
    }

    /**
     * 创建一个问题项目
     *
     * @param oneData
     *            一个问题结果集
     * @param key
     *            结构type+"-"+queid+"-"+qname;
     */
    function createRiskAccessElement(oneData, key, index) {
        var type = key.split("-")[0];
        var queid = key.split("-")[1];
        var qname = key.split("-")[2];
        var oneDatakeys = oneData.keys();
        var itemHtml = "";
        var itemHead = "";
        var itemElem = "";
        var str = "(多选)";
        // 问题标号
        // 2014-08-01-21-49 var bgNum ="A";
        for (var i = 0; i < oneDatakeys.length; i++)// 先遍历确定有多少题
        {
            var oneElem = oneData.get(oneDatakeys[i]);
            var mark = oneElem.mark; // 答案分值
            var aname = oneElem.a_name; // 答案描述
            var ansid = oneElem.ans_id;
            if (type == 0)
                str = "(单选)";
            // 2014-08-01-21-49 bgNum = changQuestionBgNum(i);
            itemElem += "<p><a href=\"javascript:void(0);\" class=\"icon_radio\" que-type =\""
                + type
                + "\" ans-id=\""
                + ansid
                + "\" ans-mark=\""
                + mark
                + "\" id =\"" + queid + "\">" + aname + "</a></p>";
        }
        itemHead = "<h5>" + index + ". " + qname + str + "</h5>";
        itemHtml = "<div class=\"test_box\">" + itemHead
            + "<div class=\"input_list\" id=\"" + (index + "-" + queid)
            + "\">" + itemElem + "</div></div>";
        return itemHtml;
    }

    /**
     * 提交风险评测答案 接口号501540
     *
     * @param keys
     *            firstMap 的keys
     */
    function postRiskAssessmentData(keys) {
        var oneRiskAssessData = ""; // 格式如：1_2_7|2_7_3| 问题ID_答案ID_答案分值
        var countNoChoice = 0;// 没有选择问题数量
        var numNoChoice = ""; // 没有选择问题题号
        var array = new Map();
        for (var j = 0; j < keys.length; j++) {
            var index = j + 1;
            var queid = keys[j].split("-")[1];
            var isChoice = false;
            $(_pageId + " .test_main #" + queid).each(function () {
                if ($(this).hasClass("checked")) {
                    isChoice = true;
                    var ansid = $(this).attr("ans-id");
                    var mark = $(this).attr("ans-mark");
                    oneRiskAssessData += (queid + "_" + ansid + "_" + mark + "|");
                }
            });

            if (!isChoice) // 没有选中 则记录未提交的题目编号
            {
                countNoChoice++;
                numNoChoice += index + "、";
            }
        }

        if (countNoChoice > 0)// 您的答题尚未完成
        {
            numNoChoice = numNoChoice.substring(0, numNoChoice.length - 1); // 去掉最后一个逗号
            layerUtils.iAlert("您的答题尚未完成，未完成题目编号：" + numNoChoice);
            return false;
        }
        var userid = appUtils.getSStorageInfo("user_id");
        var submitTestParam = {
            "user_id": login_info.user_id,
            "sub_id": sub_id,
            "q_a_args": oneRiskAssessData
        };
        // 提交风险评测答案
        service.submitTestAnswer(submitTestParam, function (data) {
            var errorNo = data.error_no;
            var errorInfo = data.error_info;

            if (errorNo == 0 && data.results.length != 0) // 调用成功,跳转到风险测评页面
            {
                var remark = data.results[0].remark;
                var riskdesc = data.results[0].riskdesc;
                var param = {
                    "user_id": login_info.user_id,
                    "next_step": "visitsurvey_flag"
                };
                // 修改流程
                service.recordProcess(param, function (data) {
                    if (data.error_no == 0) {
                        // 修改用户流程完成标识1004028
                        service.modifyUserFinishFlag({
                            "user_id": login_info.user_id
                        }, function (data) {
                            var error_no = data.error_no;
                            var error_info = data.error_info;
                            if (error_no == 0) {
                                appUtils
                                    .pageInit(
                                    "account/riskAssessment",
                                    "account/riskAssessmentResult",
                                    {
                                        "remark": remark,
                                        "riskdesc": riskdesc
                                    });
                            } else {
                                layerUtils.iAlert(error_info,
                                    -1);
                            }
                        });
                    } else {
                        layerUtils.iAlert(data.error_info);
                    }
                });

            } else {
                layerUtils.iMsg("-1", errorInfo);
            }
        });
    }

    /* 改变问题答案 */
    function changQuestionBgNum(num) {
        var bgNum = "A";
        switch (num) {
            case 0 :
                bgNum = "A";
                break;
            case 1 :
                bgNum = "B";
                break;
            case 2 :
                bgNum = "C";
                break;
            case 3 :
                bgNum = "D";
                break;
            case 4 :
                bgNum = "E";
                break;
            case 5 :
                bgNum = "F";
                break;
            case 6 :
                bgNum = "G";
                break;
            default :
                bgNum = "其它";
        }
        return bgNum;
    }

    // 连接客服
    function customerService() {
        var branchID = appUtils.getSStorageInfo("branchno");
        var brokersno = appUtils.getSStorageInfo("recommendno");
        if (branchID == undefined) {
            branchID = "";
        }
        if (brokersno == undefined) {
            brokersno = "";
        }
        // 如有选择了营业部或经纪人则需要传
        var param1 = {
            "userid": appUtils.getSStorageInfo("user_id"),
            "branchno": branchID,
            "brokersno": brokersno
        }
        console.log("================================ param1="
            + JSON.stringify(param1));
        /*
         * added at 2015/09/02 入参： user_id （客户id） 出参：调用成功有两种情况， 1.如果属于中焯渠道 会返回
         * status=1 2. 如果不属于中焯渠道或者没有渠道 会返回
         * status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。
         */
        service.serachIsCompanyCustomer(param1, function (data) {
            console.log("================================ data="
                + JSON.stringify(data));

            var error_no = data.error_no, error_info = data.error_info;
            if (error_no == "0") {
                var status = data.results[0].status;
                if (status == "0") {
                    $(".ly_shadow").show();
                    var branchname = data.results[0].branchname;
                    var brokersname = data.results[0].brokersname;
                    var servicephone = data.results[0].servicephone;
                    var brokersphone = data.results[0].brokersphone;
                    var address = data.results[0].address;
                    var info = "";
                    // 有经纪人的
                    if (!!brokersname) {
                        info = "<p style='text-align:left;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;'>营业部名称："
                            + branchname
                            + "</p>"
                            + "<p style='text-align:left;'>营业部热线：<a style='color:orange' id='branchnoPhone'>"
                            + servicephone
                            + "</a></p>"
                            + "<p style='text-align:left;'>经纪人姓名："
                            + brokersname
                            + "</p>"
                            + "<p style='text-align:left;'>经纪人电话：<a style='color:orange' id='brokersphone'>"
                            + brokersphone
                            + "</a></p>"
                            + "<p style='text-align:left;'>营业部地址："
                            + address
                            + "</p>"
                            + "<p style='text-align:left;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        // 监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); // 打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        // 监听经纪人电话事件
                        appUtils.bindEvent(".btn_bot #brokersphone",
                            function (e) {
                                var tel = $(this).text();
                                utils.call(tel); // 打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                        // 监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone",
                            function (e) {
                                var tel = $(this).text();
                                utils.call(tel); // 打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    } else {// 无经纪人的
                        info = "<p style='text-align:left;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                        branchno_info = "<br><p style='text-align:left;'>营业部名称："
                            + branchname
                            + "</p>"
                            + "<p style='text-align:left;'>营业部热线：<a style='color:orange' id='branchnoPhone'>"
                            + servicephone
                            + "</a></p>"
                            + "<p style='text-align:left;'>营业部地址："
                            + address
                            + "</p>"
                            + "<p style='text-align:left;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                        info += branchno_info;
                        $(".btn_bot p").html(info);
                        // 监听营业部电话事件
                        appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                            var tel = $(this).text();
                            utils.call(tel); // 打电话
                            e.stopPropagation(); // 阻止冒泡
                        });
                        // 监听统一电话事件
                        appUtils.bindEvent(".btn_bot #publicPhone",
                            function (e) {
                                var tel = $(this).text();
                                utils.call(tel); // 打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                        appUtils.bindEvent(".btn_box", function (e) {
                            $(".ly_shadow").hide();
                            e.stopPropagation(); // 阻止冒泡
                        });
                    }
                } else {
                    if (require("gconfig").platform != "1") {
                        // ios 获取软件是否安装
                        var param = {
                            "funcNo": "50200",
                            "moduleName": "open",
                            "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                        };
                        var result = external.callMessage(param);
                        if (result.error_no == 0) {
                            var isInstall = result.results[0].isInstall;
                            // 是否安装(0：否，1：是）
                            if (isInstall == "1") {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web" // ios
                                    // qq地址
                                    // "url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                                    // //android qq地址
                                };
                                external.callMessage(param);
                            } else {
                                layerUtils.iConfirm(
                                    "检测到您的手机未安装QQ，请先下载并安装QQ客户端",
                                    function () {
                                        // 进入appstore
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "https://itunes.apple.com/cn/app/id444934666?mt=8" // qq的appstore地址
                                        };
                                        external.callMessage(param);
                                    }, null, "下载", "取消");
                            }
                        } else {
                            layerUtils.iAlert("检测QQ失败");
                        }
                    } else {
                        var param = {
                            "funcNo": "50109",
                            "moduleName": "open",
                            // "url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                        };
                        external.callMessage(param);
                    }
                }
            } else {
                layerUtils.iAlert(error_info);
            }
        });
    }

    function destroy() {
        // 隐藏返回按钮
        // $(_pageId+" .header .icon_back").hide();
        // $(_pageId+" .upload_main .icon_check").removeClass("checked");
        // $(_pageId+" .upload_main .upload_box").removeClass("active");
        // $(_pageId+" .upload_btn").hide();
        service.destroy();
    }

    var riskAssessment = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = riskAssessment;
});