﻿/**
 * 港股通开户
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        layerUtils = require("layerUtils"),
        gconfig = require("gconfig"),
        global = gconfig.global,
        platform = require("gconfig").platform,
        utils = require("utils"),
        shellPlugin = require("shellPlugin"),
        _pageId = "#business_index";
    /* 私有业务模块的全局变量 end */
    var external = require("external");

    function init() {
        window.getInput = utils.getInput;  // 暴露调用密码键盘给window
        window.onFinish = utils.onFinish;  // 暴露关闭密码键盘给window

        //add by fengxiang 2015-08-25
        // 启动时，检查当前客户端的版本号与服务器上最新的是否一致，根据需要更新客户端，只在启动时检查，started 为 true
        // 表示已启动，已启动就不检查
        if (appUtils.getSStorageInfo("started", true) != "true") {
            // 设置 session 中的 started 为 true ，表示已启动
            var param = {
                "moduleName": "open",
                "funcNo": "50030"
            };
            //判断是否有网络
            var result = external.callMessage(param);
            var error_no = result.error_no;
            var result = result.results[0];
            if (error_no == "0") { //查询网络成功
                if (result.network != "0") {	//判断是否有网络  0：断网，1：2G，2：3G，3：4G，4：WIFI，9：未定义
                    appUtils.setSStorageInfo("started", "true", true);
                    layerUtils.iLoading(true, "正在检查版本...");
                    setBestAddress(); // 设置最佳地址
                } else {
                    layerUtils.iAlert("请连接网络！");
                }
            } else {
                layerUtils.iAlert("查询网络失败,请稍后重试！");
            }
        }
        //end by fengxiang 2015-08-25

    }

    function bindPageEvent() {

        /* 绑定新开账户  */
        appUtils.bindEvent($(_pageId + " .home_btn"), function () {
            appUtils.pageInit("business/index", "account/login", {});
        });
    }

    function destroy() {
    }

    /* 自动测速，选择最佳地址 */
    function setBestAddress() {
        // 检测更新最新版本
        detectUpdate();
    }

    /* 检测更新最新版本 */
    function detectUpdate() {
        var queryParam = {
            "by_type": "1",
            "terminal_type": platform == "1" ? "android" : "ios"
        };
        service.getVersion(queryParam, function (data) {
            //alert("8888:"+JSON.stringify(data));
            if (data.error_no == 0) {
                layerUtils.iLoading(false);
                // 服务器有数据返回时
                if (data.results.length != 0 && data.results[0].update_url != undefined) {
                    if (platform == "1") {
                        execUpdateAndroid(data.results); // 执行安卓更新
                    } else {
                        execUpdateIOS(data.results); // 执行IOS更新
                    }

                }
            } else // 查询地址失败
            {
                layerUtils.iLoading(false);
                layerUtils.iAlert("版本检查失败，请稍后重试！");
            }
        }, true, false);
    }

    // 执行安卓更新操作
    function execUpdateAndroid(results) {
        var param = {
            "funcNo": "50010",
            "moduleName": "common",
            "source": "open"
        };
        //获取当前版本
        var data = external.callMessage(param);
        if (data.error_no == "0") {
            //如果当前版本不是最新的 则下载更新
            var version = results[0].version; // 最新版本
            var version_now = data.results[0].versionSn; // 当前版本
            if (version > version_now) {
                var updateParam = {
                    "url": results[0].update_url,  // 更新地址
                    "type": "1",
                    "version": results[0].version,  // 最新版本号
                    // 只有一条记录取 0
                    "versionSn": results[0].version,
                    "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
                    "funcNo": "50201",
                    "moduleName": "common",
                    "source": "open"
                };
                external.callMessage(updateParam);
            }
        }
    }

    // 执行IOS更新操作
    function execUpdateIOS(results) {
        var updateParam = {
            "url": results[0].update_url,  // 更新地址
            "type": "1",
            "version": results[0].version,  // 最新版本号
            // 只有一条记录取 0
            "versionSn": results[0].version,
            "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
            "funcNo": "50201",
            "moduleName": "open"
        };
        external.callMessage(updateParam);
    }


    var index = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = index;
});