/*
 * 综合性得分
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        global = require("gconfig").global,
        layerUtils = require("layerUtils"),
        survey_score = "",  //风险等级数字评分
        riskFlag = "",  //1表示满足风险评测等级，2表示不满足
        utils = require("utils"),
        rating_lvl_name = "",  //风险评测等级
        survey_score = "",
        knowledge_score = "",//知识测评分数
        integrity_score = "",
        _pageId = "#account_comprehensiveScore";
    var external = require("external");
    /* 私有业务模块的全局变量 end */

    function init() {
        _pageId = "#account_comprehensiveScore";
        appUtils.setSStorageInfo("control_step", "account/comprehensiveScore");
        //初始化处理
        initHandle();
    }

    function bindPageEvent() {
        //绑定返回按钮
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"),
            function () {
                var branchID = appUtils.getSStorageInfo("branchno");
                var brokersno = appUtils.getSStorageInfo("recommendno");
                if (branchID == undefined) {
                    branchID = "";
                }
                if (brokersno == undefined) {
                    brokersno = "";
                }
                //如有选择了营业部或经纪人则需要传
                var param1 = {
                    "userid": appUtils.getSStorageInfo("user_id"),
                    "branchno": branchID,
                    "brokersno": brokersno
                }
                console.log("================================ param1=" + JSON.stringify(param1));
                /*  added at 2015/09/02
                 *  入参： user_id （客户id）
                 出参：调用成功有两种情况，
                 1.如果属于中焯渠道 会返回 status=1
                 2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
                service.serachIsCompanyCustomer(param1, function (data) {
                    console.log("================================ data=" + JSON.stringify(data));

                    var error_no = data.error_no,
                        error_info = data.error_info;
                    if (error_no == "0") {
                        var status = data.results[0].status;
                        if (status == "0") {
                            $(".ly_shadow").show();
                            var branchname = data.results[0].branchname;
                            var brokersname = data.results[0].brokersname;
                            var servicephone = data.results[0].servicephone;
                            var brokersphone = data.results[0].brokersphone;
                            var address = data.results[0].address;
                            var info = "";
                            //有经纪人的
                            if (!!brokersname) {
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听经纪人电话事件
                                appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            } else {//无经纪人的
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            }
                        } else {
                            if (require("gconfig").platform != "1") {
                                //ios 获取软件是否安装
                                var param = {
                                    "funcNo": "50200",
                                    "moduleName": "open",
                                    "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                };
                                var result = external.callMessage(param);
                                if (result.error_no == 0) {
                                    var isInstall = result.results[0].isInstall;
                                    //是否安装(0：否，1：是）
                                    if (isInstall == "1") {
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                            //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                        };
                                        external.callMessage(param);
                                    } else {
                                        layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                            //进入appstore
                                            var param = {
                                                "funcNo": "50109",
                                                "moduleName": "open",
                                                "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                            };
                                            external.callMessage(param);
                                        }, null, "下载", "取消");
                                    }
                                } else {
                                    layerUtils.iAlert("检测QQ失败");
                                }
                            } else {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                    "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                                };
                                external.callMessage(param);
                            }
                        }
                    } else {
                        layerUtils.iAlert(error_info);
                    }
                });
            });

        appUtils.bindEvent($(_pageId + " .ce_btn"), function () {
            saveStep();
            appUtils.pageInit("account/comprehensiveScore", "account/mainPage", {});
        });

        appUtils.bindEvent($(_pageId + " #riskTest a"), function () {
            appUtils.setSStorageInfo("pre_steps", "account/comprehensiveScore");
            appUtils.pageInit("account/comprehensiveScore", "account/riskAssessment", {});
        });
        appUtils.bindEvent($(_pageId + " #knowledgeTest a"), function () {
            appUtils.setSStorageInfo("pre_steps", "account/comprehensiveScore");
            appUtils.pageInit("account/comprehensiveScore", "account/knowledge", {});
        });
        appUtils.bindEvent($(_pageId + " #integrityTest a"), function () {
            appUtils.setSStorageInfo("pre_steps", "account/comprehensiveScore");
            appUtils.pageInit("account/comprehensiveScore", "account/integrity", {});
        });
    }

    function destroy() {
        service.destroy();
    }

    //初始化处理
    function initHandle() {
        //survey_score = appUtils.getSStorageInfo("survey_score"); //风险评测分数
        //knowledge_score = appUtils.getSStorageInfo("knowledge_score");  //知识测评分数
        //integrity_score = appUtils.getSStorageInfo("integrity_score"); //诚信测评分数
        var user_id = appUtils.getSStorageInfo("user_id");
        var marketvalue = appUtils.getSStorageInfo("marketvalue");
        var param = {
            "user_id": user_id,
            "marketvalue": marketvalue
        };
        var total_mark = 0;
        service.queryForeUserPG(function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;
            if (error_no == 0 && data.results.length != 0) {
                //获取应用版本
                var molileAttribution = appUtils.getSStorageInfo("molileAttribution");
                var user_id = appUtils.getSStorageInfo("user_id");
                var param = {"user_id": user_id, "message": "calTotal", "molileAttribution": molileAttribution};
                //记录流程日志
                service.submitProcesslog(function (data) {
                    var errorNo = data.error_no;
                    var errorInfo = data.error_info;
                    if (errorNo == "0") {

                    } else {
                        layerUtils.iAlert(errorInfo, -1);
                    }
                }, param);
                total_mark = result[0].total_mark;
                $(_pageId + " .value_box h5").html(total_mark + "<small>分</small>");
                if (total_mark < 70) {
                    appUtils.setSStorageInfo("total_score_flag", "2");
                    $(_pageId + " #disable").show();
                    $(_pageId + " #active").hide();
                    $(_pageId + " .bot_tips").text("您的适当性综合得分＜70分，请重新测评");
                } else {
                    appUtils.setSStorageInfo("total_score_flag", "1");
                    $(_pageId + " #active").show();
                    $(_pageId + " #disable").hide();
                    $(_pageId + " .bot_tips").text("您的适当性综合得分已满足要求，请继续");
                }
                survey_score = result[0].risk;
                knowledge_score = result[0].knowledge;
                integrity_score = result[0].cred;
                if (survey_score == null || survey_score == "null") {
                    survey_score = 0;
                }
                if (knowledge_score == null) {
                    knowledge_score = 0;
                }
                if (integrity_score == null) {
                    integrity_score = 0;
                }
                $(_pageId + " #riskTest strong").html(survey_score + "分");
                $(_pageId + " #knowledgeTest strong").html(knowledge_score + "分");
                $(_pageId + " #integrityTest strong").html(integrity_score + "分");
            } else {
                layerUtils.iAlert(error_info, -1);
            }
        }, param);

    }

    /*保存步骤*/
    function saveStep() {
        var param = {
            user_id: appUtils.getSStorageInfo("user_id"),
            current_step: "survey_level"
        };
        service.saveUserTemp(function (data) {
            var errorNo = data.error_no;
            var errorInfo = data.error_info;
            if (errorNo == "0") {
                appUtils.setSStorageInfo("current_step", "survey_level");
            } else {
                layerUtils.iAlert(errorInfo, -1);
            }
        }, param);

    }

    /* 清理界面元素*/
    function cleanPageElement() {
        $(_pageId + " .retry").hide();
        $(_pageId + " .notice").show();
        $(_pageId + " #confirm").hide();
        $(_pageId + " #reTest").show();
    }

    var comprehensiveScore = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = comprehensiveScore;
});