/**
 * 知识测评
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        global = require("gconfig").global,
        gconfig = require("gconfig"),
        utils = require("utils"),
        serverPath = global.serverPath,
        layerUtils = require("layerUtils"),
        arrs = [],
        survey_type ,
        base64Str = "",
        steps = ["account", "survey", "knowledge_level",
            "integrity_level", "risk_level",
            "level", "survey_level", "open_confirm",
            "open_finish"
        ],
        _pageId = "#account_integrity";
    var ibind = "";
    var answerID = "";
    var photoFlag = "";
    var external = require("external");
    /* 私有业务模块的全局变量 end */

    function init() {
        getAnswerStrByDataBase();
        arrs = [],
            $(_pageId + " .test_list").html("");
        //第一个题目的ID
        ibind = "";
        base64Str = "";
        _pageId = "#account_integrity";
        photoFlag = "";
        //第一个答案的ID
        answerID = "";
        survey_type = global.integrity_survey_type;
        getKnowledgeQuestions();  // 获取问卷答题
    }

    //从数据库中取出答案字符串
    function getAnswerStrByDataBase() {
        var param = {
            "survey_type": "3",
            "user_id": appUtils.getSStorageInfo("user_id")
        };

        service.reviewTest(param, function (data) {
            var errorNo = data.error_no,
                errorInfo = data.error_info;
            if (errorNo == "0") {
                var results = data.results;
                var str = results[0].results;
                var ans_array = [];
                var str_arr = str.split(",");
                for (var i = 0; i < str_arr.length; i++) {
                    var ans = str_arr[i].replace("||", "");
                    var q_id = ans.split("|")[0];
                    var a_id = ans.split("|")[1];
                    ans_array.push({"q_id": q_id, "a_id": a_id});
                }
                appUtils.setSStorageInfo("ans_array", JSON.stringify(ans_array));
            } else {
                layerUtils.iAlert(errorInfo, -1);
            }
        });
    }

    //获得照片的数量
    function getPicNum() {
        var count = 0;
        var param = {
            "user_id": appUtils.getSStorageInfo("user_id"),
            "question_id": appUtils.getSStorageInfo("question_id"),
            "answer_id": appUtils.getSStorageInfo("answer_id"),
            "operate_type": "4"
        };
        service.uploadPhotos(param, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            var results = data.results;
            if (error_no == "0") {
                var image_count = results[0].image_count;
                count = image_count;
                if (count == 0 || count == null || count == undefined) {
                    layerUtils.iMsg(-1, "请先上传诚信照片！");
                } else {
                    postRiskAssessmentData();  // 提交答题
                }
            } else {
                layerUtils.iAlert(error_info, -1);
            }
        });
    }

    function bindPageEvent() {
        /* 提交答题  */
        appUtils.preBindEvent($(document), _pageId + " .ce_btn", function () {
            //判断是否是选择了第一个选项
            if ($(_pageId + " .test_list dd p:eq(0) a").hasClass("active")) {
                //获得照片数量，判断是否上传了照片
                getPicNum();
            } else {
                postRiskAssessmentData();  // 提交答题
            }

        });
        //预绑定事件
        $(_pageId + " .test_list a").live("click", function (e) {
            var quetype = $(this).attr("type");	 // 问题类型0：单选，1：多选
            var queid = $(this).attr("id");
            if (quetype == 1) {
                $(this).toggleClass("active");
            }
            else {
                if ($(this).hasClass("active")) {
                    $(this).parent().parent().parent().find("dt").css("color", "red");  // 未选择答案，则将该题标记为红色
                    $(this).removeClass("active");
                }
                else {
                    $(_pageId + " .test_list #" + queid).removeClass("active");
                    $(this).parent().parent().parent().find("dt").css("color", "#666666");	// 题目红色标记恢复黑色
                    $(this).addClass("active");
                }
            }
        });

        //绑定返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            arrs = [],
                appUtils.pageBack();
        });
        //预绑定事件
        $(_pageId + " #showPic").live("click", function (e) {
            appUtils.setSStorageInfo("question_id", ibind),
                appUtils.setSStorageInfo("answer_id", answerID),
                appUtils.pageInit("account/integrity", "account/integrityCertify");
            e.stopPropagation();  // 阻止冒泡
        });
        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            var branchID = appUtils.getSStorageInfo("branchno");
            var brokersno = appUtils.getSStorageInfo("recommendno");
            if (branchID == undefined) {
                branchID = "";
            }
            if (brokersno == undefined) {
                brokersno = "";
            }
            //如有选择了营业部或经纪人则需要传
            var param1 = {
                "userid": appUtils.getSStorageInfo("user_id"),
                "branchno": branchID,
                "brokersno": brokersno
            }
            console.log("================================ param1=" + JSON.stringify(param1));
            /*  added at 2015/09/02
             *  入参： user_id （客户id）
             出参：调用成功有两种情况，
             1.如果属于中焯渠道 会返回 status=1
             2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
            service.serachIsCompanyCustomer(param1, function (data) {
                console.log("================================ data=" + JSON.stringify(data));

                var error_no = data.error_no,
                    error_info = data.error_info;
                if (error_no == "0") {
                    var status = data.results[0].status;
                    if (status == "0") {
                        $(".ly_shadow").show();
                        var branchname = data.results[0].branchname;
                        var brokersname = data.results[0].brokersname;
                        var servicephone = data.results[0].servicephone;
                        var brokersphone = data.results[0].brokersphone;
                        var address = data.results[0].address;
                        var info = "";
                        //有经纪人的
                        if (!!brokersname) {
                            info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                            branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                            info += branchno_info;
                            $(".btn_bot p").html(info);
                            //监听营业部电话事件
                            appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            //监听经纪人电话事件
                            appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            //监听统一电话事件
                            appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            appUtils.bindEvent(".btn_box", function (e) {
                                $(".ly_shadow").hide();
                                e.stopPropagation(); // 阻止冒泡
                            });
                        } else {//无经纪人的
                            info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                            branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                            info += branchno_info;
                            $(".btn_bot p").html(info);
                            //监听营业部电话事件
                            appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            //监听统一电话事件
                            appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            appUtils.bindEvent(".btn_box", function (e) {
                                $(".ly_shadow").hide();
                                e.stopPropagation(); // 阻止冒泡
                            });
                        }
                    } else {
                        if (require("gconfig").platform != "1") {
                            //ios 获取软件是否安装
                            var param = {
                                "funcNo": "50200",
                                "moduleName": "open",
                                "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            };
                            var result = external.callMessage(param);
                            if (result.error_no == 0) {
                                var isInstall = result.results[0].isInstall;
                                //是否安装(0：否，1：是）
                                if (isInstall == "1") {
                                    var param = {
                                        "funcNo": "50109",
                                        "moduleName": "open",
                                        "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                        //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                    };
                                    external.callMessage(param);
                                } else {
                                    layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                        //进入appstore
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                        };
                                        external.callMessage(param);
                                    }, null, "下载", "取消");
                                }
                            } else {
                                layerUtils.iAlert("检测QQ失败");
                            }
                        } else {
                            var param = {
                                "funcNo": "50109",
                                "moduleName": "open",
                                //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                            };
                            external.callMessage(param);
                        }
                    }
                } else {
                    layerUtils.iAlert(error_info);
                }
            });
        });
    }

    function destroy() {
        service.destroy();
    }


    /* 获取诚信测评题库 */
    function getKnowledgeQuestions() {
        // 查询诚信评测

        var queryTestParam = {"survey_type": survey_type};
        service.queryRiskToc(queryTestParam, function (data) {
            var errorNo = data.error_no,
                errorInfo = data.error_info;
            var ansArr = appUtils.getSStorageInfo("ans_array");
            var JsonArr = JSON.parse(ansArr);
            if (errorNo == "0" && data.dsName)   //调用成功
            {
                $(data.questionList).each(function (i, ele) {
                    //遍列题目名称
                    var id = ele.question_id;
                    obj = {};
                    obj["qId"] = id;
                    arrs.push(obj); //题目id数组
                    if (i == 0) {
                        ibind = id;
                        appUtils.setSStorageInfo("question_id", ibind);
                    }
                    var name = ele.question_name;
                    var type = ele.type;
                    var htmltext = "<dl><dt>" + (i + 1) + "、" + name + "</dt><dd>";
                    //遍列答案
                    if (type == "0") {
                        $(data.answerList).each(function (idx, e) {
                            if ((idx == 0) && (e.question_id == id)) {
                                if (JsonArr.length >= 1) {
                                    if (JsonArr[i].a_id == e.answer_id) {
                                        var answerStr = e.answer_name;
                                        var answer = "";
                                        var info = "";
                                        if (answerStr != null) {
                                            var start = answerStr.indexOf("("),
                                                end = answerStr.lastIndexOf(")");
                                            answer = answerStr.substring(0, start);
                                            info = answerStr.substring(start, end + 1);
                                        }
                                        htmltext += "<p class='spel'><a href='javascript:void(0);' class='active' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='0'>" + answer + "<br><strong>" + info + "<br></strong><span id='showPic' style='color:#00acee;font-size:18px'>(查看诚信证明图片)</span>" + "</a></p>";
                                        //第一个答案的ID
                                        answerID = e.answer_id;
                                        appUtils.setSStorageInfo("answer_id", answerID);
                                    } else {
                                        var answerStr = e.answer_name;
                                        var answer = "";
                                        var info = "";
                                        if (answerStr != null) {
                                            var start = answerStr.indexOf("("),
                                                end = answerStr.lastIndexOf(")");
                                            answer = answerStr.substring(0, start);
                                            info = answerStr.substring(start, end + 1);
                                        }
                                        htmltext += "<p class='spel'><a href='javascript:void(0);' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='0'>" + answer + "<br><strong>" + info + "<br></strong><span id='showPic' style='color:#00acee;font-size:18px'>(查看诚信证明图片)</span>" + "</a></p>";
                                        //第一个答案的ID
                                        answerID = e.answer_id;
                                        appUtils.setSStorageInfo("answer_id", answerID);

                                    }
                                } else {
                                    var answerStr = e.answer_name;
                                    var answer = "";
                                    var info = "";
                                    if (answerStr != null) {
                                        var start = answerStr.indexOf("("),
                                            end = answerStr.lastIndexOf(")");
                                        answer = answerStr.substring(0, start);
                                        info = answerStr.substring(start, end + 1);
                                    }
                                    htmltext += "<p class='spel'><a href='javascript:void(0);' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='0'>" + answer + "<br><strong>" + info + "<br></strong><span id='showPic' style='color:#00acee;font-size:18px'>(查看诚信证明图片)</span>" + "</a></p>";
                                    //第一个答案的ID
                                    answerID = e.answer_id;
                                    appUtils.setSStorageInfo("answer_id", answerID);
                                }

                            } else if (e.question_id == id) {
                                if (JsonArr.length >= 1) {
                                    if (JsonArr[i].a_id == e.answer_id) {
                                        htmltext += "<p><a href='javascript:void(0);' class='active' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='0'>" + e.answer_name + "</a></p>";
                                    } else {
                                        htmltext += "<p><a href='javascript:void(0);' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='0'>" + e.answer_name + "</a></p>";
                                    }
                                } else {
                                    htmltext += "<p><a href='javascript:void(0);' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='0'>" + e.answer_name + "</a></p>";
                                }
                            }
                        });
                    } else {
                        $(data.answerList).each(function (idx, e) {
                            if (e.question_id == id) {
                                htmltext += "<p><a href='javascript:void(0);' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='1'>" + e.answer_name + "</a></p>";
                            }
                        });
                    }

                    htmltext += "</dd></dl>";
                    $(_pageId + " .test_list").append(htmltext);
                    /*appUtils.preBindEvent($(_pageId+" .test_list"),$(_pageId+" #showPic"),function(e){
                     alert("kkka");
                     e.stopPropagation();  // 阻止冒泡
                     });*/
                    $(_pageId + " .ce_btn").css("display", "block");
                });
                //appUtils.bindEvent($(_pageId+" .test_list dd p:eq(0)"),function(e){

                // 为选择按钮添加事件
                //appUtils.bindEvent($(_pageId+" .test_list a"),function(e){


                /*$(_pageId+" .test_list dd p:eq(0)").live("click",function(e){
                 appUtils.setSStorageInfo("question_id",ibind),
                 appUtils.setSStorageInfo("answer_id",answerID),
                 appUtils.setSStorageInfo("operate_type","3");
                 appUtils.pageInit("account/integrity","account/integrityCertify");
                 $(_pageId+" .upload_btn").show();
                 if(!$(_pageId+" .test_list dd p:eq(0) a").hasClass("active")){
                 $(_pageId+" .upload_btn").hide();
                 }
                 e.stopPropagation();  // 阻止冒泡
                 });*/
            }
            else {
                layerUtils.iAlert(errorInfo, -1);
            }
        }, true, true, handleTimeout);
    }

    /* 处理请求超时 */
    function handleTimeout() {
        layerUtils.iConfirm("请求超时，是否重新加载？", function () {
            getKnowledgeQuestions();  // 再次诚信测评题目
        });
    }

    /* 提交诚信评测答案 */
    function postRiskAssessmentData() {
        var len = $(_pageId + " .test_list dl").length;
        var str = "";   //题目，答案拼接的字符串
        var strs = "";
        $(arrs).each(function (i, e) {
            var val = "";
            var types = $(_pageId + " a[name='" + e.qId + "']").attr("type");
            if (types == "1") {
                $(_pageId + " a[name='" + e.qId + "']").each(function () {
                    if ($(this).hasClass("active")) {
                        val += $(this).attr("value") + "-";
                    }
                });
                if (val.indexOf("-") != -1) {
                    val = val.substr(0, val.length - 1);
                }
            } else {
                val = $(_pageId + " .test_list a[name='" + e.qId + "'].active").attr("value");
            }
            if (val == undefined || val == "") {
                strs += $(_pageId + " a[name='" + e.qId + "']").attr("id") + "、";
            } else if ((i == 0) && (answerID == val)) {
                str += e.qId + "|" + val + "||,";
            } else {
                //str+=e.qId+"|"+val+"|"+base64Str+"||";
                str += e.qId + "|" + val + "||,";
            }
        });
        str = str.substr(0, str.length - 1);
        if ((str == "")) {
            layerUtils.iMsg(-1, "请先选择后提交！");
        } else {
            var submitTestParam = {
                "user_id": appUtils.getSStorageInfo("user_id"),
                "survey_type": survey_type,
                "answer_str": str
            };
            var ans_array = [];
            var str_arr = str.split(",");
            for (var i = 0; i < str_arr.length; i++) {
                var ans = str_arr[i].replace("||", "");
                var q_id = ans.split("|")[0];
                var a_id = ans.split("|")[1];
                ans_array.push({"q_id": q_id, "a_id": a_id});
            }
            appUtils.setSStorageInfo("ans_array", JSON.stringify(ans_array));
            //提交诚信评测答案
            service.submitTestAnswer(submitTestParam, function (data) {
                var errorNo = data.error_no;
                var errorInfo = data.error_info;
                if (errorNo == 0 && data.results.length != 0)	//调用成功,跳转到诚信测评页面
                {
                    //获取应用版本
                    var molileAttribution = appUtils.getSStorageInfo("molileAttribution");
                    var user_id = appUtils.getSStorageInfo("user_id");
                    var param = {"user_id": user_id, "message": "creditTest", "molileAttribution": molileAttribution};
                    //记录流程日志
                    service.submitProcesslog(function (data) {
                        var errorNo = data.error_no;
                        var errorInfo = data.error_info;
                        if (errorNo == "0") {

                        } else {
                            layerUtils.iAlert(errorInfo, -1);
                        }
                    }, param);
                    //保存步骤并跳转
                    /*修改了的代码*/
                    saveStep(data);
                }
                else {
                    appUtils.setSStorageInfo("integrityFlag", "2");
                    layerUtils.iAlert(errorInfo, -1);
                }
            });
        }
    }

    /*修改了的代码*/
    /*保存步骤*/
    function saveStep(_data) {
        var param = {
            user_id: appUtils.getSStorageInfo("user_id"),
            current_step: "integrity_level"
        };
        var c_step = appUtils.getSStorageInfo("current_step");
        //数据库保存步骤下标
        var index = steps.indexOf(c_step);
        //本步骤下标
        var this_index = steps.indexOf("integrity_level");
        if (index < this_index) {
            service.saveUserTemp(function (data) {
                var errorNo = data.error_no;
                var errorInfo = data.error_info;
                if (errorNo == "0") {
                    //保存当前步骤到session
                    appUtils.setSStorageInfo("current_step", "integrity_level");
                    var remark = _data.results[0].total_score,   //诚信等级评分
                        riskdesc = _data.results[0].define,  //诚信评测文字等级
                        define_value = _data.results[0].define_value;  //诚信评测字母等级
                    appUtils.setSStorageInfo("integrityFlag", "1");
                    appUtils.setSStorageInfo("credit_score", remark);
                    /*修改了的代码mainPage*/
                    var back_step = appUtils.getSStorageInfo("back_step"); //港股通开通标志
                    if (back_step == "2") {
                        appUtils.pageInit("account/integrity", "account/result");
                    } else {
                        var preStep = appUtils.getSStorageInfo("pre_steps");
                        if (preStep != "account/comprehensiveScore") {
                            appUtils.pageInit("account/integrity", "account/mainPage", {"remark": remark, "riskdesc": riskdesc, "define_value": define_value});
                        } else {
                            appUtils.pageInit("account/integrity", "account/comprehensiveScore", {"remark": remark, "riskdesc": riskdesc, "define_value": define_value});
                        }
                    }
                } else {
                    layerUtils.iAlert(errorInfo, -1);
                }
            }, param);
        } else {
            var remark = _data.results[0].total_score,   //诚信等级评分
                riskdesc = _data.results[0].define,  //诚信评测文字等级
                define_value = _data.results[0].define_value;  //诚信评测字母等级
            appUtils.setSStorageInfo("integrityFlag", "1");
            appUtils.setSStorageInfo("credit_score", remark);
            var back_step = appUtils.getSStorageInfo("back_step"); //港股通开通标志
            if (back_step == "2") {
                appUtils.pageInit("account/integrity", "account/result");
            } else {
                var preStep = appUtils.getSStorageInfo("pre_steps");
                if (preStep != "account/comprehensiveScore") {
                    appUtils.pageInit("account/integrity", "account/mainPage", {"remark": remark, "riskdesc": riskdesc, "define_value": define_value});
                } else {
                    appUtils.pageInit("account/integrity", "account/comprehensiveScore", {"remark": remark, "riskdesc": riskdesc, "define_value": define_value});
                }
            }
        }
    }

    var integrity = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = integrity;
});