/**
 * 诚信测评
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        global = require("gconfig").global,
        utils = require("utils"),
        layerUtils = require("layerUtils"),
        arrs = [],
        _pageId = "#account_knowledge";
    var external = require("external");
    /* 私有业务模块的全局变量 end */

    function init() {
        //从数据库中拿到答案
        getAnswerStrByDataBase();
        arrs = [],
            $(_pageId + " .test_list").html("");
        _pageId = "#account_knowledge";
        getKnowledgeQuestions();  // 获取问卷答题
    }

    function bindPageEvent() {
        /* 提交答题  */
        appUtils.bindEvent(_pageId + " .ce_btn", function () {
            postRiskAssessmentData();  // 提交答题
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"),
            function () {
                var branchID = appUtils.getSStorageInfo("branchno");
                var brokersno = appUtils.getSStorageInfo("recommendno");
                if (branchID == undefined) {
                    branchID = "";
                }
                if (brokersno == undefined) {
                    brokersno = "";
                }
                //如有选择了营业部或经纪人则需要传
                var param1 = {
                    "userid": appUtils.getSStorageInfo("user_id"),
                    "branchno": branchID,
                    "brokersno": brokersno
                }
                console.log("================================ param1=" + JSON.stringify(param1));
                /*  added at 2015/09/02
                 *  入参： user_id （客户id）
                 出参：调用成功有两种情况，
                 1.如果属于中焯渠道 会返回 status=1
                 2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
                service.serachIsCompanyCustomer(param1, function (data) {
                    console.log("================================ data=" + JSON.stringify(data));

                    var error_no = data.error_no,
                        error_info = data.error_info;
                    if (error_no == "0") {
                        var status = data.results[0].status;
                        if (status == "0") {
                            $(".ly_shadow").show();
                            var branchname = data.results[0].branchname;
                            var brokersname = data.results[0].brokersname;
                            var servicephone = data.results[0].servicephone;
                            var brokersphone = data.results[0].brokersphone;
                            var address = data.results[0].address;
                            var info = "";
                            //有经纪人的
                            if (!!brokersname) {
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听经纪人电话事件
                                appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            } else {//无经纪人的
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            }
                        } else {
                            if (require("gconfig").platform != "1") {
                                //ios 获取软件是否安装
                                var param = {
                                    "funcNo": "50200",
                                    "moduleName": "open",
                                    "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                };
                                var result = external.callMessage(param);
                                if (result.error_no == 0) {
                                    var isInstall = result.results[0].isInstall;
                                    //是否安装(0：否，1：是）
                                    if (isInstall == "1") {
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                            //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                        };
                                        external.callMessage(param);
                                    } else {
                                        layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                            //进入appstore
                                            var param = {
                                                "funcNo": "50109",
                                                "moduleName": "open",
                                                "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                            };
                                            external.callMessage(param);
                                        }, null, "下载", "取消");
                                    }
                                } else {
                                    layerUtils.iAlert("检测QQ失败");
                                }
                            } else {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                    "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                                };
                                external.callMessage(param);
                            }
                        }
                    } else {
                        layerUtils.iAlert(error_info);
                    }
                });
            });
        //绑定返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            arrs = [],
                appUtils.pageBack();
        });
    }

    function destroy() {
        service.destroy();
    }

    //从数据库中取出答案字符串
    function getAnswerStrByDataBase() {
        var param = {
            "survey_type": "2",
            "user_id": appUtils.getSStorageInfo("user_id")
        };

        service.reviewTest(param, function (data) {
            var errorNo = data.error_no,
                errorInfo = data.error_info;
            if (errorNo == "0") {
                var results = data.results;
                var str = results[0].results;
                var ans_array = [];
                var str_arr = str.split(",");
                for (var i = 0; i < str_arr.length; i++) {
                    var ans = str_arr[i].replace("||", "");
                    var q_id = ans.split("|")[0];
                    var a_id = ans.split("|")[1];
                    ans_array.push({"q_id": q_id, "a_id": a_id});
                }
                appUtils.setSStorageInfo("ans_array", JSON.stringify(ans_array));
            } else {
                layerUtils.iAlert(errorInfo, -1);
            }
        });
    }

    /* 获取风险测评题库 */
    function getKnowledgeQuestions() {
        // 查询风险评测
        var survey_type = "3",
            queryTestParam = {"survey_type": survey_type};
        service.queryRiskToc(queryTestParam, function (data) {
            console.log(JSON.stringify(data));
            var errorNo = data.error_no,
                errorInfo = data.error_info;
            if (errorNo == "0" && data.dsName)   //调用成功
            {
                var edu = "<div class='gray_title'><h4>测评前您可浏览相关<a id='edu' href='javascript:void(0);'>业务知识</a></h4></div>"
                $(_pageId + " .test_list").append(edu);
                var ansArr = appUtils.getSStorageInfo("ans_array");
                var JsonArr = JSON.parse(ansArr);
                $(data.questionList).each(function (i, ele) {
                    //本题答案是否正确的标记
                    var isRightFlag = "yes";
                    //遍列题目名称
                    var id = ele.question_id,
                        ibind,
                        obj = {};
                    obj["qId"] = id;
                    arrs.push(obj); //题目id数组
                    if (i == 0) {
                        ibind = id;
                    }
                    var name = ele.question_name;
                    var type = ele.type;
                    var description = ele.description;
                    var htmltext = "<dl><dt>" + (i + 1) + "、" + name + "<a class='sb_icon' href='javascript:void(0);'></a></dt><dd>";
                    //遍列答案
                    if (type == "0") {
                        $(data.answerList).each(function (idx, e) {
                            if (e.question_id == id) {
                                if (JsonArr.length > 1) {
                                    if (JsonArr[i].a_id == e.answer_id) {
                                        //如果选择了的答案分值为零则更新标志
                                        if (e.mark == "0") {
                                            isRightFlag = "no";
                                        }
                                        htmltext += "<p><a href='javascript:void(0);' class='active' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='0'>" + e.answer_name + "</a></p>";
                                    } else {
                                        htmltext += "<p><a href='javascript:void(0);' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='0'>" + e.answer_name + "</a></p>";
                                    }
                                } else {
                                    htmltext += "<p><a href='javascript:void(0);' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='0'>" + e.answer_name + "</a></p>";
                                }
                            }
                        });
                    } else {
                        $(data.answerList).each(function (idx, e) {
                            if (e.question_id == id) {
                                htmltext += "<p><a href='javascript:void(0);' name='" + id + "' id='" + (i + 1) + "' value='" + e.answer_id + "' type='1'>" + e.answer_name + "</a></p>";
                            }
                        });
                    }
                    //通过判断这题目是否正确来选择是否显示提示
                    if (isRightFlag == "yes") {
                        htmltext += "<div class='test_tips' style='display:none;'><strong>知识点提示</strong><div>" + description + "</div></div></dd></dl>";
                        $(_pageId + " .test_list").append(htmltext);
                    } else {
                        htmltext += "<div class='test_tips' style='display:block;'><strong>知识点提示</strong><div>" + description + "</div></div></dd></dl>";
                        $(_pageId + " .test_list").append(htmltext);
                    }
                    $(_pageId + " .ce_btn").css("display", "block");
                });

                //查看知识提示信息
                appUtils.bindEvent($(_pageId + " .sb_icon"), function (e) {
                    $(this).parent().parent().find($(".test_tips")).toggle();
                    e.stopPropagation();  // 阻止冒泡
                });

                // 为选择按钮添加事件
                appUtils.bindEvent($(_pageId + " .test_list p a"), function () {
                    var quetype = $(this).attr("type");	 // 问题类型0：单选，1：多选
                    var queid = $(this).attr("id");
                    if (quetype == 1) {
                        $(this).toggleClass("active");
                    }
                    else {
                        if ($(this).hasClass("active")) {
                            $(this).parent().parent().parent().find("dt").css("color", "red");  // 未选择答案，则将该题标记为红色
                            $(this).removeClass("active");
                        }
                        else {
                            $(_pageId + " .test_list #" + queid).removeClass("active");
                            $(this).parent().parent().parent().find("dt").css("color", "#666666");	// 题目红色标记恢复黑色
                            $(this).addClass("active");
                        }
                    }
                });

                //查看业务知识
                appUtils.bindEvent($(_pageId + " .gray_title a"), function () {
                    //add by fengxiang 2015-07-17 升级
                    var param = {
                        "funcNo": "50109",
                        "moduleName": "open",
                        "url": "http://edu.sse.com.cn/col/shhkconnect/home/"
                    };
                    external.callMessage(param);
                });
            }
            else {
                layerUtils.iAlert(errorInfo, -1);
            }
        }, true, true, handleTimeout);
    }

    /* 处理请求超时 */
    function handleTimeout() {
        layerUtils.iConfirm("请求超时，是否重新加载？", function () {
            getRiskAssessQuestions();  // 再次风险测评题目
        });
    }

    /* 提交诚信评测答案 */
    function postRiskAssessmentData() {
        var len = $(_pageId + " .test_list dl").length;
        var str = "";   //题目，答案拼接的字符串
        var strs = "";
        $(arrs).each(function (i, e) {
            var val = "";
            var types = $(_pageId + " a[name='" + e.qId + "']").attr("type");
            if (types == "1") {
                $(_pageId + " a[name='" + e.qId + "']").each(function () {
                    if ($(this).hasClass("active")) {
                        val += $(this).attr("value") + "-";
                    }
                });
                if (val.indexOf("-") != -1) {
                    val = val.substr(0, val.length - 1);
                }
            } else {
                val = $(_pageId + " .test_list a[name='" + e.qId + "'].active").attr("value");
            }
            if (val == undefined || val == "") {
                strs += $(_pageId + " a[name='" + e.qId + "']").attr("id") + "、";
            } else {
                str += e.qId + "|" + val + "||,";
            }
        });
        str = str.substr(0, str.length - 1);
        var strss = str.split(",");
        if ((strss.length != len) && (strs != "")) {
            strs = strs.substr(0, strs.length - 1);
            layerUtils.iMsg(-1, "第" + strs + "题没有选择，请检查后重新确认！");
        } else {
            var submitTestParam = {
                "user_id": appUtils.getSStorageInfo("user_id"),
                "survey_type": "3",
                "answer_str": str
            };
            var ans_array = [];
            var str_arr = str.split(",");
            for (var i = 0; i < str_arr.length; i++) {
                var ans = str_arr[i].replace("||", "");
                var q_id = ans.split("|")[0];
                var a_id = ans.split("|")[1];
                ans_array.push({"q_id": q_id, "a_id": a_id});
            }
            appUtils.setSStorageInfo("ans_array", JSON.stringify(ans_array));
            //提交风险评测答案
            service.submitTestAnswer(submitTestParam, function (data) {
                console.log(JSON.stringify(data));
                var errorNo = data.error_no;
                var errorInfo = data.error_info;
                if (errorNo == 0 && data.results.length != 0)	//调用成功,跳转到风险测评页面
                {
                    //获取应用版本
                    var molileAttribution = appUtils.getSStorageInfo("molileAttribution");
                    var user_id = appUtils.getSStorageInfo("user_id");
                    var param = {"user_id": user_id, "message": "knowTest", "molileAttribution": molileAttribution};
                    //记录流程日志
                    service.submitProcesslog(function (data) {
                        var errorNo = data.error_no;
                        var errorInfo = data.error_info;
                        if (errorNo == "0") {

                        } else {
                            layerUtils.iAlert(errorInfo, -1);
                        }
                    }, param);
                    var remark = data.results[0].total_score,   //风险等级评分
                        riskdesc = data.results[0].define,  //风险评测文字等级
                        define_value = data.results[0].define_value;  //风险评测字母等级
                    appUtils.setSStorageInfo("knowledge_score", remark, true);
                    appUtils.pageInit("account/knowledge", "account/knowledgeInfo", {"remark": remark, "riskdesc": riskdesc, "define_value": define_value});
                }
                else {
                    layerUtils.iAlert(errorInfo, -1);
                }
            });
        }
    }

    var knowledge = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = knowledge;
});
