/*
 * 知识测评信息
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        global = require("gconfig").global,
        utils = require("utils"),
        layerUtils = require("layerUtils"),
        knowledge_score = "",  //风险等级数字评分
        knowledgeFlag = "",  //1表示满足风险评测等级，2表示不满足
        knowledge_lvl_name = "",  //风险评测等级
        steps = ["account", "survey", "knowledge_level",
            "integrity_level", "risk_level",
            "level", "survey_level", "open_confirm",
            "open_finish"
        ],
        _pageId = "#account_knowledgeInfo";
    var external = require("external");
    /* 私有业务模块的全局变量 end */

    function init() {
        _pageId = "#account_knowledgeInfo";
        cleanPageElement();
        //初始化处理
        initHandle();
    }

    function bindPageEvent() {
        //绑定确认键
        appUtils.bindEvent($(_pageId + " #confirm"), function () {
            appUtils.setSStorageInfo("knowledgeScore", knowledge_score);
            /*if(preStep!="account/comprehensiveScore"){
             appUtils.pageInit("account/knowledgeInfo","account/mainPage",{});
             }else{
             appUtils.pageInit("account/knowledgeInfo",preStep,{});
             }*/
            var preStep = appUtils.getSStorageInfo("pre_steps");
            var control_Step = appUtils.getSStorageInfo("control_step");
            //control_Step和preStep都是account/comprehensiveScore
            if ((preStep == "") || (preStep == null) || (preStep == undefined)) {
                preStep = control_Step;
            }
            if ((preStep != "account/comprehensiveScore") && (control_Step != "account/comprehensiveScore")) {
                appUtils.pageInit("account/knowledgeInfo", "account/mainPage", {});
            } else {
                appUtils.pageInit("account/knowledgeInfo", preStep, {});
            }
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"),
            function () {
                var branchID = appUtils.getSStorageInfo("branchno");
                var brokersno = appUtils.getSStorageInfo("recommendno");
                if (branchID == undefined) {
                    branchID = "";
                }
                if (brokersno == undefined) {
                    brokersno = "";
                }
                //如有选择了营业部或经纪人则需要传
                var param1 = {
                    "userid": appUtils.getSStorageInfo("user_id"),
                    "branchno": branchID,
                    "brokersno": brokersno
                }
                console.log("================================ param1=" + JSON.stringify(param1));
                /*  added at 2015/09/02
                 *  入参： user_id （客户id）
                 出参：调用成功有两种情况，
                 1.如果属于中焯渠道 会返回 status=1
                 2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
                service.serachIsCompanyCustomer(param1, function (data) {
                    console.log("================================ data=" + JSON.stringify(data));

                    var error_no = data.error_no,
                        error_info = data.error_info;
                    if (error_no == "0") {
                        var status = data.results[0].status;
                        if (status == "0") {
                            $(".ly_shadow").show();
                            var branchname = data.results[0].branchname;
                            var brokersname = data.results[0].brokersname;
                            var servicephone = data.results[0].servicephone;
                            var brokersphone = data.results[0].brokersphone;
                            var address = data.results[0].address;
                            var info = "";
                            //有经纪人的
                            if (!!brokersname) {
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听经纪人电话事件
                                appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            } else {//无经纪人的
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            }
                        } else {
                            if (require("gconfig").platform != "1") {
                                //ios 获取软件是否安装
                                var param = {
                                    "funcNo": "50200",
                                    "moduleName": "open",
                                    "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                };
                                var result = external.callMessage(param);
                                if (result.error_no == 0) {
                                    var isInstall = result.results[0].isInstall;
                                    //是否安装(0：否，1：是）
                                    if (isInstall == "1") {
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                            //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                        };
                                        external.callMessage(param);
                                    } else {
                                        layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                            //进入appstore
                                            var param = {
                                                "funcNo": "50109",
                                                "moduleName": "open",
                                                "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                            };
                                            external.callMessage(param);
                                        }, null, "下载", "取消");
                                    }
                                } else {
                                    layerUtils.iAlert("检测QQ失败");
                                }
                            } else {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                    "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                                };
                                external.callMessage(param);
                            }
                        }
                    } else {
                        layerUtils.iAlert(error_info);
                    }
                });
            });

        //绑定重新评测按钮
        appUtils.bindEvent($(_pageId + " #reTest"), function () {
            appUtils.pageInit("account/knowledgeInfo", "account/knowledge", {});
        });
        //绑定重新评测链接
        appUtils.bindEvent($(_pageId + " .retry"), function () {
            appUtils.pageInit("account/knowledgeInfo", "account/knowledge", {});
        });
        //绑定返回按钮
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.setSStorageInfo("knowledgeScore", knowledge_score);
            appUtils.pageInit("account/knowledgeInfo", "account/mainPage", {});
        });
    }

    function destroy() {
        service.destroy();
    }

    //初始化处理
    function initHandle() {
        knowledge_score = appUtils.getPageParam("remark");
        knowledge_lvl_name = appUtils.getPageParam("riskdesc");
        $(_pageId + " .chart_pic strong").html(knowledge_score);
        $(_pageId + " .test_chart h1").html(knowledge_lvl_name);
        if (knowledge_score >= 70) {
            $(_pageId + " .retry").show();
            $(_pageId + " .notice").hide();
            $(_pageId + " #confirm").show();
            $(_pageId + " #reTest").hide();
            knowledgeFlag = "1";
            saveStep();
        } else {
            knowledgeFlag = "2";
        }
        appUtils.setSStorageInfo("knowledgeFlag", knowledgeFlag);
    }

    //保存步骤
    function saveStep() {
        var param = {
            user_id: appUtils.getSStorageInfo("user_id"),
            current_step: "knowledge_level"
        };
        var c_step = appUtils.getSStorageInfo("current_step");
        var index = steps.indexOf(c_step);
        var this_index = steps.indexOf("knowledge_level");
        if (index < this_index) {
            service.saveUserTemp(function (data) {
                var errorNo = data.error_no;
                var errorInfo = data.error_info;
                if (errorNo == "0") {
                    appUtils.setSStorageInfo("current_step", "knowledge_level");
                } else {
                    layerUtils.iAlert(errorInfo, -1);
                }
            }, param);
        }
    }

    /* 清理界面元素*/
    function cleanPageElement() {
        $(_pageId + " .retry").hide();
        $(_pageId + " .notice").show();
        $(_pageId + " #confirm").hide();
        $(_pageId + " #reTest").show();
    }

    var knowledgeInfo = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = knowledgeInfo;
});