﻿/**
 * 资金账号登陆
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        global = require("gconfig").global,
        utils = require("utils"),
        layerUtils = require("layerUtils"),
        platform = require("gconfig").platform,
        shellPlugin = require("shellPlugin"),
        validatorUtil = require("validatorUtil"),
        startCountDown = null,
        _pageId = "#account_login",
        key = 1,
        steps = ["uploadimg", "idconfirm", "witness",
            "certintall", "capitalacct",
            "stkacct", "setpwd", "tpbank",
            "risksurvey", "visitsurvey", "success"
        ],
        stepMap = {"account": "account/mainPage", "survey": "account/mainPage", "knowledge_level": "account/mainPage", "integrity_level": "account/mainPage", "risk_level": "account/comprehensiveScore",
            "level": "account/comprehensiveScore", "survey_level": "account/mainPage", "open_confirm": "account/mainPage", "open_finish": "account/result"
        },
    /*stepMap = {"account":"account/mainPage","survey":"account/knowledge","knowledge_level":"account/integrity","integrity_level":"account/riskInfo","risk_level":"account/riskInfo",
     "level":"account/comprehensiveScore","survey_level":"account/signProtocol","open_confirm":"account/questionsRevisit","open_finish":"account/result"
     },*/
        stepMap0 = {"uploadimg": "account/uploadPhotoChange", "witness": "account/digitalCertificate"};
    var external = require("external");

    /* 私有业务模块的全局变量 end */

    function init() {
        //获取验证码
        codeRefresh();

        //add by fengxiang 2015-08-11 在港股通界面添加更新
        // 启动时，检查当前客户端的版本号与服务器上最新的是否一致，根据需要更新客户端，只在启动时检查，started 为 true
        // 表示已启动，已启动就不检查
        if (appUtils.getSStorageInfo("started", true) != "true") {
            // 设置 session 中的 started 为 true ，表示已启动
            var param = {
                "moduleName": "open",
                "funcNo": "50030"
            };
            //判断是否有网络
            var result = external.callMessage(param);
            var error_no = result.error_no;
            var result = result.results[0];
            if (error_no == "0") { //查询网络成功
                if (result.network != "0") {	//判断是否有网络  0：断网，1：2G，2：3G，3：4G，4：WIFI，9：未定义
                    appUtils.setSStorageInfo("started", "true", true);
                    layerUtils.iLoading(true, "正在检查版本...");
                    setBestAddress(); // 设置最佳地址
                } else {
                    layerUtils.iAlert("请连接网络！");
                }
            } else {
                layerUtils.iAlert("查询网络失败,请稍后重试！");
            }
        }
        //end by fengxiang 2015-08-11 在港股通界面添加更新

    }

    //更换验证码
    function codeRefresh() {
        $(_pageId + " .code_box img").attr("src", global.serverUrl + "/nImgServlet?key=" + Math.random());
    }

    function bindPageEvent() {
        /* 绑定返回事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_back"), function () {
            //是否是中焯的
            if (global.isZhongZhuo) {
                //add by fengxiang 2015-08-11 判断是否是从主页跳转过来的，是的话就返回主页，不是的话就返回中焯
                var preModule = appUtils.getSStorageInfo("preModule", true);
                if (preModule == "main") {
                    appUtils.sendDirect("../open/index.html#!/business/index.html");
                } else {
                    var param = {
                        "funcNo": "50101",
                        "moduleName": "open"
                    };
                    external.callMessage(param);
                    appUtils.clearSStorage(true);
                    $(_pageId).remove();
                }
                //end by fengxiang 2015-08-11 判断是否是从主页跳转过来的，是的话就返回主页，不是的话就返回中焯
            } else {
                appUtils.clearSStorage(true);
                appUtils.setSStorageInfo("started", "true", true);
                $(_pageId).remove();
                appUtils.sendDirect("../open/index.html#!/business/index.html");
            }
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"),
            function () {
                var branchID = appUtils.getSStorageInfo("branchno");
                var brokersno = appUtils.getSStorageInfo("recommendno");
                if (branchID == undefined) {
                    branchID = "";
                }
                if (brokersno == undefined) {
                    brokersno = "";
                }
                //如有选择了营业部或经纪人则需要传
                var param1 = {
                    "userid": appUtils.getSStorageInfo("user_id"),
                    "branchno": branchID,
                    "brokersno": brokersno
                }
                console.log("================================ param1=" + JSON.stringify(param1));
                /*  added at 2015/09/02
                 *  入参： user_id （客户id）
                 出参：调用成功有两种情况，
                 1.如果属于中焯渠道 会返回 status=1
                 2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
                service.serachIsCompanyCustomer(param1, function (data) {
                    console.log("================================ data=" + JSON.stringify(data));

                    var error_no = data.error_no,
                        error_info = data.error_info;
                    if (error_no == "0") {
                        var status = data.results[0].status;
                        if (status == "0") {
                            $(".ly_shadow").show();
                            var branchname = data.results[0].branchname;
                            var brokersname = data.results[0].brokersname;
                            var servicephone = data.results[0].servicephone;
                            var brokersphone = data.results[0].brokersphone;
                            var address = data.results[0].address;
                            var info = "";
                            //有经纪人的
                            if (!!brokersname) {
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听经纪人电话事件
                                appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            } else {//无经纪人的
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            }
                        } else {
                            if (require("gconfig").platform != "1") {
                                //ios 获取软件是否安装
                                var param = {
                                    "funcNo": "50200",
                                    "moduleName": "open",
                                    "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                };
                                var result = external.callMessage(param);
                                if (result.error_no == 0) {
                                    var isInstall = result.results[0].isInstall;
                                    //是否安装(0：否，1：是）
                                    if (isInstall == "1") {
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                            //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                        };
                                        external.callMessage(param);
                                    } else {
                                        layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                            //进入appstore
                                            var param = {
                                                "funcNo": "50109",
                                                "moduleName": "open",
                                                "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                            };
                                            external.callMessage(param);
                                        }, null, "下载", "取消");
                                    }
                                } else {
                                    layerUtils.iAlert("检测QQ失败");
                                }
                            } else {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                    "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                                };
                                external.callMessage(param);
                            }
                        }
                    } else {
                        layerUtils.iAlert(error_info);
                    }
                });
            });

        /* 切换图形验证码 */
        appUtils.bindEvent($(_pageId + " .btn_refresh"), function () {
            $(_pageId + " .code_box img").attr("src", global.serverUrl + "/nImgServlet?key=" + Math.random());
        });

        /* 校验图形验证码 */
        appUtils.bindEvent($(_pageId + " .mobile_form .pic_code"), function () {
        }, "input");

        /* 绑定资金密码输入*/
        appUtils.bindEvent($(_pageId + " .password"), function () {
            var password = $(_pageId + " .password").val();
            if (password != "") {
                $(_pageId + " .btn_clear").show();
            } else if (password == "") {
                $(_pageId + " .btn_clear").hide();
            }
            if (!$(_pageId + " btn_clear").is(":hidden")) {
                appUtils.bindEvent($(_pageId + " .btn_clear"), function () {
                    $(_pageId + " .password").val("");
                    $(_pageId + " .btn_clear").hide();
                });
            }
        }, "input");

        /* 下一步(继续开户) */
        appUtils.bindEvent($(_pageId + " .ce_btn a"), function () {
            //检查输入的信息
            if (checkInfo()) {
                //登陆资金账号
                loginAccount();
            }
        });

        /* 绑定输入账号验证只让输入数字*/
        appUtils.bindEvent($(_pageId + " .account"), function () {
            var accountNumStr = $(_pageId + " .account").val().trim();
            if (accountNumStr != "") {
                if (!validatorUtil.isNumeric(accountNumStr)) {
                    layerUtils.iMsg(-1, "请输入数字资金账号！");
                    var str = $(_pageId + " .account").val();
                    $(_pageId + " .account").val(str.substring(0, str.length - 1));
                    return false;
                }
            }
        }, "input");

        /* 绑定输入验证码只能输入数字和字母*/
        appUtils.bindEvent($(_pageId + " .code"), function () {
            var codeStr = $(_pageId + " .code").val().trim();
            if (codeStr != "") {
                if (!(validatorUtil.isNumeric(codeStr) || validatorUtil.isEnNumeric(codeStr))) {
                    layerUtils.iMsg(-1, "请正确输入验证码！");
                    $(_pageId + " .code").val("");
                    return false;
                }
            }
        }, "input");

        /* 绑定输入密码只能输入六位数字*/
        appUtils.bindEvent($(_pageId + " .password"), function () {
            var codeStr = $(_pageId + " .password").val().trim();
            if (codeStr != "") {
                if (!validatorUtil.isNumeric(codeStr)) {
                    layerUtils.iMsg(-1, "请输入数字密码！");
                    var str = $(_pageId + " .password").val();
                    $(_pageId + " .password").val(str.substring(0, str.length - 1));
                    return false;
                }
            }
        }, "input");

        appUtils.bindEvent($(_pageId), function (e) {
            // 关闭密码键盘
            if (platform == '1') {
                //关闭密码键盘
//				var param = {
//					"moduleName":"common",
//					"funcNo": "50211"
//				};
//				var result = external.callMessage(param);
//				if( result.error_no == "0"){
//	                $(_pageId+" #main").height($(window).height()-$(_pageId+" .header").height());
//				}
            }
            e.stopPropagation(); // 阻止冒泡
        });


    }

    function destroy() {
        $(_pageId + " .account").val("");   //清除资金账号
        $(_pageId + " .password").val("");  //清除密码
        $(_pageId + " .code").val("");  // 清除验证码
        service.destroy();
    }

    /* 验证输入信息*/
    function checkInfo() {
        var account_str = $(_pageId + " .account").val().length,
            password_str = $(_pageId + " .password").val().length,
            code_str = $(_pageId + " .code").val().length,
            accountStr = $(_pageId + " .account").val().trim();
        if ((accountStr.length) < 10 || (accountStr.length) > 11) {
            layerUtils.iMsg(-1, "请输入10~11位的资金账号！");
            codeRefresh();
            return false;
        }
        if (password_str == 0) {
            layerUtils.iMsg(-1, "请输入资金密码！");
            codeRefresh();
            return false;
        }
        if (code_str == 0) {
            layerUtils.iMsg(-1, "请输入验证码！");
            codeRefresh();
            return false;
        }
        if (!validatorUtil.isNumeric(accountStr)) {
            layerUtils.iMsg(-1, "请输入数字资金账号！");
            codeRefresh();
            return false;
        }
        if (!((6 <= password_str) && (password_str <= 20))) {
            layerUtils.iMsg(-1, "请输入6-20位的资金密码！");
            codeRefresh();
            return false;
        }
        return true;
    }

    //登陆资金账号
    function loginAccount() {
        var fund_account = $(_pageId + " .account").val(),
            password = $(_pageId + " .password").val(),
            code = $(_pageId + " .code").val();
        //把交易密码加密存到session中
        appUtils.setSStorageInfo("password", password, true);
        appUtils.setSStorageInfo("account_no", fund_account, true);
        var param = {
            "fund_account": fund_account,
            "password": password,
            "verify_code": code
        };
        //登陆资金账号
        service.loginAccount(param, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;
            if (error_no == "0" && result.length != 0) {
                if (result[0].login_flag == "1") {
                    var mobversionName = "";
                    // 获取应用版本versionName
                    /*shellPlugin.callShellMethod("getVersionPlugin",
                     function(data) {
                     var versionName = JSON.stringify(data.versionName);
                     mobversionName = versionName.replace(/^\"|\"$/g, '');
                     }, null);*/

                    //add by fengxiang 2015-07-17 升级
                    var param = {
                        "moduleName": "open",
                        "funcNo": "50010"
                    };
                    var result2 = external.callMessage(param);
                    if (result2.error_no == "0") {
                        var data = result2.results[0];
                        var versionName = JSON.stringify(data.version);
                        mobversionName = versionName.replace(/^\"|\"$/g, '');
                    }
                    //end by fengxiang 2015-07-17 升级
                    var molileAttribution = "";
                    if (platform == "1") {
                        molileAttribution = "android|" + mobversionName; // 获取应用版本:例如:android|2.0.1
                    } else {
                        molileAttribution = "apple|" + mobversionName; // 获取应用版本:例如:android|2.0.1
                    }
                    appUtils.setSStorageInfo("molileAttribution", molileAttribution);
                    var user_id = appUtils.getSStorageInfo("user_id");
                    var param = {"user_id": user_id, "message": "login", "molileAttribution": molileAttribution};

                    //记录流程日志
                    service.submitProcesslog(function (data) {
                        var errorNo = data.error_no;
                        var errorInfo = data.error_info;
                        if (errorNo == "0") {

                        } else {
                            layerUtils.iAlert(errorInfo, -1);
                        }
                    }, param);
                    //是否需要跑批
                    if (result[0].is_autoTask) {
                        appUtils.setSStorageInfo("is_autoTask", result[0].is_autoTask);
                    }
                    //开通港股通备注
                    if (result[0].ggtopen_remark) {
                        appUtils.setSStorageInfo("ggtopen_remark", result[0].ggtopen_remark);
                    }
                    //当前步骤
                    if (result[0].current_step) {
                        appUtils.setSStorageInfo("current_step", result[0].current_step);//result[0].current_step
                    }
                    //证件类型
                    if (result[0].idtype) {
                        appUtils.setSStorageInfo("idtype", result[0].idtype);
                    }
                    //证件有效截止日期
                    if (result[0].idenddate) {
                        appUtils.setSStorageInfo("idenddate", result[0].idenddate);
                    }
                    //证件有效开始日期
                    if (result[0].idbegindate) {
                        appUtils.setSStorageInfo("idbegindate", result[0].idbegindate);
                    }
                    //沪A账号是否加挂
                    if (result[0].isadd) {
                        appUtils.setSStorageInfo("isadd", result[0].isadd);
                    }
                    //港股通开立标志
                    if (result[0].ggtopen_flag) {
                        appUtils.setSStorageInfo("ggtopen_flag", result[0].ggtopen_flag);
                    }
                    //风险测评分数
                    if (result[0].risk_score) {
                        appUtils.setSStorageInfo("survey_score", result[0].risk_score);//result[0].risk_score
                        if (((result[0].risk_score) != "") || ((result[0].risk_score) != null)) {
                            var rating_lvl_name = "";
                            var score = parseInt(result[0].risk_score);
                            if (score < 10) {
                                rating_lvl_name = "保本型";
                            } else if ((score >= 10) && (score < 30)) {
                                rating_lvl_name = "保守型";
                            } else if ((score >= 30) && (score < 55)) {
                                rating_lvl_name = "防御型";
                            } else if ((score >= 55) && (score < 80)) {
                                rating_lvl_name = "稳健型";
                            } else if ((score >= 80) && (score <= 100)) {
                                rating_lvl_name = "进取型";
                            }
                            appUtils.setSStorageInfo("rating_lvl_name", rating_lvl_name);
                        }
                    }
                    //风险测评是否有效
                    if (result[0].risk_survey_valid) {
                        appUtils.setSStorageInfo("risk_survey_valid", result[0].risk_survey_valid);//
                    }
                    //风险测评等级
                    if (result[0].rating_lvl) {
                        appUtils.setSStorageInfo("rating_lvl", result[0].rating_lvl);
                    }
                    //营业部编号
                    if (result[0].branchno) {
                        appUtils.setSStorageInfo("branchno", result[0].branchno);
                    }
                    //用户编号
                    if (result[0].user_id) {
                        appUtils.setSStorageInfo("user_id", result[0].user_id);
                    }
                    //客户姓名
                    if (result[0].custname) {
                        appUtils.setSStorageInfo("custname", result[0].custname);
                    }
                    //沪A账号
                    if (result[0].shaaccount) {
                        appUtils.setSStorageInfo("shaaccount", result[0].shaaccount);
                    }
                    //证券账户普通资产
                    if (result[0].marketvalue) {
                        appUtils.setSStorageInfo("marketvalue", result[0].marketvalue);//result[0].marketvalue
                    }
                    //总资产
                    if (result[0].pt_sum_asset) {
                        appUtils.setSStorageInfo("pt_sum_asset", result[0].pt_sum_asset);
                    }
                    //电话号码
                    if (result[0].mobileno) {
                        appUtils.setSStorageInfo("mobileno", result[0].mobileno);
                    }
                    //客户类型
                    if (result[0].cust_type) {
                        appUtils.setSStorageInfo("cust_type", result[0].cust_type);
                    }
                    //信用证券账户总资产
                    if (result[0].net_asset) {
                        appUtils.setSStorageInfo("net_asset", result[0].net_asset);
                    }
                    //联系地址
                    if (result[0].address) {
                        appUtils.setSStorageInfo("address", result[0].address);
                    }
                    //身份证是否在有效期内
                    if (result[0].idenddate_valid) {
                        appUtils.setSStorageInfo("idenddate_valid", result[0].idenddate_valid);
                    }
                    //身份证号
                    if (result[0].idno) {
                        appUtils.setSStorageInfo("idno", result[0].idno);
                    }
                    //知识测评分数
                    if (result[0].getKnoledNum) {
                        appUtils.setSStorageInfo("knowledgeScore", result[0].getKnoledNum);//result[0].getKnoledNum
                    }
                    //是否进行了诚信测评，是1不是0
                    if (result[0].cred_flag) {
                        appUtils.setSStorageInfo("cred_flag", result[0].cred_flag);
                    }
                    //是否签署了协议，是1不是0
                    if (result[0].agreement_flag) {
                        appUtils.setSStorageInfo("agreement_flag", result[0].agreement_flag);
                    }
                    //诚信测评分数
                    if (result[0].credit_score) {
                        appUtils.setSStorageInfo("credit_score", (result[0].credit_score) * 10);
                    }

                    //修改过
                    if (result[0].orgid) {
                        appUtils.setSStorageInfo("orgid", result[0].orgid);
                    }
                    //修改过
                    if (result[0].custcert) {
                        appUtils.setSStorageInfo("custcert", result[0].custcert);
                    }

                    //jsessionid
                    if (result[0].jsessionid) {
                        appUtils.setSStorageInfo("jsessionid", result[0].jsessionid);
                    }
                    //back_step
                    if (result[0].back_step) {
                        appUtils.setSStorageInfo("back_step", result[0].back_step);
                    }

                    //是否是中焯的
                    if (global.isZhongZhuo) {
                        //add by fengxiang 2015-08-11 保存渠道数据
                        var param = {
                            "user_id": result[0].user_id,
                            "channela": getMemoryInfo("channelValue"),  //getMemoryInfo("channela")
                            "channelb": getMemoryInfo("channelb"),
                            "channelc": getMemoryInfo("channelc")
                        };
                        service.saveChannel(param, function (data) {
                            //只需要保存
                        });
                        //end by fengxiang 2015-08-11 保存渠道数据
                    }

                    nextStep(result[0]);//下一步入口

                } else if (result[0].login_flag == "0") {
                    layerUtils.iMsg(-1, result[0].login_reason);
                }
            } else {
                if (error_no == "-10002") {
                    //刷新验证码
                    codeRefresh();
                }
                if (error_info == "") {

                    layerUtils.iAlert("用户名有误或密码错误！", -1);
                    //刷新验证码
                    codeRefresh();
                    $(_pageId + " .code").val("");  // 清除验证码
                } else {
                    layerUtils.iAlert(error_info, -1);
                    $(_pageId + " .code").val("");  // 清除验证码
                    //刷新验证码
                    codeRefresh();
                }
            }
        });
    }

    /* 下一步入口 */
    function nextStep(res) {
        if (res.back_step == "1" || res.back_step == "3" || res.back_step == "4") {
            appUtils.pageInit("account/login", "account/result");
        } else if (res.back_step == "2") {
            appUtils.pageInit("account/login", "account/integrity", {});
        } else if (!!res.current_step) {//!!res.current_step
            //流程控制
            var step = stepMap[res.current_step];
            if (!!step) {
                appUtils.pageInit("account/login", step, {});
            } else {
                appUtils.pageInit("account/login", "account/mainPage", {});
            }

        } else {
            appUtils.pageInit("account/login", "account/msgConfirm", {});
        }
    }


    /******************* start 更新H5**********************/
    /* 自动测速，选择最佳地址 */
    function setBestAddress() {
        // 检测更新最新版本
        detectUpdate();
    }

    /* 检测更新最新版本 */
    function detectUpdate() {
        var queryParam = {
            "by_type": "1",
            "terminal_type": platform == "1" ? "android" : "ios"
        };
        //是否是中焯的  // by_type 1: 中焯版本   2： 单独
        if (global.isZhongZhuo) {
            queryParam.by_type = "1";
        } else {
            queryParam.by_type = "2";
        }
        service.getVersion(queryParam, function (data) {
            if (data.error_no == 0) {
                layerUtils.iLoading(false);
                // 服务器有数据返回时
                if (data.results.length != 0 && data.results[0].update_url != undefined) {
                    if (platform == "1") {
                        execUpdateAndroid(data.results); // 执行安卓更新
                    } else {
                        execUpdateIOS(data.results); // 执行IOS更新
                    }

                }
            } else // 查询地址失败
            {
                layerUtils.iLoading(false);
                layerUtils.iAlert("版本检查失败，请稍后重试！");
            }
        }, true, false);
    }

    // 执行安卓更新操作
    function execUpdateAndroid(results) {
        var param = {
            "funcNo": "50010",
            "moduleName": "common",
            "source": "open"
        };
        //获取当前版本
        var result1 = external.callMessage(param);
        if (result1.error_no == "0") {
            //如果当前版本不是最新的 则下载更新
            var version = results[0].version; // 最新版本
            var version_now = result1.results[0].versionSn; // 当前版本
            if (version > version_now) {
                var updateParam = {
                    "url": results[0].update_url,  // 更新地址
                    "type": "1",
                    "version": results[0].version,  // 最新版本号
                    // 只有一条记录取 0
                    "versionSn": results[0].version,
                    "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
                    "funcNo": "50201",
                    "moduleName": "common",
                    "source": "open"
                };
                external.callMessage(updateParam);
            }
        }
    }

    // 执行IOS更新操作
    function execUpdateIOS(results) {
        var updateParam = {
            "url": results[0].update_url,  // 更新地址
            "type": "1",
            "version": results[0].version,  // 最新版本号
            // 只有一条记录取 0
            "versionSn": results[0].version,
            "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
            "funcNo": "50201",
            "moduleName": "open"
        };
        external.callMessage(updateParam);
    }

    /******************* end 更新H5 **********************/

        //add by fengxiang 2015-08-11  从内存缓存获取数据
    function getMemoryInfo(key) {
        var param = {
            "funcNo": "50041",
            "key": key
        };
        var result = external.callMessage(param);
        if (result.error_no == "0") { //获取缓存成功
            var value = result.results[0].value;
            return value;
        } else {
            layerUtils.iAlert("获取内存数据失败");
        }
    }

    //end by fengxiang 2015-08-11  从内存缓存获取数据

    var login = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    //暴露接口
    module.exports = login;
});
