/**
 * 主菜单
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        global = require("gconfig").global,
        layerUtils = require("layerUtils"),
        fundsFlag = "",  //资金状况
        utils = require("utils"),
        riskFlag = "",   //风险评测状况
        knowledgeFlag = "", //知识评测状况
        marketvalue = "",
        knowledgeScore = "",
        agreement_flag = "",
        rating_lvl_name = "",
        survey_score = "",
        signFlag = "", //协议签署状况
        risk_survey_valid = "",
        steps = ["account", "survey", "knowledge_level",
            "integrity_level", "risk_level",
            "level", "survey_level", "open_confirm",
            "open_finish"
        ],
        cred_flag = "",
        _pageId = "#account_mainPage";
    var external = require("external");

    /* 私有业务模块的全局变量 end */
    function init() {
        _pageId = "#account_mainPage";
        //初始化操作
        initHandle();
    }

    function bindPageEvent() {
        //绑定资金菜单
        appUtils.bindEvent($(_pageId + " #funds"), function () {
            appUtils.pageInit("account/mainPage", "account/fundsInfo", {});
        });
        //绑定知识测评
        appUtils.bindEvent($(_pageId + " #knowledgeTest"), function () {
            var c_step = appUtils.getSStorageInfo("current_step");
            var index = steps.indexOf(c_step);
            //本步骤下标
            var this_index = steps.indexOf("knowledge_level") - 1;
            if ((index > this_index) || (index == this_index)) {
                appUtils.pageInit("account/mainPage", "account/knowledge", {});
            }
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"),
            function () {
                var branchID = appUtils.getSStorageInfo("branchno");
                var brokersno = appUtils.getSStorageInfo("recommendno");
                if (branchID == undefined) {
                    branchID = "";
                }
                if (brokersno == undefined) {
                    brokersno = "";
                }
                //如有选择了营业部或经纪人则需要传
                var param1 = {
                    "userid": appUtils.getSStorageInfo("user_id"),
                    "branchno": branchID,
                    "brokersno": brokersno
                }
                console.log("================================ param1=" + JSON.stringify(param1));
                /*  added at 2015/09/02
                 *  入参： user_id （客户id）
                 出参：调用成功有两种情况，
                 1.如果属于中焯渠道 会返回 status=1
                 2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
                service.serachIsCompanyCustomer(param1, function (data) {
                    console.log("================================ data=" + JSON.stringify(data));

                    var error_no = data.error_no,
                        error_info = data.error_info;
                    if (error_no == "0") {
                        var status = data.results[0].status;
                        if (status == "0") {
                            $(".ly_shadow").show();
                            var branchname = data.results[0].branchname;
                            var brokersname = data.results[0].brokersname;
                            var servicephone = data.results[0].servicephone;
                            var brokersphone = data.results[0].brokersphone;
                            var address = data.results[0].address;
                            var info = "";
                            //有经纪人的
                            if (!!brokersname) {
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听经纪人电话事件
                                appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            } else {//无经纪人的
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            }
                        } else {
                            if (require("gconfig").platform != "1") {
                                //ios 获取软件是否安装
                                var param = {
                                    "funcNo": "50200",
                                    "moduleName": "open",
                                    "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                };
                                var result = external.callMessage(param);
                                if (result.error_no == 0) {
                                    var isInstall = result.results[0].isInstall;
                                    //是否安装(0：否，1：是）
                                    if (isInstall == "1") {
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                            //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                        };
                                        external.callMessage(param);
                                    } else {
                                        layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                            //进入appstore
                                            var param = {
                                                "funcNo": "50109",
                                                "moduleName": "open",
                                                "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                            };
                                            external.callMessage(param);
                                        }, null, "下载", "取消");
                                    }
                                } else {
                                    layerUtils.iAlert("检测QQ失败");
                                }
                            } else {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                    "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                                };
                                external.callMessage(param);
                            }
                        }
                    } else {
                        layerUtils.iAlert(error_info);
                    }
                });
            });
        //绑定诚信测评
        appUtils.bindEvent($(_pageId + " #integrityTest"), function () {
            var c_step = appUtils.getSStorageInfo("current_step");
            var index = steps.indexOf(c_step);
            //本步骤下标
            var this_index = steps.indexOf("integrity_level") - 1;
            if ((index > this_index) || (index == this_index)) {
                appUtils.pageInit("account/mainPage", "account/integrity", {});
            }
        });
        //绑定风险等级测试
        appUtils.bindEvent($(_pageId + " #riskTest"), function () {
            var c_step = appUtils.getSStorageInfo("current_step");
            var index = steps.indexOf(c_step);
            //本步骤下标
            var this_index = steps.indexOf("risk_level") - 1;
            if ((index > this_index) || (index == this_index)) {
                appUtils.pageInit("account/mainPage", "account/riskInfo", {});
            }
        });
        //绑定电子签约
        appUtils.bindEvent($(_pageId + " #elecSign"), function () {
            var c_step = appUtils.getSStorageInfo("current_step");
            var index = steps.indexOf(c_step);
            //本步骤下标
            var this_index = steps.indexOf("level") - 1;
            if ((index > this_index) || (index == this_index)) {
                appUtils.pageInit("account/mainPage", "account/signProtocol", {});
            }
        });

        //绑定提交港股通权限的按钮

        //绑定提交按钮
        appUtils.bindEvent($(_pageId + " .ce_btn"), function () {
            if (!$(_pageId + " .ce_btn").hasClass("disable")) {
                //获取应用版本
                var molileAttribution = appUtils.getSStorageInfo("molileAttribution");
                var user_id = appUtils.getSStorageInfo("user_id");
                var param = {"user_id": user_id, "message": "finished", "molileAttribution": molileAttribution};
                //记录流程日志
                service.submitProcesslog(function (data) {
                    var errorNo = data.error_no;
                    var errorInfo = data.error_info;
                    if (errorNo == "0") {
                        appUtils.pageInit("account/mainPage", "account/questionsRevisit", {});
                    } else {
                        layerUtils.iAlert(errorInfo, -1);
                    }
                }, param);
            }
        });


        //处理返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageInit("account/mainPage", "account/msgConfirm", {});
        });
    }

    //初始化操作
    function initHandle() {
        //appUtils.setSStorageInfo("pre_steps","account_mainPage");
        var value = appUtils.getSStorageInfo("value"), //在主菜单显示账户资金
            rating_lvl = appUtils.getSStorageInfo("rating_lvl"),  //在主菜单显示风险评测等级
            survey_score = appUtils.getSStorageInfo("survey_score");
        knowledgeScore = appUtils.getSStorageInfo("knowledgeScore"); //在主菜单显示知识评测等级
        marketvalue = appUtils.getSStorageInfo("marketvalue");
        risk_survey_valid = appUtils.getSStorageInfo("risk_survey_valid");
        rating_lvl_name = appUtils.getSStorageInfo("rating_lvl_name");  //风险评测等级
        cred_flag = appUtils.getSStorageInfo("cred_flag");
        fundsFlag = appUtils.getSStorageInfo("fundsFlag");
        agreement_flag = appUtils.getSStorageInfo("agreement_flag");
        riskFlag = appUtils.getSStorageInfo("riskFlag");
        integrityFlag = appUtils.getSStorageInfo("integrityFlag");
        knowledgeFlag = appUtils.getSStorageInfo("knowledgeFlag");
        signFlag = appUtils.getSStorageInfo("signFlag");
        credit_score = appUtils.getSStorageInfo("credit_score");
        var c_step = appUtils.getSStorageInfo("current_step");
        //总资产
        var pt_sum_asset = appUtils.getSStorageInfo("pt_sum_asset");
        //信用资产
        var pt_net_asset = appUtils.getSStorageInfo("pt_net_asset");

        //判断有没有沪A账户
        var shaaccount = appUtils.getSStorageInfo("shaaccount"),
            isadd = appUtils.getSStorageInfo("isadd"),
            _prePageCode = appUtils.getSStorageInfo("_prePageCode");
        if (shaaccount == "" || shaaccount == undefined || shaaccount == null) {
            handle();
        }
        if (shaaccount != null && isadd == "0") {
            handle();
        }
        //判断从子页面跳到主菜单
        //资金状况
        if (pt_sum_asset != null) {
            var index = steps.indexOf(c_step);
            var this_index = steps.indexOf("survey");
            //当资产大于50万或登陆账户后满足了50万，或者下次登陆的时候前面满足的都显示已经满足
            if ((pt_sum_asset >= 500000) || (fundsFlag == "1") || (index >= this_index)) {
                saveStep();
                if (index <= this_index) {
                    appUtils.setSStorageInfo("current_step", "survey");
                }
                fundsFlag = "1";
                $(_pageId + " .must_list ul li:eq(0)").removeClass("lost").addClass("over");
                $(_pageId + " #funds span").removeClass("ared").html("已满足");
            } else {
                fundsFlag = "2";
                $(_pageId + " .must_list ul li:eq(0)").removeClass("over");
                $(_pageId + " .must_list ul li:eq(0)").addClass("lost");
                $(_pageId + " #funds span").addClass("ared").html(pt_sum_asset);
            }
        }
        if ((knowledgeScore != null) || (knowledgeFlag == "1") || ((knowledgeScore != "0"))) {
            var c_step = (appUtils.getSStorageInfo("current_step"));
            //知识评测
            if (parseInt(knowledgeScore) >= 70) {
                knowledgeFlag = "1";
                $(_pageId + " .must_list ul li:eq(1)").removeClass("lost").addClass("over");
                $(_pageId + " #knowledgeTest span").removeClass("ared").html(knowledgeScore + "分");
            } else if (((c_step == "survey") || (c_step == "")) && (knowledgeScore == "0")) {
                var c_step = appUtils.getSStorageInfo("current_step");
                {
                    $(_pageId + " #knowledgeTest span").html("<span style='color:red'>请测评</span>");
                }
            } else if (!(c_step == "account")) {
                knowledgeFlag = "2";
                //用两个感叹号返回的就是false,所以两个感叹号的作用就在于，如果明确设置了变量的值（非null/undifined/0/""等值),
                //结果就会根据变量的实际值来返回，如果没有设置，结果就会返回false
                $(_pageId + " .must_list ul li:eq(1)").removeClass("over").addClass("lost");
                $(_pageId + " #knowledgeTest span").addClass("ared").html(knowledgeScore + "分");
            }

        }

        //诚信测评
        if (cred_flag == "1" || integrityFlag == "1") {
            $(_pageId + " .must_list ul li:eq(2)").removeClass("lost").addClass("over");
            $(_pageId + " #integrityTest span").html(credit_score + "分");
        } else if (integrityFlag == "2") {
            $(_pageId + " .must_list ul li:eq(2)").removeClass("over").addClass("lost");
            $(_pageId + " #integrityTest span").html("<span style='color:red'>请测评</span>");
        } else {
            if ((integrityFlag != "2") && (c_step == "knowledge_level")) {
                $(_pageId + " #integrityTest span").html("<span style='color:red'>请测评</span>");
            }
        }

        /**
         * 风险测评begin
         */
        //数据库保存步骤下标
        var index = steps.indexOf(c_step);
        //本步骤下标
        var this_index = steps.indexOf("integrity_level");
        if ((survey_score != null) && (survey_score != "null") && (this_index < index) || (riskFlag == "1")) {
            //风险评测
            if ((survey_score > 0) && (risk_survey_valid == "1")) {
                riskFlag = "1";
                $(_pageId + " .must_list ul li:eq(3)").removeClass("lost");
                $(_pageId + " .must_list ul li:eq(3)").addClass("over");
                if (!!rating_lvl_name) {
                    $(_pageId + " #riskTest span").removeClass("ared").html(rating_lvl_name);
                }
            } else {
                riskFlag = "2";
                if (survey_score > 0) {
                    $(_pageId + " .must_list ul li:eq(3)").removeClass("over");
                    $(_pageId + " .must_list ul li:eq(3)").addClass("lost");
                    $(_pageId + " #riskTest span").addClass("ared").html("已过期");
                } else {
                    $(_pageId + " .must_list ul li:eq(3)").removeClass("over");
                    $(_pageId + " .must_list ul li:eq(3)").addClass("lost");
                    $(_pageId + " #riskTest span").addClass("ared").html(rating_lvl_name);
                }
            }
        } else if ((riskFlag != "2") && (c_step == "integrity_level")) {
            $(_pageId + " #riskTest span").html("<span style='color:red'>请测评</span>");
        }
        /**
         * 风险测评end
         */


        //协议签署
        if ((signFlag == "1") || (agreement_flag == "1")) {
            signFlag = "1";
            $(_pageId + " .must_list ul li:eq(4)").removeClass("lost").addClass("over");
            $(_pageId + " #elecSign span").html("");
        } else if (signFlag == "2") {
            $(_pageId + " .must_list ul li:eq(4)").removeClass("over").addClass("lost");
            $(_pageId + " #elecSign span").html("");
        } else if (((c_step == "survey_level") || (c_step == "level") || (c_step == "risk_level")) && (riskFlag != "2")) {
            $(_pageId + " #elecSign span").html("<span style='color:red'>请签署</span>");
        }


        //判断提交港股通权限按钮的功能
        if (fundsFlag == "1" && riskFlag == "1" && knowledgeFlag == "1" && signFlag == "1") {//fundsFlag == "1" && riskFlag == "1" && knowledgeFlag == "1" && signFlag == "1"
            $(_pageId + " .ce_btn").removeClass("disable");
        }

    }//initHandle

    function saveStep() {
        var param = {
            user_id: appUtils.getSStorageInfo("user_id"),
            current_step: "survey"
        };
        var c_step = appUtils.getSStorageInfo("current_step");
        var index = steps.indexOf(c_step);
        var this_index = steps.indexOf("survey");
        if (index < this_index) {
            service.saveUserTemp(function (data) {
                var errorNo = data.error_no;
                var errorInfo = data.error_info;
                if (errorNo == "0") {
                    appUtils.setSStorageInfo("current_step", "survey");
                } else {
                    layerUtils.iAlert(errorInfo, -1);
                }
            }, param);
        }


    }

    /* 没有沪A账户的处理，有沪A，但是没有在本证券公司加挂的处理*/
    function handle() {
        layerUtils.iAlert("你当前尚未在我司开通沪A账户，暂时无法申请港股通", -1, function () {
            //退出app
            //require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出系统
            appUtils.sendDirect("../open/index.html");
        }, "退出");
    }

    function destroy() {
        service.destroy();
    }


    /* 清理界面元素*/
    /*function cleanPageElement()
     {

     }*/

    var mainPage = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = mainPage;
});