/**
 * 修改电话号码
 */
define(function (require, exports, module) {
    var appUtils = require("appUtils"),
        global = require("gconfig").global,
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        validatorUtil = require("validatorUtil"),
        utils = require("utils"),
        mobile_no = "",
        flag = "",
        layerUtils = require("layerUtils"),
        utils = require("utils"),
        startCountDown = null,
        address = "",
        steps = ["account", "survey", "knowledge_level",
            "integrity_level", "risk_level",
            "level", "survey_level", "open_confirm",
            "open_finish"
        ],
        _pageId = "#account_msgConfirm";
    var external = require("external");

    function init() {
        /* 发送验证码后自动互调该方法 */
        window.getCode = getCode;
        flag = "",
            mobile_no = "",
            _pageId = "#account_msgConfirm";
        initMsg();
    }

    //填充个人资料
    function initMsg() {
        var account_no = appUtils.getSStorageInfo("account_no", true),
            custname = appUtils.getSStorageInfo("custname"),
            idno = appUtils.getSStorageInfo("idno"),
            idenddate = appUtils.getSStorageInfo("idenddate"),
            idbegindate = appUtils.getSStorageInfo("idbegindate");
        address = appUtils.getSStorageInfo("address");
        mobile_no = appUtils.getSStorageInfo("mobileno");
        //有效期
        var dataStr = idbegindate + "至" + idenddate;
        //填充个人资料
        $(_pageId + " .account_no").val(account_no);
        //修改过
        $(_pageId + " h5").html("姓&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;名：" + custname);
        $(_pageId + " .idno").val(idno);
        $(_pageId + " .idenddate").val(idenddate);
        $(_pageId + " .idbegindate").val(idbegindate);
        $(_pageId + " .edit_tarea").val(address);
        $(_pageId + " .mobileno").val(mobile_no);
        $(_pageId + " .iddate").val(dataStr);
    }

    function saveStep() {
        var param = {
            user_id: appUtils.getSStorageInfo("user_id"),
            current_step: "account"
        };
        var c_step = appUtils.getSStorageInfo("current_step");
        //数据库保存步骤下标
        var index = steps.indexOf(c_step);
        //本步骤下标
        var this_index = steps.indexOf("account");
        if (index < this_index) {
            //记录步骤
            service.saveUserTemp(function (data) {
                var errorNo = data.error_no;
                var errorInfo = data.error_info;
                if (errorNo == "0") {
                    appUtils.setSStorageInfo("current_step", "account");
                    appUtils.pageInit("account/msgConfirm", "account/mainPage", {});
                } else {
                    layerUtils.iAlert(errorInfo, -1);
                }
            }, param);
        } else {
            appUtils.pageInit("account/msgConfirm", "account/mainPage", {});
        }
    }

    function bindPageEvent() {
        //获取验证码
        appUtils.bindEvent($(_pageId + " .blue_code"), function () {
            var mobileno = $(_pageId + " .mobileno").val();
            if (validatorUtil.isMobile(mobileno)) {
                if ($(_pageId + " .mobileno").val() == mobile_no) {
                    layerUtils.iMsg(-1, "您未修改手机号码！");
                } else {
                    $(this).hide();
                    $(_pageId + " .get_code").show();
                    sendSmsCode(mobileno);  //获取验证码
                }
            }
            else {
                // 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
                var times = mobileno.length - 11;
                if (mobileno.length > 11) {
                    layerUtils.iMsg(-1, "您多输入&nbsp;" + times + "&nbsp;位电话号码，请重新输入！");
                }
                else if (mobileno.length < 11) {
                    layerUtils.iMsg(-1, "您少输入&nbsp;" + Math.abs(times) + "&nbsp;位电话号码，请重新输入！");
                } else {
                    layerUtils.iMsg(-1, "请输入正确的电话号码！");
                }
                return;
            }
        });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"),
            function () {
                var branchID = appUtils.getSStorageInfo("branchno");
                var brokersno = appUtils.getSStorageInfo("recommendno");
                if (branchID == undefined) {
                    branchID = "";
                }
                if (brokersno == undefined) {
                    brokersno = "";
                }
                //如有选择了营业部或经纪人则需要传
                var param1 = {
                    "userid": appUtils.getSStorageInfo("user_id"),
                    "branchno": branchID,
                    "brokersno": brokersno
                }
                console.log("================================ param1=" + JSON.stringify(param1));
                /*  added at 2015/09/02
                 *  入参： user_id （客户id）
                 出参：调用成功有两种情况，
                 1.如果属于中焯渠道 会返回 status=1
                 2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
                service.serachIsCompanyCustomer(param1, function (data) {
                    console.log("================================ data=" + JSON.stringify(data));

                    var error_no = data.error_no,
                        error_info = data.error_info;
                    if (error_no == "0") {
                        var status = data.results[0].status;
                        if (status == "0") {
                            $(".ly_shadow").show();
                            var branchname = data.results[0].branchname;
                            var brokersname = data.results[0].brokersname;
                            var servicephone = data.results[0].servicephone;
                            var brokersphone = data.results[0].brokersphone;
                            var address = data.results[0].address;
                            var info = "";
                            //有经纪人的
                            if (!!brokersname) {
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听经纪人电话事件
                                appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            } else {//无经纪人的
                                info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                                branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                    + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                    + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                                info += branchno_info;
                                $(".btn_bot p").html(info);
                                //监听营业部电话事件
                                appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                //监听统一电话事件
                                appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                    var tel = $(this).text();
                                    utils.call(tel); //打电话
                                    e.stopPropagation(); // 阻止冒泡
                                });
                                appUtils.bindEvent(".btn_box", function (e) {
                                    $(".ly_shadow").hide();
                                    e.stopPropagation(); // 阻止冒泡
                                });
                            }
                        } else {
                            if (require("gconfig").platform != "1") {
                                //ios 获取软件是否安装
                                var param = {
                                    "funcNo": "50200",
                                    "moduleName": "open",
                                    "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                };
                                var result = external.callMessage(param);
                                if (result.error_no == 0) {
                                    var isInstall = result.results[0].isInstall;
                                    //是否安装(0：否，1：是）
                                    if (isInstall == "1") {
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                            //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                        };
                                        external.callMessage(param);
                                    } else {
                                        layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                            //进入appstore
                                            var param = {
                                                "funcNo": "50109",
                                                "moduleName": "open",
                                                "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                            };
                                            external.callMessage(param);
                                        }, null, "下载", "取消");
                                    }
                                } else {
                                    layerUtils.iAlert("检测QQ失败");
                                }
                            } else {
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                    "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                                };
                                external.callMessage(param);
                            }
                        }
                    } else {
                        layerUtils.iAlert(error_info);
                    }
                });
            });

        //提交电话修改
        appUtils.bindEvent($(_pageId + " .ce_btn"), function () {
            if ($(_pageId + " .mobileno").val().length == 0) {
                layerUtils.iAlert("请输入手机号！", -1);
                return;
            }

            //地址改变了
            if ($(_pageId + " .edit_tarea").val() != address) {
                flag = "1";
            }
            //电话号码改变了
            if (mobile_no == $(_pageId + " .mobileno").val()) {
                if (flag == "1") {
                    submitAddress();
                } else {
                    saveStep();
                }
            } else {
                if (($(_pageId + " .code").val().length == 0) || ($(_pageId + " .code").val() == "请输入验证码")) {
                    layerUtils.iAlert("请输入验证码!", -1);
                    return;
                }
                checkSmsCode();
            }
//				submitAddress();//
        });
        //修改电话号码
        appUtils.bindEvent($(_pageId + " .mobileno"), function () {
            $(_pageId + " #showCode").show();
        });

        /* 绑定输入账号验证只让输入数字*/
        appUtils.bindEvent($(_pageId + " .mobileno"), function () {
            var accountNumStr = $(_pageId + " .mobileno").val().trim();
            if (accountNumStr != "") {
                if (!validatorUtil.isNumeric(accountNumStr)) {
                    layerUtils.iMsg(-1, "请正确输入号码！");
                    var str = $(_pageId + " .mobileno").val();
                    $(_pageId + " .mobileno").val(str.substring(0, str.length - 1));
                    return false;
                }
            }
        }, "input");

        /* 绑定输入地址
         appUtils.bindEvent($(_pageId+ " .address"),function(){
         var addressStr = $(_pageId+ " .address").val().trim();
         if(addressStr != ""){
         if(!validatorUtil.executeExp("/^[\da-zA-Z\u4e00-\u9fa5\(\)\（\）\-\——\、]*$/",addressStr)){
         layerUtils.iMsg(-1,"请正确输入地址！");
         var str = $(_pageId+ " .address").val();
         $(_pageId+ " .address").val(str.substring(0,str.length-1));
         return false;
         }
         }
         },"input");*/

        /* 绑定输入验证码只让输入数字*/
        appUtils.bindEvent($(_pageId + " .code"), function () {
            var accountNumStr = $(_pageId + " .code").val().trim();
            if (accountNumStr != "") {
                if (!validatorUtil.isNumeric(accountNumStr)) {
                    layerUtils.iMsg(-1, "请正确输入验证码！");
                    var str = $(_pageId + " .code").val();
                    $(_pageId + " .code").val(str.substring(0, str.length - 1));
                    return false;
                }
            }
        }, "input");

        //处理返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            layerUtils.iConfirm("是否退出？", function () {
                //清除所有缓存
                appUtils.clearSStorage();
                //防止再次到主页面时进行版本检测
                appUtils.setSStorageInfo("started", "true", true);
                /**
                 * 清除项目中的html
                 */
                $("#bodyContent .page").each(function () {
                    $(this).remove();
                });
                appUtils.pageInit("account/mainPage", "account/login", {});
            });
        });

        //清空验证码输入框
        appUtils.bindEvent($(_pageId + " .code"), function () {
            $(this).val("");
        });
    }

    function destroy() {
        service.destroy();
    }

    /* 壳子获取验证码自动填充 */
    function getCode(data) {
        if (data) {
            $(_pageId + " .code").val(data);
        }
    }

    function submitAddress() {
        //验证成功提交电话号码修改
        var param = {
            "user_id": appUtils.getSStorageInfo("user_id"),
            "contact_mobile": $(_pageId + " .mobileno").val(),
            "address": $(_pageId + " .edit_tarea").val(),
            "trdpwd": appUtils.getSStorageInfo("password", true)
        };
        service.submitMobileAddress(param, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            if (error_no == "0") {
                appUtils.setSStorageInfo("address", $(_pageId + " .edit_tarea").val());
                //获取应用版本
                var molileAttribution = appUtils.getSStorageInfo("molileAttribution");
                var user_id = appUtils.getSStorageInfo("user_id");
                var param = {"user_id": user_id, "message": "alterAddr", "molileAttribution": molileAttribution};
                //记录流程日志
                service.submitProcesslog(function (data) {
                    var errorNo = data.error_no;
                    var errorInfo = data.error_info;
                    if (errorNo == "0") {
                        saveStep();
                    } else {
                        layerUtils.iAlert(errorInfo, -1);
                    }
                }, param);
            } else {
                layerUtils.iAlert(error_info, -1);
            }
        });
    }

    //发送验证码
    function sendSmsCode(mobileno) {
        var param = {
            "mobile_no": mobileno
        };
        service.sendSmsCode(param, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;
            if (error_no == "0") {
                // 计时器
                var sumTime = 120;
                //处理获取验证码时发生的动作
                var handleCount = function () {
                    // 获取验证码之后按钮隐藏
                    $(_pageId + " .blue_code").hide();
                    // 显示倒计时
                    $(_pageId + " .get_code").show();
                    $(_pageId + " .get_code").text(sumTime-- + "秒后重发");
                };
                handleCount();
                startCountDown = window.setInterval(function () {
                    handleCount();
                }, 1000);
                // 120 秒之后清除计时器
                var clearCountDown = setTimeout(function () {
                    // 显示按钮
                    $(_pageId + " .blue_code").show();
                    // 隐藏倒计时
                    $(_pageId + " .get_code").hide();
                    $(_pageId + " .get_code").text(120);
                    window.clearInterval(startCountDown);
                }, 121000);
                //发送完验证码后，通过判断输入手机号是否一致，否则重新发送验证码
                var c_phoneNum = mobileno;
                appUtils.bindEvent($(_pageId + " .mobileno"), function () {
                    c_phoneNum = $(_pageId + " .mobileno").val();
                    if (validatorUtil.isMobile(mobileno) && validatorUtil.isMobile(c_phoneNum)) {
                        //用户两次输入的手机号不同，重新获取验证码
                        if (c_phoneNum != mobileno) {
                            clearInterval(startCountDown);   //清除定时器
                            clearTimeout(clearCountDown);
                            $(_pageId + " .blue_code").show();  // 显示按钮
                            $(_pageId + " .get_code").hide();  // 隐藏倒计时
                        }
                    }
                }, "input");
                // 调用读取短信验证码插件
                //require("shellPlugin").callShellMethod("sMSReceiverPlugin",null,null,null);
            } else {
                layerUtils.iAlert(error_info, -1);
                return false;
            }
        });
    }

    //检验验证码
    function checkSmsCode() {
        var param = {
            "mobile_no": $(_pageId + " .mobileno").val(),
            "mobile_code": $(_pageId + " .code").val()
        };
        service.checkSmsCode(param, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            if (error_no == "0") {
                //验证成功提交电话号码修改
                var param = {
                    "user_id": appUtils.getSStorageInfo("user_id"),
                    "contact_mobile": $(_pageId + " .mobileno").val(),
                    "address": $(_pageId + " .edit_tarea").val(),
                    "trdpwd": appUtils.getSStorageInfo("password", true)
                };
                service.submitMobileAddress(param, function (data) {
                    var error_no = data.error_no;
                    var error_info = data.error_info;
                    if (error_no == "0") {
                        //如果地址改变了
                        if (flag == "1") {
                            //获取应用版本
                            var molileAttribution = appUtils.getSStorageInfo("molileAttribution");
                            appUtils.setSStorageInfo("address", $(_pageId + " .edit_tarea").val());
                            var user_id = appUtils.getSStorageInfo("user_id");
                            var param = {"user_id": user_id, "message": "alterMobile", "molileAttribution": molileAttribution};
                            //记录流程日志
                            service.submitProcesslog(function (data) {
                                var errorNo = data.error_no;
                                var errorInfo = data.error_info;
                                if (errorNo == "0") {
                                    /*begin*/
                                    appUtils.setSStorageInfo("mobileno", $(_pageId + " .mobileno").val());
                                    var user_id = appUtils.getSStorageInfo("user_id");
                                    var param = {"user_id": user_id, "message": "alterAddr", "molileAttribution": molileAttribution};
                                    //记录流程日志
                                    service.submitProcesslog(function (data) {
                                        var errorNo = data.error_no;
                                        var errorInfo = data.error_info;
                                        if (errorNo == "0") {
                                            saveStep();
                                        } else {
                                            layerUtils.iAlert(errorInfo, -1);
                                        }
                                    }, param);
                                    /*end*/

                                } else {
                                    layerUtils.iAlert(errorInfo, -1);
                                }
                            }, param);
                        } else {
                            //获取应用版本
                            var molileAttribution = appUtils.getSStorageInfo("molileAttribution");
                            /*begin*/
                            appUtils.setSStorageInfo("mobileno", $(_pageId + " .mobileno").val());
                            var user_id = appUtils.getSStorageInfo("user_id");
                            var param = {"user_id": user_id, "message": "alterMobile", "molileAttribution": molileAttribution};
                            //记录流程日志
                            service.submitProcesslog(function (data) {
                                var errorNo = data.error_no;
                                var errorInfo = data.error_info;
                                if (errorNo == "0") {
                                    saveStep();
                                } else {
                                    layerUtils.iAlert(errorInfo, -1);
                                }
                            }, param);
                            /*end*/
                        }

                    } else {
                        layerUtils.iAlert(error_info, -1);
                    }
                });
            } else {
                layerUtils.iAlert(error_info, -1);
            }
        });
    }

    //清空页面信息
    function cleanPage() {
        $(_pageId + " .mobileno").html("");
        $(_pageId + " .code").html("");
        $(_pageId + " .blue_code").show();  // 显示按钮
        $(_pageId + " .get_code").hide();  // 隐藏倒计时
    }

    var msgConfirm = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = msgConfirm;
});