/**
 * 结果页
 */
define(function (require, exports, module) {
    var appUtils = require("appUtils"),
        global = require("gconfig").global,
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        layerUtils = require("layerUtils"),
        _pageId = "#account_result";
    var external = require("external");

    function init() {
        var back_step = appUtils.getSStorageInfo("back_step");  //港股通开通标志
        if (back_step == "4") {
            /*$(_pageId+" .icon").addClass("icon3");*/
            $(_pageId + " .succes_main h1").html("开通成功");
            $(_pageId + " .notice").html("恭喜您，港股通开通成功！");
            //获取应用版本
            var molileAttribution = appUtils.getSStorageInfo("molileAttribution");
            var user_id = appUtils.getSStorageInfo("user_id");
            var param = {"user_id": user_id, "message": "success", "molileAttribution": molileAttribution};
            //记录流程日志
            service.submitProcesslog(function (data) {
                var errorNo = data.error_no;
                var errorInfo = data.error_info;
                if (errorNo == "0") {
                } else {
                    layerUtils.iAlert(errorInfo, -1);
                }
            }, param);
        } else {
            //获取应用版本
            var molileAttribution = appUtils.getSStorageInfo("molileAttribution");
            var user_id = appUtils.getSStorageInfo("user_id");
            var param = {"user_id": user_id, "message": "success", "molileAttribution": molileAttribution};
            //记录流程日志
            service.submitProcesslog(function (data) {
                var errorNo = data.error_no;
                var errorInfo = data.error_info;
                if (errorNo == "0") {
                } else {
                    layerUtils.iAlert(errorInfo, -1);
                }
            }, param);
        }
    }

    function bindPageEvent() {
        appUtils.bindEvent($(_pageId + " .tel"), function () {
            appUtils.pageInit("account/result", "account/editNum", {});
        });
        //绑定返回
        appUtils.bindEvent($(_pageId + " .ce_btn"), function () {
            //是否是中焯的
            if (global.isZhongZhuo) {
                layerUtils.iConfirm("是否退出软件？", function () {
                    //退出至中焯页面
                    var param = {
                        "funcNo": "50101",
                        "moduleName": "open"
                    };
                    external.callMessage(param);
                    appUtils.clearSStorage(true);
                    $(_pageId).remove();
                });
            } else {
                layerUtils.iConfirm("是否返回主页？", function () {
                    appUtils.clearSStorage(true);
                    appUtils.setSStorageInfo("started", "true", true);
                    $(_pageId).remove();
                    appUtils.sendDirect("../open/index.html#!/business/index.html");
                });
            }
        });
    }

    function destroy() {
        service.destroy();
    }

    var result = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = result;
});