﻿/**
 * 港股通开户
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        layerUtils = require("layerUtils"),
        gconfig = require("gconfig"),
        global = gconfig.global,
        utils = require("utils"),
        shellPlugin = require("shellPlugin"),
        _pageId = "#business_index";
    var external = require("external");

    /* 私有业务模块的全局变量 end */

    function init() {
        window.getInput = utils.getInput;  // 暴露调用密码键盘给window
        window.onFinish = utils.onFinish;  // 暴露关闭密码键盘给window
        // 启动时，检查当前客户端的版本号与服务器上最新的是否一致，根据需要更新客户端，只在启动时检查，started 为 true 表示已启动，已启动就不检查
        if (appUtils.getSStorageInfo("started", true) != "true") {
            // 设置 session 中的 started 为 true ，表示已启动
            appUtils.setSStorageInfo("started", "true", true);
            //layerUtils.iLoading(true, "正在检查版本...");
            //queryVersAndAddr();  // 检查版本更新
        }
    }

    function bindPageEvent() {

        /* 绑定新开账户  */
        appUtils.bindEvent($(_pageId + " .home_btn"), function () {
            appUtils.pageInit("business/index", "account/login", {});
        });
    }

    function destroy() {
    }

    /* 查询服务器上的版本号和下载地址 */
    function queryVersAndAddr() {
        var queryParam = {
            "terminal_type": gconfig.platform == "1" ? "android" : "ios"
        };
        service.getVersion(queryParam, function (data) {
            if (data.error_no == 0) {
                layerUtils.iLoading(false);
                // 服务器有数据返回时
                if (data.results.length != 0 && data.results[0].update_url != undefined) {
                    execUpdate(data.results);  // 执行更新
                }
            }
            else  // 查询地址失败
            {
                layerUtils.iLoading(false);
                layerUtils.iAlert("版本检查失败，请稍后重试！");
            }
        }, true, false);
    }

    // 执行更新
    function execUpdate(results) {
        /*var length = results.length,
         updateParam = {
         "url" : results[0].update_url,  // 更新地址
         "versionLatest" : results[0].version,  // 最新版本号
         // 只有一条记录取 0
         "versionLowest" : results[0].version == results[length-1].version ? "0" : results[length-1].version,
         "firstEnforcement" : results[0].enforcement  // 第一条记录是否是强制更新
         };
         shellPlugin.callShellMethod("updateManagerPlugin",null,function(){
         layerUtils.iAlert("调用版本更新插件失败！");
         },updateParam);*/

        //add by fengxiang 2015-07-17 升级
        var length = results.length,
            updateParam = {
                "url": results[0].update_url,  // 更新地址
                "type": "1",
                "version": results[0].version,  // 最新版本号
                // 只有一条记录取 0
                "versionSn": results[0].version,
                "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
                "funcNo": "50201",
                "moduleName": "common",
                "source": "open"
            };
//		shellPlugin.callShellMethod("updateManagerPlugin",null,function(){
//			layerUtils.iAlert("调用版本更新插件失败！");
//		},updateParam);
        var result = external.callMessage(updateParam);
        //end by fengxiang 2015-07-17 升级
    }

    var index = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = index;
});