/**
 * 非现场手机开户前端service层调用接口
 * */
define(function (require, exports, module) {
    var appUtils = require("appUtils"),
        mobileService = "ggt/scripts/thinkive/service/mobileService";

    function MobileService() {
        this.serviceMap = {};
    }

    /***应用接口......................................................开始*/

    /**
     * 刷新资产(1004234)
     */
    MobileService.prototype.queryAccount = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryAccount(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryAccount(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };


    /**
     * 资金账号登陆
     */
    MobileService.prototype.loginAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.loginAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.loginAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 上传诚信证明照片
     */
    MobileService.prototype.uploadPhotos = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.uploadPhotos(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.uploadPhotos(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };


    /**
     * 查询信用资产
     */
    MobileService.prototype.loginNetAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.loginNetAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.loginNetAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 回显 1004237
     */
    MobileService.prototype.reviewTest = function (param, callback) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.reviewTest(param, callback);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.reviewTest(param, callback);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 风险测评获取(1004231)
     */
    MobileService.prototype.queryRiskQuestion = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryRiskQuestion(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryRiskQuestion(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 风险测评获取(1004216)
     */
    MobileService.prototype.saveUserTemp = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.saveUserTemp(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.saveUserTemp(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 风险测评获取(1004232)
     */
    MobileService.prototype.submitRiskAnswer = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitRiskAnswer(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitRiskAnswer(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 风险测评结果获取(1004233)
     */
    MobileService.prototype.queryRiskAnswer = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryRiskAnswer(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryRiskAnswer(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 修改地址和电话(1004236)
     */
    MobileService.prototype.submitMobileAddress = function (param, callBackFunc, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitMobileAddress(param, callBackFunc, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitMobileAddress(param, callBackFunc, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 记录流程日志(1004229)
     */
    MobileService.prototype.submitProcesslog = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitProcesslog(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitProcesslog(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 适当性综合得分(1004215)
     */
    MobileService.prototype.queryForeUserPG = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryForeUserPG(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryForeUserPG(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 查询问卷
     */
    MobileService.prototype.queryRiskToc = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryRiskToc(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryRiskToc(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 修改地址(1004226)
     */
    MobileService.prototype.submitAddress = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitAddress(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitAddress(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };
    /**
     * 提交风险评测答案
     */
    MobileService.prototype.submitTestAnswer = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitTestAnswer(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitTestAnswer(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 查询电子协议
     */
    MobileService.prototype.getSign = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.getSign(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.getSign(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 签署协议
     */
    MobileService.prototype.queryOpenCheckSign = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryOpenCheckSign(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryOpenCheckSign(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 查看协议内容
     */
    MobileService.prototype.getProtocolInfo = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.getProtocolInfo(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.getProtocolInfo(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 开通港股通权限
     */
    MobileService.prototype.openAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.openAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.openAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 发送手机验证码
     */
    MobileService.prototype.sendSmsCode = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.sendSmsCode(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.sendSmsCode(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 检验验证码
     */
    MobileService.prototype.checkSmsCode = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.checkSmsCode(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.checkSmsCode(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 提交修改电话号码
     */
    MobileService.prototype.submitMobileNo = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitMobileNo(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitMobileNo(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 移动客户端版本检测 (501560)
     * @param terminal_type  客户端类型
     * @param callback 回调函数
     */
    MobileService.prototype.getVersion = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.getVersion(param, callback, isLastReq, isShowWait, timeOutFunc, dataType);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.getVersion(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };


    /**
     * 保存渠道数据[2000000]
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.saveChannel = function (param, callback, isLastReq, isShowWait) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.saveChannel(param, callback, isLastReq, isShowWait);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.saveChannel(param, callback, isLastReq, isShowWait);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };


    /********************added at 2015/09/02 qq客服渠道处理**********************/
    /**
     * qq客服处理[96130407]
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.serachIsCompanyCustomer = function (param, callback, isLastReq, isShowWait) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.serachIsCompanyCustomer(param, callback, isLastReq, isShowWait);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.serachIsCompanyCustomer(param, callback, isLastReq, isShowWait);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /***应用接口......................................................结束*/

    /**
     * 释放操作
     */
    MobileService.prototype.destroy = function () {
        for (var key in this.serviceMap) {
            var service = this.serviceMap[key];
            service.destroy();
            delete this.serviceMap[key];
        }
        this.serviceMap = {};
    };

    function getInstance() {
        return new MobileService();
    }

    var service = {
        "getInstance": getInstance
    };

    // 暴露对外的接口
    module.exports = service;
});