/**
 * 非现场手机开户前端service层调用接口
 * */
define(function (require, exports, module) {
    var appUtils = require("appUtils"),
        gconfig = require("gconfig"),
        domain = require("domain"),
        layerUtils = require("layerUtils"),
        service = require("service"),
        appUtils = require("appUtils"),
        global = gconfig.global,
        serverPathTrade = global.serverPath;

    function MobileService() {
        this.service = new $.domain.Service();
    }

    /***应用接口......................................................开始*/

    /**
     * 登陆资金账号(1004201)
     */
    MobileService.prototype.loginAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004201";
        paraMap["fund_account"] = param.fund_account;
        paraMap["password"] = param.password;
        paraMap["verify_code"] = param.verify_code;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能:流程日志(1004229)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   营业编号
     */
    MobileService.prototype.submitProcesslog = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004229";
        paraMap["user_id"] = param.user_id;
        paraMap["message"] = param.message;
        paraMap["molileAttribution"] = param.molileAttribution;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };

    /**
     * 1上传，3查询，2 删除诚信证明照片
     */
    MobileService.prototype.uploadPhotos = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004235";
        paraMap["user_id"] = param.user_id;
        paraMap["question_id"] = param.question_id;
        paraMap["answer_id"] = param.answer_id;
        paraMap["image_flag"] = param.image_flag;
        paraMap["image_content"] = param.image_content;
        paraMap["operate_type"] = param.operate_type;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
        /*var paraMap = {};
         paraMap["funcNo"] = "1004235";
         paraMap["user_id"] = param.user_id;
         paraMap["question_id"] = param.question_id;
         paraMap["answer_id"] = param.answer_id;
         paraMap["image_flag"] = param.image_flag;
         paraMap["image_content"] = param.image_content;
         paraMap["operate_type"] = param.operate_type;
         paraMap["jsessionid"] = appUtils.getSStorageInfo("jsessionid");
         var isLastReq = (typeof(isLastReq)=="undefined"||isLastReq==="")?true:isLastReq;
         var isShowWait = (typeof(isShowWait)=="undefined"||isShowWait==="")?true:isShowWait;
         $.ajax({
         url : global.serverPath,
         data : paraMap,
         type : "post",
         dataType : "json",
         timeout:50000,
         async : true,
         beforeSend : function(XMLHttpRequest) {
         if (isShowWait) {
         layerUtils.iLoading(true, "请等待...");
         }
         },
         success : function(data, textStatus) {
         if (data) {
         if (callback) {
         callback(data);
         }
         } else {
         layerUtils.iMsg(-1, "后台返回数据格式不正确，请联系管理员！");
         }
         },
         complete : function(XMLHttpRequest, textStatus) {
         if (isShowWait && isLastReq) {
         layerUtils.iLoading(false);
         }
         },
         error : function(XMLHttpRequest,errorStatus) { //abort会执行error方法
         if(errorStatus == "timeout"){
         layerUtils.iAlert("请求超时，请重新提交！");
         }else{
         layerUtils.iAlert("请求发生问题：" + errorStatus + "，请重新提交！");
         }
         layerUtils.iLoading(false);
         }
         });*/
    };

    /**
     * 查询信用资产
     */
    MobileService.prototype.loginNetAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004202";
        paraMap["user_id"] = param.user_id;
        paraMap["fund_account"] = param.fund_account;
        paraMap["password"] = param.password;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 查询问卷
     */
    MobileService.prototype.queryRiskToc = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004209";
        //1：风险测评 2诚信测评 3：知识测评 4：机构风险测评 5机构诚信测评 6：机构知识测评 7查询全部
        paraMap["survey_type"] = param.survey_type;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能: 风险测评获取(1004231)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   用户id
     */
    MobileService.prototype.queryRiskQuestion = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004231";
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };

    /**
     * 功能: 提交风险测评(1004232)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   用户id
     */
    MobileService.prototype.submitRiskAnswer = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004232";
        paraMap["user_id"] = param.user_id;
        paraMap["jsondata"] = param.riskAnswers;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };

    /**
     * 问卷答案回写
     */
    MobileService.prototype.reviewTest = function (param, callback) {
        var paraMap = {};
        paraMap["funcNo"] = "1004237";
        paraMap["user_id"] = param.user_id;
        paraMap["survey_type"] = param.survey_type;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 提交电话号码和地址修改
     */
    MobileService.prototype.submitMobileAddress = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004236";
        paraMap["user_id"] = param.user_id;
        paraMap["contact_mobile"] = param.contact_mobile;
        paraMap["address"] = param.address;
        paraMap["trdpwd"] = param.trdpwd;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能: 风险测评结果获取(1004233)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   用户id
     */
    MobileService.prototype.queryRiskAnswer = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004233";
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc);
    };
    /**
     * 功能:用户适当性评估(1004215)
     * 入参: callBackFunc: 回调函数
     *         user_id：客户编号
     */
    MobileService.prototype.queryForeUserPG = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004215";
        paraMap["user_id"] = param.user_id;
        paraMap["marketvalue"] = param.marketvalue;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc);
    };
    /**
     * 功能:保存用户步骤(1004216)
     * 入参: callBackFunc: 回调函数
     *         user_id：客户编号
     */
    MobileService.prototype.saveUserTemp = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004216";
        paraMap["user_id"] = param.user_id;
        paraMap["current_step"] = param.current_step;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc);
    };
    /**
     * 提交风险评测答案
     */
    MobileService.prototype.submitTestAnswer = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004210";
        //1：风险测评 2诚信测评 3：知识测评 4：机构风险测评 5机构诚信测评 6：机构知识测评 7查询全部
        paraMap["survey_type"] = param.survey_type;
        paraMap["user_id"] = param.user_id;
        paraMap["answer_str"] = param.answer_str;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 查询协议
     */
    MobileService.prototype.getSign = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004203";
        paraMap["category_englishname"] = param.category_englishname;
        paraMap["category_no"] = param.category_no;
        paraMap["econtract_no"] = param.econtract_no;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 签署协议
     */
    MobileService.prototype.queryOpenCheckSign = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004225";
        paraMap["user_id"] = param.user_id;
        paraMap["jsondata"] = param.jsondata;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能: 刷新证券资产(1004234)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   用户id
     */
    MobileService.prototype.queryAccount = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004234";
        paraMap["user_id"] = param.user_id;
        paraMap["fundid"] = param.fundid;
        paraMap["orgid"] = param.orgid;
        paraMap["trdpwd"] = param.trdpwd;
        paraMap["custcert"] = param.custcert;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };

    /**
     * 查看协议内容
     */
    MobileService.prototype.getProtocolInfo = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004204";
        paraMap["econtract_no"] = param.econtract_no;
        paraMap["econtract_version"] = param.econtract_version;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 开通港股通权限
     */
    MobileService.prototype.openAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004221";
        paraMap["user_id"] = param.user_id;
        paraMap["trade_pwd"] = param.trade_pwd;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 发送验证码
     */
    MobileService.prototype.sendSmsCode = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004222";
        paraMap["mobile_no"] = param.mobile_no;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 检验验证码
     */
    MobileService.prototype.checkSmsCode = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004223";
        paraMap["mobile_no"] = param.mobile_no;
        paraMap["mobile_code"] = param.mobile_code;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 提交电话号码修改
     */
    MobileService.prototype.submitMobileNo = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004224";
        paraMap["user_id"] = param.user_id;
        paraMap["contact_mobile"] = param.contact_mobile;
        paraMap["trdpwd"] = param.trdpwd;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能:修改用户联系地址和联系方式(1004226)
     * 入参: callBackFunc: 回调函数
     */
    MobileService.prototype.submitAddress = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004226";
        paraMap["user_id"] = param.user_id;
        paraMap['trdpwd'] = param.trdpwd;
        paraMap["address"] = param.address;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };

    /**
     * add by fengxiang 2015-08-11
     * 移动客户端版本检测 (501560)
     *
     * @param terminal_type
     *            客户端类型
     * @param callback
     *            回调函数
     */
    MobileService.prototype.getVersion = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "501560";
        paraMap["terminal_type"] = param.terminal_type;
        paraMap["by_type"] = param.by_type;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        // reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 保存渠道数据[2000000]
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.saveChannel = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "2000000";
        paraMap["channela"] = param.channela;
        paraMap["channelb"] = param.channelb;
        paraMap["channelc"] = param.channelc;
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        this.service.invoke(reqParamVo, callback);
    };

    /********************added at 2015/09/02 qq客服渠道处理**********************/
    /**
     * qq客服处理[96130407]
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.serachIsCompanyCustomer = function (param, callback) {
        var paraMap = {};
        paraMap["funcNo"] = "96130407";
        paraMap["user_id"] = param.userid;
        paraMap["branchno"] = param.branchno;
        paraMap["brokersno"] = param.brokersno;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        this.service.invoke(reqParamVo, callback);
    };


    /***应用接口......................................................结束*/

    /* 释放操作*/
    MobileService.prototype.destroy = function () {
        this.service.destroy();
    };

    /* 实例化对象 */
    function getInstance() {
        return new MobileService();
    }

    var mobileService = {
        "getInstance": getInstance
    };

    // 暴露对外的接口
    module.exports = mobileService;
});