/**
 * 非现场手机开户前端service层调用接口
 * */
define(function (require, exports, module) {
    var appUtils = require("appUtils"),
        mobileService = "modifyInfo/scripts/thinkive/service/mobileService";

    function MobileService() {
        this.serviceMap = {};
    }

    /***应用接口......................................................开始*/

    /*add 20150909*/

    /**
     * 驳回后修改资料 (501561)
     *
     * @param user_id
     *            用户编号
     * @param fieldname
     *            驳回步骤(zj_pwd资金密码、trade_pwd交易密码、bind_bank三方存管、photo图片、workflowagain重新走流程、opacctkind_flag开户流程业务类型)
     * @param callback
     *            回调函数
     */
    MobileService.prototype.rejectStep = function (param, callback, isLastReq, isShowWait) {
        var service = this.serviceMap[service];
        if (service) {
            service.rejectStep(param, callback, isLastReq, isShowWait);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[service] = service;
                    service.rejectStep(param, callback, isLastReq,
                        isShowWait);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    //流程控制
    MobileService.prototype.recordProcess = function (param, callback, isLastReq, isShowWait) {
        var service = this.serviceMap[service];
        if (service) {
            service.recordProcess(param, callback, isLastReq, isShowWait);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[service] = service;
                    service.recordProcess(param, callback, isLastReq,
                        isShowWait);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /*end*/

    /**
     * 获取籍贯的省市信息(96130311)
     *
     * @param funcNo
     *            功能号
     * @param callback
     *            回调函数
     */
    MobileService.prototype.getProvinceAndCity = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[service];
        if (service) {
            service.getProvinceAndCity(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[service] = service;
                    service.getProvinceAndCity(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 获取rsa加密模块和公钥
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.getRSAKey = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[service];
        if (service) {
            service.getRSAKey(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[service] = service;
                    service.getRSAKey(param, callback,
                        isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 功能: 修改用户流程完成标识1004028
     * 入参：user_id：用户编号(Y)
     */
    MobileService.prototype.modifyUserFinishFlag = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[service];
        if (service) {
            service.modifyUserFinishFlag(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[service] = service;
                    service.modifyUserFinishFlag(param, callback,
                        isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 查询离线视频通过状态查询 (501546)
     *
     * @param user_id
     *            用户ID
     * @param callback
     *            回调函数
     */
    MobileService.prototype.queryQQOfflineState = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[service];
        if (service) {
            service.queryQQOfflineState(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[service] = service;
                    service.queryQQOfflineState(param, callback,
                        isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 功能: 初始化股东号信息及开基金信息1004026
     * 入参：user_id：用户编号(Y)
     */
    MobileService.prototype.queryAccountUpdateData = function (callBackFunc, param, isLastReq) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryAccountUpdateData(callBackFunc, param, isLastReq);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryAccountUpdateData(callBackFunc, param, isLastReq);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 功能: 增开结果查询1004023
     * 入参：user_id：用户编号(Y)
     */
    MobileService.prototype.queryAccountInfoCurrent = function (callBackFunc, param, isLastReq) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryAccountInfoCurrent(callBackFunc, param, isLastReq);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryAccountInfoCurrent(callBackFunc, param, isLastReq);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 功能: 查询用户1004021
     * 入参：user_id：用户编号(Y)
     */
    MobileService.prototype.queryAccountInfo = function (callBackFunc, param, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryAccountInfo(callBackFunc, param, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryAccountInfo(callBackFunc, param, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 刷新资产(1004234)
     */
    MobileService.prototype.queryAccount = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryAccount(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryAccount(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };


    /**
     * 资金账号登陆
     */
    MobileService.prototype.loginAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.loginAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.loginAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 获取数据字典
     *
     * @param enum_type
     *            "occupational"为职业,"adapter"为学历,"zqzhlx"为开通证券类型
     * @param callback
     *            回调函数
     */
    MobileService.prototype.queryDataDict = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryDataDict(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryDataDict(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /*
     * 用户信息确认
     */
    MobileService.prototype.updateUserInfoByTrade = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.updateUserInfoByTrade(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.updateUserInfoByTrade(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 功能: 开立股东，基金账号或者加挂1004027
     * 入参：user_id：用户编号(Y)
     *        handle_str: 加挂或开户信息字符串(Y)
     *                格式：stkbd,stkacct,handle_type|stkbd,stkacct|handle_type|...(stkbd:交易板块，stkacct股东代码，handle_type操作类型0：开户，1加挂)
     */
    MobileService.prototype.submitUserSelectAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitUserSelectAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitUserSelectAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 查询电子协议列表(501558)
     *
     * @param category_englishname
     *            电子协议英文名
     * @param category_no
     *            类别编号
     * @param econtract_no
     *            协议编号
     * @param callback
     *            回调函数
     */
    MobileService.prototype.queryProtocolList = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[service];
        if (service) {
            service.queryProtocolList(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[service] = service;
                    service.queryProtocolList(param, callback,
                        isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 获取视频ip [96130315]
     *
     * @param funcNo
     *            功能号
     * @param user_id
     *            客户编号
     * @param callback
     *            回调函数
     */
    MobileService.prototype.getVedioIp = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.getVedioIp(param, callback, isLastReq, isShowWait,
                timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.getVedioIp(param, callback, isLastReq,
                        isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 上传诚信证明照片
     */
    MobileService.prototype.uploadPhotos = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.uploadPhotos(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.uploadPhotos(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };


    /**
     * 查询信用资产
     */
    MobileService.prototype.loginNetAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.loginNetAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.loginNetAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 回显 1004237
     */
    MobileService.prototype.reviewTest = function (param, callback) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.reviewTest(param, callback);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.reviewTest(param, callback);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 风险测评获取(1004231)
     */
    MobileService.prototype.queryRiskQuestion = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryRiskQuestion(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryRiskQuestion(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 风险测评获取(1004216)
     */
    MobileService.prototype.saveUserTemp = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.saveUserTemp(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.saveUserTemp(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 风险测评获取(1004232)
     */
    MobileService.prototype.submitRiskAnswer = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitRiskAnswer(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitRiskAnswer(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 风险测评结果获取(1004233)
     */
    MobileService.prototype.queryRiskAnswer = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryRiskAnswer(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryRiskAnswer(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 修改地址和电话(1004236)
     */
    MobileService.prototype.submitMobileAddress = function (param, callBackFunc, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitMobileAddress(param, callBackFunc, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitMobileAddress(param, callBackFunc, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 记录流程日志(1004229)
     */
    MobileService.prototype.submitProcesslog = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitProcesslog(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitProcesslog(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 适当性综合得分(1004215)
     */
    MobileService.prototype.queryForeUserPG = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryForeUserPG(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryForeUserPG(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 查询问卷
     */
    MobileService.prototype.queryRiskToc = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryRiskToc(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryRiskToc(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 修改地址(1004226)
     */
    MobileService.prototype.submitAddress = function (callBackFunc, param) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitAddress(callBackFunc, param);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitAddress(callBackFunc, param);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };
    /**
     * 提交风险评测答案
     */
    MobileService.prototype.submitTestAnswer = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitTestAnswer(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitTestAnswer(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 查询电子协议
     */
    MobileService.prototype.getSign = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.getSign(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.getSign(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 签署协议
     */
    MobileService.prototype.queryOpenCheckSign = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.queryOpenCheckSign(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.queryOpenCheckSign(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 查看协议内容
     */
    MobileService.prototype.getProtocolInfo = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.getProtocolInfo(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.getProtocolInfo(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 开通港股通权限
     */
    MobileService.prototype.openAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.openAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.openAccount(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 发送手机验证码
     */
    MobileService.prototype.sendSmsCode = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.sendSmsCode(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.sendSmsCode(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 检验验证码
     */
    MobileService.prototype.checkSmsCode = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.checkSmsCode(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.checkSmsCode(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 提交修改电话号码
     */
    MobileService.prototype.submitMobileNo = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.submitMobileNo(param, callback, isLastReq, isShowWait, timeOutFunc);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.submitMobileNo(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /**
     * 移动客户端版本检测 (501560)
     * @param terminal_type  客户端类型
     * @param callback 回调函数
     */
    MobileService.prototype.getVersion = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.getVersion(param, callback, isLastReq, isShowWait, timeOutFunc, dataType);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.getVersion(param, callback, isLastReq, isShowWait, timeOutFunc);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };


    /**
     * 保存渠道数据[2000000]
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.saveChannel = function (param, callback, isLastReq, isShowWait) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.saveChannel(param, callback, isLastReq, isShowWait);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.saveChannel(param, callback, isLastReq, isShowWait);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };


    /********************added at 2015/09/02 qq客服渠道处理**********************/
    /**
     * qq客服处理[96130407]
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.serachIsCompanyCustomer = function (param, callback, isLastReq, isShowWait) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.serachIsCompanyCustomer(param, callback, isLastReq, isShowWait);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.serachIsCompanyCustomer(param, callback, isLastReq, isShowWait);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /********************added at 2016/02/25 照片回显**********************/
    /**
     * 照片回显 [96130313]
     * @param funcNo 功能号
     * @param user_id  客户编号
     * @param callback 回调函数
     */
    MobileService.prototype.getPhoto = function (param, callback, isLastReq, isShowWait) {
        var service = this.serviceMap[mobileService];
        if (service) {
            service.getPhoto(param, callback, isLastReq, isShowWait);
        } else {
            var This = this;
            require.async(mobileService, function (module) {
                if (module) {
                    service = module.getInstance();
                    This.serviceMap[mobileService] = service;
                    service.getPhoto(param, callback, isLastReq, isShowWait);
                } else {
                    alert("服务层，js模块类[" + mobileService + "]不存在!");
                }
            });
        }
    };

    /***应用接口......................................................结束*/

    /**
     * 释放操作
     */
    MobileService.prototype.destroy = function () {
        for (var key in this.serviceMap) {
            var service = this.serviceMap[key];
            service.destroy();
            delete this.serviceMap[key];
        }
        this.serviceMap = {};
    };

    function getInstance() {
        return new MobileService();
    }

    var service = {
        "getInstance": getInstance
    };

    // 暴露对外的接口
    module.exports = service;
});