/**
 * 非现场手机开户前端service层调用接口
 * */
define(function (require, exports, module) {
    var appUtils = require("appUtils"),
        gconfig = require("gconfig"),
        domain = require("domain"),
        layerUtils = require("layerUtils"),
        service = require("service"),
        appUtils = require("appUtils"),
        global = gconfig.global,
        serverPathTrade = global.serverPath;

    function MobileService() {
        this.service = new $.domain.Service();
    }

    /***应用接口......................................................开始*/

    /*add 20150909*/

    /**
     * 驳回后修改资料 (501561)
     *
     * @param userid
     *            用户编号
     * @param fieldname
     *            驳回步骤(zj_pwd资金密码、trade_pwd交易密码、bind_bank三方存管、photo图片、workflowagain重新走流程、opacctkind_flag开户流程业务类型)
     * @param callback
     *            回调函数
     */
    MobileService.prototype.rejectStep = function (param, callback, isLastReq, isShowWait) {
        var paraMap = {};
        paraMap["funcNo"] = "501561";
        paraMap["userid"] = param.userid;
        paraMap["fieldname"] = param.fieldname;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        this.service.invoke(reqParamVo, callback);
    };

    //流程控制步骤
    MobileService.prototype.recordProcess = function (param, callback, isLastReq, isShowWait) {
        var paraMap = {};
        paraMap["funcNo"] = "1004234";
        paraMap["user_id"] = param.user_id;
        paraMap["next_step"] = param.next_step;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        this.service.invoke(reqParamVo, callback);
    };


    /*end*/

    /**
     * 获取籍贯的省市信息(96130311)
     *
     * @param funcNo
     *            功能号
     * @param callback
     *            回调函数
     */
    MobileService.prototype.getProvinceAndCity = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "96130311";
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 获取rsa加密模块和公钥
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.getRSAKey = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1000000";
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能: 修改用户流程完成标识1004028
     * 入参：user_id：用户编号(Y)
     */
    MobileService.prototype.modifyUserFinishFlag = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004028";
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 查询离线视频通过状态查询 (501546)
     *
     * @param user_id
     *            用户ID
     * @param callback
     *            回调函数
     */
    MobileService.prototype.queryQQOfflineState = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "501546";
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能: 初始化股东号信息及开基金信息1004026
     * 入参：user_id：用户编号(Y)
     */
    MobileService.prototype.queryAccountUpdateData = function (callBackFunc, param, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004026";
        paraMap["user_id"] = param.user_id;
        paraMap["op_source"] = global.op_source;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callBackFunc);
    };

    /**
     * 功能: 增开结果查询1004023
     * 入参：user_id：用户编号(Y)
     */
    MobileService.prototype.queryAccountInfoCurrent = function (callBackFunc, param, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004023";
        paraMap["user_id"] = param.user_id;
        paraMap["op_source"] = global.op_source;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callBackFunc);
    };

    /**
     * 功能: 查询用户1004021
     * 入参：user_id：用户编号(Y)
     */
    MobileService.prototype.queryAccountInfo = function (callBackFunc, param, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004021";
        paraMap["user_id"] = param.user_id;
        paraMap["op_source"] = global.op_source;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callBackFunc);
    };

    /**
     * 登陆资金账号(1004201)
     * again: 用户是否选择再一次办理该业务 //正常登陆传0   ， 若已完成流程，用户选择再次办理业务 传1
     */
    MobileService.prototype.loginAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004020";
        paraMap["fund_account"] = param.fund_account;
        paraMap["password"] = param.password;
        paraMap["again"] = param.again;
        paraMap["verify_code"] = param.verify_code;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 获取数据字典
     *
     * @param enum_type
     *            "occupational"为职业,"adapter"为学历,"zqzhlx"为开通证券类型
     * @param callback
     *            回调函数
     */
    MobileService.prototype.queryDataDict = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "501501";
        paraMap["enum_type"] = param.enum_type;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /*
     * 用户信息确认
     */
    MobileService.prototype.updateUserInfoByTrade = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004030";
        paraMap["user_id"] = param.user_id;
        paraMap["custname"] = param.custname;
        paraMap["addr"] = param.addr;
        paraMap["mobileno"] = param.mobileno;
        paraMap["code"] = param.code;
        paraMap["idbegindate"] = param.idbegindate;
        paraMap["idenddate"] = param.idenddate;
        paraMap["mobversion"] = param.mobversion;
        paraMap["idno"] = param.idno;
        paraMap["policeorg"] = param.policeorg;
        paraMap["native"] = param.native;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能: 开立股东，基金账号或者加挂1004027
     * 入参：user_id：用户编号(Y)
     *        handle_str: 加挂或开户信息字符串(Y)
     *                格式：stkbd,stkacct,handle_type|stkbd,stkacct|handle_type|...(stkbd:交易板块，stkacct股东代码，handle_type操作类型0：开户，1加挂)
     */
    MobileService.prototype.submitUserSelectAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004027";
        paraMap["user_id"] = param.user_id;
        paraMap["handle_str"] = param.handle_str;
        paraMap["op_source"] = global.op_source;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 查询电子协议列表(501558)
     *
     * @param category_englishname
     *            电子协议英文名
     * @param category_no
     *            类别编号
     * @param econtract_no
     *            协议编号
     * @param callback
     *            回调函数
     */
    MobileService.prototype.queryProtocolList = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "501558";
        paraMap["category_englishname"] = param.category_englishname;
        paraMap["category_no"] = param.category_no;
        paraMap["econtract_no"] = param.econtract_no;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 获取视频ip [96130315]
     *
     * @param funcNo
     *            功能号
     * @param user_id
     *            客户编号
     * @param callback
     *            回调函数
     */
    MobileService.prototype.getVedioIp = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "96130315";
        paraMap["addrtype"] = param.addrtype;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能:流程日志(1004229)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   营业编号
     */
    MobileService.prototype.submitProcesslog = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004229";
        paraMap["user_id"] = param.user_id;
        paraMap["message"] = param.message;
        paraMap["molileAttribution"] = param.molileAttribution;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };

    /**
     * 1上传，3查询，2 删除诚信证明照片
     */
    MobileService.prototype.uploadPhotos = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004235";
        paraMap["user_id"] = param.user_id;
        paraMap["question_id"] = param.question_id;
        paraMap["answer_id"] = param.answer_id;
        paraMap["image_flag"] = param.image_flag;
        paraMap["image_content"] = param.image_content;
        paraMap["operate_type"] = param.operate_type;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
        /*var paraMap = {};
         paraMap["funcNo"] = "1004235";
         paraMap["user_id"] = param.user_id;
         paraMap["question_id"] = param.question_id;
         paraMap["answer_id"] = param.answer_id;
         paraMap["image_flag"] = param.image_flag;
         paraMap["image_content"] = param.image_content;
         paraMap["operate_type"] = param.operate_type;
         paraMap["jsessionid"] = appUtils.getSStorageInfo("jsessionid");
         var isLastReq = (typeof(isLastReq)=="undefined"||isLastReq==="")?true:isLastReq;
         var isShowWait = (typeof(isShowWait)=="undefined"||isShowWait==="")?true:isShowWait;
         $.ajax({
         url : global.serverPath,
         data : paraMap,
         type : "post",
         dataType : "json",
         timeout:50000,
         async : true,
         beforeSend : function(XMLHttpRequest) {
         if (isShowWait) {
         layerUtils.iLoading(true, "请等待...");
         }
         },
         success : function(data, textStatus) {
         if (data) {
         if (callback) {
         callback(data);
         }
         } else {
         layerUtils.iMsg(-1, "后台返回数据格式不正确，请联系管理员！");
         }
         },
         complete : function(XMLHttpRequest, textStatus) {
         if (isShowWait && isLastReq) {
         layerUtils.iLoading(false);
         }
         },
         error : function(XMLHttpRequest,errorStatus) { //abort会执行error方法
         if(errorStatus == "timeout"){
         layerUtils.iAlert("请求超时，请重新提交！");
         }else{
         layerUtils.iAlert("请求发生问题：" + errorStatus + "，请重新提交！");
         }
         layerUtils.iLoading(false);
         }
         });*/
    };

    /**
     * 查询信用资产
     */
    MobileService.prototype.loginNetAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004202";
        paraMap["user_id"] = param.user_id;
        paraMap["fund_account"] = param.fund_account;
        paraMap["password"] = param.password;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 查询问卷
     */
    MobileService.prototype.queryRiskToc = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004209";
        //1：风险测评 2诚信测评 3：知识测评 4：机构风险测评 5机构诚信测评 6：机构知识测评 7查询全部
        paraMap["survey_type"] = param.survey_type;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能: 风险测评获取(1004231)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   用户id
     */
    MobileService.prototype.queryRiskQuestion = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "501539";
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };

    /**
     * 功能: 提交风险测评(1004232)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   用户id
     */
    MobileService.prototype.submitRiskAnswer = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004232";
        paraMap["user_id"] = param.user_id;
        paraMap["jsondata"] = param.riskAnswers;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };

    /**
     * 问卷答案回写
     */
    MobileService.prototype.reviewTest = function (param, callback) {
        var paraMap = {};
        paraMap["funcNo"] = "1004237";
        paraMap["user_id"] = param.user_id;
        paraMap["survey_type"] = param.survey_type;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 提交电话号码和地址修改
     */
    MobileService.prototype.submitMobileAddress = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004236";
        paraMap["user_id"] = param.user_id;
        paraMap["contact_mobile"] = param.contact_mobile;
        paraMap["address"] = param.address;
        paraMap["trdpwd"] = param.trdpwd;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能: 风险测评结果获取(1004233)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   用户id
     */
    MobileService.prototype.queryRiskAnswer = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004233";
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc);
    };
    /**
     * 功能:用户适当性评估(1004215)
     * 入参: callBackFunc: 回调函数
     *         user_id：客户编号
     */
    MobileService.prototype.queryForeUserPG = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004215";
        paraMap["user_id"] = param.user_id;
        paraMap["marketvalue"] = param.marketvalue;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc);
    };
    /**
     * 功能:保存用户步骤(1004216)
     * 入参: callBackFunc: 回调函数
     *         user_id：客户编号
     */
    MobileService.prototype.saveUserTemp = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004216";
        paraMap["user_id"] = param.user_id;
        paraMap["current_step"] = param.current_step;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc);
    };
    /**
     * 提交风险评测答案
     */
    MobileService.prototype.submitTestAnswer = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "501540";
        paraMap["user_id"] = param.user_id;
        paraMap["sub_id"] = param.sub_id;
        paraMap["q_a_args"] = param.q_a_args;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 查询协议
     */
    MobileService.prototype.getSign = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "501558";
        paraMap["category_englishname"] = param.category_englishname;
        paraMap["category_no"] = param.category_no;
        paraMap["econtract_no"] = param.econtract_no;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 签署协议
     */
    MobileService.prototype.queryOpenCheckSign = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "501554";
        paraMap["user_id"] = param.user_id;
        paraMap["jsondata"] = param.jsondata;
        paraMap["checksign"] = param.checksign;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能: 刷新证券资产(1004234)
     * 入参: callBackFunc: 回调函数
     *    param.user_id   用户id
     */
    MobileService.prototype.queryAccount = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004234";
        paraMap["user_id"] = param.user_id;
        paraMap["fundid"] = param.fundid;
        paraMap["orgid"] = param.orgid;
        paraMap["trdpwd"] = param.trdpwd;
        paraMap["custcert"] = param.custcert;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };

    /**
     * 查看协议内容
     */
    MobileService.prototype.getProtocolInfo = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "501559";
        paraMap["econtract_no"] = param.econtract_no;
        paraMap["econtract_version"] = param.econtract_version;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 开通港股通权限
     */
    MobileService.prototype.openAccount = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004221";
        paraMap["user_id"] = param.user_id;
        paraMap["trade_pwd"] = param.trade_pwd;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 发送验证码
     */
    MobileService.prototype.sendSmsCode = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004031";
        paraMap["mobileno"] = param.mobile_no;
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 检验验证码
     */
    MobileService.prototype.checkSmsCode = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004223";
        paraMap["mobile_no"] = param.mobile_no;
        paraMap["mobile_code"] = param.mobile_code;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 提交电话号码修改
     */
    MobileService.prototype.submitMobileNo = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "1004224";
        paraMap["user_id"] = param.user_id;
        paraMap["contact_mobile"] = param.contact_mobile;
        paraMap["trdpwd"] = param.trdpwd;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 功能:修改用户联系地址和联系方式(1004226)
     * 入参: callBackFunc: 回调函数
     */
    MobileService.prototype.submitAddress = function (callBackFunc, param) {
        var paraMap = {};
        paraMap["funcNo"] = "1004226";
        paraMap["user_id"] = param.user_id;
        paraMap['trdpwd'] = param.trdpwd;
        paraMap["address"] = param.address;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        this.service.invoke(reqParamVo, callBackFunc, false);
    };


    /**
     * add by fengxiang 2015-08-11
     * 移动客户端版本检测 (501560)
     *
     * @param terminal_type
     *            客户端类型
     * @param callback
     *            回调函数
     */
    MobileService.prototype.getVersion = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "501560";
        paraMap["terminal_type"] = param.terminal_type;
        paraMap["by_type"] = param.by_type;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        // reqParamVo.setTimeOutFunc(timeOutFunc);
        this.service.invoke(reqParamVo, callback);
    };

    /**
     * 保存渠道数据[2000000]
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.saveChannel = function (param, callback, isLastReq, isShowWait, timeOutFunc) {
        var paraMap = {};
        paraMap["funcNo"] = "2000000";
        paraMap["channela"] = param.channela;
        paraMap["channelb"] = param.channelb;
        paraMap["channelc"] = param.channelc;
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        this.service.invoke(reqParamVo, callback);
    };
    /********************added at 2015/09/02 qq客服渠道处理**********************/
    /**
     * qq客服处理[96130407]
     * @param param  参数
     * @param callback 回调函数
     */
    MobileService.prototype.serachIsCompanyCustomer = function (param, callback) {
        var paraMap = {};
        paraMap["funcNo"] = "96130407";
        paraMap["user_id"] = param.userid;
        paraMap["branchno"] = param.branchno;
        paraMap["brokersno"] = param.brokersno;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        this.service.invoke(reqParamVo, callback);
    };

    /********************added at 2016/02/25 照片回显**********************/
    /**
     * 照片回显 [96130313]
     * @param funcNo 功能号
     * @param user_id  客户编号
     * @param callback 回调函数
     */
    MobileService.prototype.getPhoto = function (param, callback) {
        var paraMap = {};
        paraMap["funcNo"] = "96130313";
        paraMap["user_id"] = param.user_id;
        var reqParamVo = $.getReqParamVo();
        reqParamVo.setUrl(global.serverPath);
        reqParamVo.setReqParam(paraMap);
        reqParamVo.setIsLastReq((typeof(isLastReq) == "undefined" || isLastReq === "") ? true : isLastReq);
        reqParamVo.setIsShowWait((typeof(isShowWait) == "undefined" || isShowWait === "") ? true : isShowWait);
        this.service.invoke(reqParamVo, callback);
    };

    /***应用接口......................................................结束*/

    /* 释放操作*/
    MobileService.prototype.destroy = function () {
        this.service.destroy();
    };

    /* 实例化对象 */
    function getInstance() {
        return new MobileService();
    }

    var mobileService = {
        "getInstance": getInstance
    };

    // 暴露对外的接口
    module.exports = mobileService;
});