/**
 * 数字证书
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),
    // 业务层接口，请求数据
        global = require("gconfig").global,
        utils = require("utils"),
        layerUtils = require("layerUtils"),
        _pageId = "#account_digitalCertificate",
        downloadProgressInterval = null;

    var external = require("external");
    /* 私有业务模块的全局变量 end */

    function init() {
        layerUtils.iLoading(false); // 证书下载页屏蔽系统等待层
        upload_cert(); // 下载安装证书
    }

    function bindPageEvent() {
        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            var branchID = appUtils.getSStorageInfo("bid");
            var brokersno = appUtils.getSStorageInfo("recommendno");
            if (branchID == undefined) {
                branchID = "";
            }
            if (brokersno == undefined) {
                brokersno = "";
            }
            //如有选择了营业部或经纪人则需要传
            var param1 = {
                "userid": appUtils.getSStorageInfo("user_id"),
                "branchno": "",
                "brokersno": ""
            }
            /*  added at 2015/09/02
             *  入参： user_id （客户id）
             出参：调用成功有两种情况，
             1.如果属于中焯渠道 会返回 status=1
             2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
            service.serachIsCompanyCustomer(param1, function (data) {
                var error_no = data.error_no,
                    error_info = data.error_info;
                if (error_no == "0") {
                    var status = data.results[0].status;
                    if (status == "0") {
                        $(".ly_shadow").show();
                        var branchname = data.results[0].branchname;
                        var brokersname = data.results[0].brokersname;
                        var servicephone = data.results[0].servicephone;
                        var brokersphone = data.results[0].brokersphone;
                        var address = data.results[0].address;
                        var info = "";
                        //有经纪人的
                        if (!!brokersname) {
                            info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                            branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                            info += branchno_info;
                            $(".btn_bot p").html(info);
                            //监听营业部电话事件
                            appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话

                                e.stopPropagation(); // 阻止冒泡
                            });
                            //监听经纪人电话事件
                            appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            //监听统一电话事件
                            appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            appUtils.bindEvent(".btn_box", function (e) {
                                $(".ly_shadow").hide();
                                e.stopPropagation(); // 阻止冒泡
                            });
                        } else {//无经纪人的
                            info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                            branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                            info += branchno_info;
                            $(".btn_bot p").html(info);
                            //监听营业部电话事件
                            appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            //监听统一电话事件
                            appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            appUtils.bindEvent(".btn_box", function (e) {
                                $(".ly_shadow").hide();
                                e.stopPropagation(); // 阻止冒泡
                            });
                        }
                    } else {
                        if (require("gconfig").platform != "1") {
                            //ios 获取软件是否安装
                            var param = {
                                "funcNo": "50200",
                                "moduleName": "open",
                                "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            };
                            var result = external.callMessage(param);
                            if (result.error_no == 0) {
                                var isInstall = result.results[0].isInstall;
                                //是否安装(0：否，1：是）
                                if (isInstall == "1") {
                                    var param = {
                                        "funcNo": "50109",
                                        "moduleName": "open",
                                        "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                        //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                    };
                                    external.callMessage(param);
                                } else {
                                    layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                        //进入appstore
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                        };
                                        external.callMessage(param);
                                    }, null, "下载", "取消");
                                }
                            } else {
                                layerUtils.iAlert("检测QQ失败");
                            }
                        } else {
                            var param = {
                                "funcNo": "50109",
                                "moduleName": "open",
                                //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                            };
                            external.callMessage(param);
                        }
                    }
                } else {
                    layerUtils.iAlert(error_info);
                }
            });
        });


        appUtils.bindEvent($(_pageId + " .cert_down a"),
            function (e) {
                $(_pageId + " .qa_list").slideDown("fast");
                e.stopPropagation();
            });

        appUtils.bindEvent($(_pageId),
            function (e) {
                $(_pageId + " .qa_list").slideUp("fast");
                e.stopPropagation();
            });
    }

    function destroy() {
        $(_pageId + " .order_succes").show();
        $(_pageId + " .cert_down").hide();
        $(_pageId + " #next_btn a").html("请稍后...");
        $(_pageId + " #next_btn").attr("class", "ce_btn");
        service.destroy();
    }

    /* 下载证书并安装 */
    function upload_cert() {
        // 下载证书，创建10位随机数
        var createKeyRandom = "1";
        for (var i = 0; i < 9; i++) {
            createKeyRandom += parseInt(Math.random() * 10) + "";
        }
        // 证书申请串，数据来源于壳子
        var pkcs10 = "",
            createKeyParam = {
                "funcNo": "60003",
                "moduleName": "open",
                "rodam": createKeyRandom,
                "userId": appUtils.getSStorageInfo("user_id"),
                "key": "stockDelegateTradeSys"
            };

        //add by fengxiang 2015-07-17 升级
        var result = external.callMessage(createKeyParam);
        var error_no = result.error_no;
        var data = result.results[0];
        if (error_no == "0") {
            pkcs10 = data.pkcs10;
            // 中登证书
            var param = {
                "user_id": appUtils.getSStorageInfo("user_id"),
                "pkcs10": pkcs10
            };
            var cert_type = ""; // 证书类型
            // 新开调用中登证书
            if (appUtils.getSStorageInfo("openChannel") == "new") {
                cert_type = "zd";
                service.queryCompyCart(param,
                    function (data) {
                        callcert(data, cert_type);
                    },
                    true, false, handleTimeout);
            } else if (appUtils.getSStorageInfo("openChannel") == "change") {
                cert_type = "tw";
                service.queryMyselfCart(param,
                    function (data) {
                        callcert(data, cert_type);
                    },
                    true, false, handleTimeout);
            }
        } else {
            install_failed(); // 安装证书失败回调
        }
        //end by fengxiang 2015-07-17 升级

        // 调用壳子的方法生成证书申请串
        /*shellPlugin.callShellMethod("createKeyPlugin", function(data) {
         pkcs10 = data.pkcs10;
         // 中登证书
         var param = {
         "user_id": appUtils.getSStorageInfo("user_id"),
         "pkcs10": pkcs10
         };
         var cert_type = ""; // 证书类型
         // 新开调用中登证书
         if (appUtils.getSStorageInfo("openChannel") == "new") {
         cert_type = "zd";
         service.queryCompyCart(param,
         function(data) {
         callcert(data, cert_type);
         },
         true, false, handleTimeout);
         } else if (appUtils.getSStorageInfo("openChannel") == "change") {
         cert_type = "tw";
         service.queryMyselfCart(param,
         function(data) {
         callcert(data, cert_type);
         },
         true, false, handleTimeout);
         }
         },
         install_failed, createKeyParam);*/
    }

    /* 安装证书回调方法 */
    function callcert(data, cert_type) {
        var error_no = data.error_no;
        var error_info = data.error_info;
        if (error_no == "0" && data.results.length != 0) {
            var certParam = {
                // 获取证书的内容
                "funcNo": "60004",
                "moduleName": "open",
                "content": data.results[0].p7cert,
                "userId": appUtils.getSStorageInfo("user_id"),
                "pwd": appUtils.getSStorageInfo("pwd"),
                "type": cert_type
            };
            //add by fengxiang 2015-07-17 升级
            // 壳子读取证书，然后安装证书
            var result = external.callMessage(certParam);
            var error_no = result.error_no;
            var data = result.results[0];
            if (error_no == "0") {
                $(_pageId + " .cert_down .cert_stat").html("安装完成");
                $(_pageId + " .order_succes").hide();
                $(_pageId + " .cert_down").show();
                $(_pageId + " #next_btn").attr("class", "ct_btn");
                if (appUtils.getSStorageInfo("openChannel") == "change") {
                    if (appUtils.getSStorageInfo("finance") == "finance") {
                        $(_pageId + " #next_btn a").html("继续开户"); // 理财户
                    } else {
                        $(_pageId + " #next_btn a").html("继续转户"); // 转户
                    }
                } else {
                    $(_pageId + " #next_btn a").html("继续开户"); // 开户
                }
                // 为按钮绑定事件
                appUtils.bindEvent($(_pageId + " #next_btn a"),
                    function () {
                        appUtils.pageInit("account/digitalCertificate", "account/signProtocol", {});
                    });
            } else {
                install_failed(); // 安装证书失败回调
            }
            //end by fengxiang 2015-07-17 升级


            // 壳子读取证书，然后安装证书
            /*shellPlugin.callShellMethod("initZsPlugin",
             function(data) {
             if (data == "OK") {
             $(_pageId + " .cert_down .cert_stat").html("安装完成");
             $(_pageId + " .order_succes").hide();
             $(_pageId + " .cert_down").show();
             $(_pageId + " #next_btn").attr("class", "ct_btn");
             if (appUtils.getSStorageInfo("openChannel") == "change") {
             if (appUtils.getSStorageInfo("finance") == "finance") {
             $(_pageId + " #next_btn a").html("继续开户"); // 理财户
             } else {
             $(_pageId + " #next_btn a").html("继续转户"); // 转户
             }
             } else {
             $(_pageId + " #next_btn a").html("继续开户"); // 开户
             }
             // 为按钮绑定事件
             appUtils.bindEvent($(_pageId + " #next_btn a"),
             function() {
             appUtils.pageInit("account/digitalCertificate", "account/signProtocol", {});
             });
             } else {
             install_failed();
             }
             },
             install_failed, certParam);*/
        } else {
            layerUtils.iLoading(false);
            layerUtils.iAlert(data.error_info, -1);
            install_failed();
        }
    }

    /* 处理请求超时 */
    function handleTimeout() {
        layerUtils.iConfirm("请求超时，是否重新加载？", function () {
            upload_cert();  // 再次下载证书
        });
    }


    /* 安装证书失败回调 */
    function install_failed() {
        $(_pageId + " #next_btn").attr("class", "ct_btn");
        $(_pageId + " #next_btn a").html("重 试");
        $(_pageId + " .cert_down .cert_stat").html("安装失败");
        $(_pageId + " .order_succes").hide();
        $(_pageId + " .cert_down").show();
        // 为按钮绑定事件
        appUtils.bindEvent($(_pageId + " #next_btn a"),
            function () {
                destroy();
                init();
            });
    }


    var digitalCertificate = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = digitalCertificate;
});