/**
 * 手机号码验证
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),
    // 业务层接口，请求数据
        global = require("gconfig").global,
        platform = require("gconfig").platform,
        layerUtils = require("layerUtils"),
        shellPlugin = require("shellPlugin"),
        utils = require("utils"),
        validatorUtil = require("validatorUtil"),
        startCountDown = null,
        extend_branchno = "",
        isrecscanning_branchno = null,
        extend_company = "",
        mobversion = "",
        mobversionName = "",
        _pageId = "#account_msgVerify",
        psw_id = "",
        flag = false,
        steps = [
            "validation",
            "openVerify",
            "selDepartMent",
            "uploadimg", "idconfirm", "witness", "capitalacct", "stkacct", "setpwd", "tpbank", "risksurvey", "visitsurvey", "success"
        ],
        stepMap = {
            "validation": "account/msgVerify",
            "openVerify": "account/openVerify",
            "selDepartMent": "account/selDepartment",
            "uploadimg": "account/uploadPhotoChange",
            "idconfirm": "account/personInfo",
            "witness": "account/vedioNotice",
            "capitalacct": "account/signProtocol",
            "stkacct": "account/signProtocol",
            "setpwd": "account/setPwd",
            "tpbank": "account/thirdDepository",
            "risksurvey": "account/riskAssessment",
            "visitsurvey": "account/openConfirm",
            "success": "account/accountResult"
        },
        stepMap0 = {
            "uploadimg": "account/uploadPhotoChange",
            "witness": "account/signProtocol"
        };

    var external = require("external");
    var channelValue = ""; //中焯渠道参数
    var channelb = "";   //中焯预留参数1
    var channelc = "";   //中焯预留参数2
    /* 私有业务模块的全局变量 end */

    function init() {
        appUtils.setSStorageInfo("flag", "0"); //如果数据字典内没有配置证书标识
        //是否是中焯的
        if (global.isZhongZhuo) {
            channelValue = getMemoryInfo("channelValue"); //从内存缓存获取数据
            channelb = getMemoryInfo("channelb"); //从内存缓存获取数据
            channelc = getMemoryInfo("channelc"); //从内存缓存获取数据
        }

        /* 发送验证码后自动互调该方法 */
        window.getCode = getCode;
        if (global.company == "jsyh") {  //建行专属

            $(_pageId + " #jsyh").show();
            $(_pageId + " #ths").hide();
        }
        else if (global.company == "ths" || global.company == "cfyj") { //同花顺

            $(_pageId + " #jsyh").hide();
            $(_pageId + " #ths").show();
        } else {  //广州

            $(_pageId + " #jsyh").hide();
            $(_pageId + " #ths").hide();
        }
        if (appUtils.getSStorageInfo("selback") == 3) {
            appUtils.clearSStorage();  // 清空所有的session
            appUtils.clearLStorage();
            //防止再次到主页面时进行版本检测
            appUtils.setSStorageInfo("started", "true", true);
        }
    }

    function bindPageEvent() {

        /* 绑定返回事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_back"),
            function () {
                appUtils.pageInit("account/msgVerify", "account/accountFor", {});
            });

        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"),
            function () {
                if (require("gconfig").platform != "1") {
                    //ios 获取软件是否安装
                    var param = {
                        "funcNo": "50200",
                        "moduleName": "open",
                        "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                    };
                    var result = external.callMessage(param);
                    if (result.error_no == 0) {
                        var isInstall = result.results[0].isInstall;
                        //是否安装(0：否，1：是）
                        if (isInstall == "1") {
                            var param = {
                                "funcNo": "50109",
                                "moduleName": "open",
                                "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                            };
                            external.callMessage(param);
                        } else {
                            layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                //进入appstore
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                };
                                external.callMessage(param);
                            }, null, "下载", "取消");
                        }
                    } else {
                        layerUtils.iAlert("检测QQ失败");
                    }
                } else {
                    var param = {
                        "funcNo": "50109",
                        "moduleName": "open",
                        //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                        "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                    };
                    external.callMessage(param);
                }
            });


        /* 绑定退出按钮 */
        appUtils.bindEvent($(_pageId + " .header .icon_close"),
            function () {
                utils.layerTwoButton("退出系统？", "确认", "取消",
                    function () {
                        //require("shellPlugin").callShellMethod("closeAppPlugin", null, null); // 退出程序
                        //add by fengxiang 2015-07-17 升级
                        var param = {
                            "moduleName": "open",
                            "funcNo": "50105"
                        };
                        //退出应用
                        external.callMessage(param);
                        //end by fengxiang 2015-07-17 升级
                    },
                    function () {
                        return false;
                    });
            });
        /* 限制手机号在IOS上的长度 */
        appUtils.bindEvent($(_pageId + " .phoneNum"),
            function () {
                utils.dealIPhoneMaxLength(this, 11); // 处理iphone兼容
            });

        /* 绑定获取短信验证码事件 */
        appUtils.bindEvent($(_pageId + " .getmsg"),
            function () {
                var phoneNum = $(_pageId + " .phoneNum").val(),
                    phoneReg170 = /^170\d{8}$/; // 170
                // 的手机号
                // 首先验证手机号
                if (validatorUtil.isMobile(phoneNum) || phoneReg170.test(phoneNum)) {
                    getSmsCode(phoneNum); // 获取验证码
                } else {
                    // 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
                    var times = phoneNum.length - 11;
                    if (phoneNum.length > 11) {
                        layerUtils.iMsg(-1, "您多输入&nbsp;" + times + "&nbsp;位电话号码，请重新输入！");
                    } else if (phoneNum.length < 11) {
                        layerUtils.iMsg(-1, "您少输入&nbsp;" + Math.abs(times) + "&nbsp;位电话号码，请重新输入！");
                    } else {
                        //add by 冯翔 2015-07-24  提示输入11位错误手机号
                        layerUtils.iMsg(-1, "手机号码输入错误，请重新输入！");
                        //end by 冯翔 2015-07-24  提示输入11位错误手机号
                    }
                    return;
                }
            });

        /* 下一步(继续开户) */
        appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"),
            function () {
                var mobilecode = $(_pageId + " .mobileCode").val();
                if ($(_pageId + " .phoneNum").val().length == 0) {
                    layerUtils.iMsg(-1, "请输入手机号！");
                    return;
                }
                if ($(_pageId + " .mobileCode").val().length == 0) {
                    layerUtils.iMsg(-1, "请输入验证码！");
                    return;
                }
                if (!validatorUtil.isNumeric(mobilecode) || mobilecode.length != 6) {
                    layerUtils.iMsg(-1, "验证码格式不对！");
                    return;
                }
                checkSmsCode(); // 验证码校验

            });

    }

    function destroy() {
        // 清除计时器
        if (startCountDown != null) {
            window.clearInterval(startCountDown);
        }
        $(_pageId + " .getmsg").show(); // 显示按钮
        $(_pageId + " .cert_notice").hide(); // 隐藏验证码已发出提示
        $(_pageId + " .time").hide(); // 隐藏倒计时
        $(_pageId + " .phoneNum").val(""); // 清除手机号
        $(_pageId + " .mobileCode").val(""); // 清除验证码
        service.destroy();
    }

    /* 壳子获取验证码自动填充 */
    function getCode(data) {
        if (data) {
            $(_pageId + " .phoneNum").val(data);
        }
    }

    /* 获取验证码 */
    function getSmsCode(phoneNum) {
        var mac = iBrowser.pc ? "02:00:5E:00:00:14" : "",
            ip = iBrowser.pc ? "192.168.1.109" : "";
        // 只有当不是 pc 时，才调用壳子获取 ip 和 mac
        if (!iBrowser.pc) {
            /*require("shellPlugin").callShellMethod("getIpMacPLugin",
             function(data) {
             data = data.split("|");
             mac = data[0];
             ip = data[1];
             appUtils.setSStorageInfo("ip", ip); // 将 ip 保存到
             // sessionStorage
             // 里面
             appUtils.setSStorageInfo("mac", mac); // 将 mac
             // 保存到
             // sessionStorage
             // 里面
             sendmsg(phoneNum, mac, ip); // 发送验证码
             },
             null);*/
            //add by fengxiang 2015-07-17 升级
            var param = {
                "moduleName": "open",
                "funcNo": "50023"
            };
            var result = external.callMessage(param);
            if (result.error_no == "0") {
                ip = result.results[0].ip;
                appUtils.setSStorageInfo("ip", ip); // 将 ip 保存到 sessionStorage 里面
                var param = {
                    "moduleName": "open",
                    "funcNo": "50024"
                };
                var result = external.callMessage(param);
                if (result.error_no == "0") {
                    //android
                    mac = result.results[0].mac;
                    if (mac.length > 17) {
                        mac = mac.substring(0, 17);
                    }
                    appUtils.setSStorageInfo("mac", mac); // 将 mac 保存到 sessionStorage 里面
                    sendmsg(phoneNum, mac, ip); // 发送验证码
                } else {
                    layerUtils.iAlert(result.error_info);
                }

            } else {
                layerUtils.iAlert(result.error_info);
            }
            //end by fengxiang 2015-07-17 升级
        } else {
            sendmsg(phoneNum, mac, ip); // 发送验证码
        }
    }

    /* 发送验证码 */
    function sendmsg(phoneNum, mac, ip) {
        var param = {
            // 访问接口来源标识，访问来源(默认PC) 0：pc， 2：pad， 3：手机
            // "op_way": iBrowser.pc ? 0 : "smartphones",
			"op_way": "smartphones",
            // 2014-07-04 15:21 pm "op_way" : iBrowser.pc ? 0 : 3,
            "mobile_no": phoneNum,
            "ip": ip,
            "mac": mac
        };
        // 请求获取验证码接口
        service.getSmsCode(param,
            function (data) {
                var error_no = data.error_no;
                var error_info = data.error_info;
                var result = data.results;
                if (error_no == "0") {
                    // 后台如果返回ip地址，则本地存储用户ip地址
                    if (result[0] && result[0].ip) {
                        appUtils.setSStorageInfo("ip", result[0].ip);
                    }
                    // 计时器
                    var sumTime = 60;
                    // 处理获取验证码时发生的动作
                    var handleCount = function () {
                        // 获取验证码之后按钮隐藏
                        $(_pageId + " .getmsg").hide();
                        // 显示倒计时
                        $(_pageId + " .time").show();
                        $(_pageId + " .cert_notice").show();
                        $(_pageId + " .time").text(sumTime-- + "秒后重发");
                    };
                    handleCount();
                    startCountDown = window.setInterval(function () {
                            handleCount();
                        },
                        1000);
                    // 120 秒之后清除计时器
                    var clearCountDown = setTimeout(function () {
                            // 显示按钮
                            $(_pageId + " .getmsg").show();
                            // 隐藏倒计时
                            $(_pageId + " .time").hide();
                            $(_pageId + " .cert_notice").hide();
                            $(_pageId + " .time").text(60);
                            window.clearInterval(startCountDown);
                        },
                        61000);
                    // 发送完验证码后，通过判断输入手机号是否一致，否则重新发送验证码
                    var c_phoneNum = phoneNum;
                    appUtils.bindEvent($(_pageId + " .phoneNum"),
                        function () {
                            c_phoneNum = $(_pageId + " .phoneNum").val();
                            if (validatorUtil.isMobile(phoneNum) && validatorUtil.isMobile(c_phoneNum)) {
                                // 用户两次输入的手机号不同，重新获取验证码
                                if (c_phoneNum != phoneNum) {
                                    clearInterval(startCountDown); // 清除定时器
                                    clearTimeout(clearCountDown);
                                    $(_pageId + " .getmsg").show(); // 显示按钮
                                    $(_pageId + " .time").hide(); // 隐藏倒计时
                                }
                            }
                        },
                        "input");
                    // 调用读取短信验证码插件
//                require("shellPlugin").callShellMethod("sMSReceiverPlugin", null, null, null);
                } else {
                    layerUtils.iAlert(error_info, -1);
                    return false;
                }
            },
            true, true);
    }

    /* 提交验证码校验 */
    function checkSmsCode() {

        // 获取应用版本versionName
        var param = {
            "moduleName": "open",
            "funcNo": "50010"
        };
        var result = external.callMessage(param);
        if (result.error_no == "0") {
            var data = result.results[0];
            var versionName = JSON.stringify(data.version);
            mobversionName = versionName.replace(/^\"|\"$/g, '');
        }

        if (platform == "1") {
            mobversion = global.company + "|android|" + mobversionName; // 获取应用版本:例如:android|2.0.1
        } else {
            mobversion = global.company + "|apple|" + mobversionName; // 获取应用版本:例如:android|2.0.1
        }
        var login_flag = appUtils.getSStorageInfo("openChannel") == "new" ? "0" : "1";

        var param = {
            "mobile_no": $(_pageId + " .phoneNum").val(),
            "mobile_code": $(_pageId + " .mobileCode").val(),
            "login_flag": login_flag,
            // 登录业务标准，新开户：0 转户： 1
            "mobversion": mobversion,
            "company": ""
        };
        //是否是中焯的
        if (global.isZhongZhuo) {
            param.company = channelValue; //中焯渠道参数
        } else {
            param.company = global.company
        }


        /* 调用验证码校验接口 */
        service.checkSmsCode(param, function (data) {
            // 	alert(JSON.stringify(data))
            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;
            if (error_no == "0" && result.length != 0) {

                if (result[0].user_id.length <= 6) {

                    if (result[0].native) {
                        appUtils.setSStorageInfo("native", result[0].native);
                    }
                    // 联系地址保存到session
                    if (result[0].addr) {
                        appUtils.setSStorageInfo("addr", result[0].addr);
                    }
                    // 民族保存到session
                    if (result[0].ethnicname) {
                        appUtils.setSStorageInfo("ethnicname", result[0].ethnicname);
                    }
                    // 出生日期保存到session
                    if (result[0].birthday) {
                        appUtils.setSStorageInfo("birthday", result[0].birthday);
                    }
                    // 性别保存到session
                    if (result[0].usersex) {
                        appUtils.setSStorageInfo("gender", result[0].usersex);
                    }
                    // 图片的显示地址保存到session
                    if (result[0].img_path) {
                        appUtils.setSStorageInfo("imgPath", result[0].img_path);
                    }
                    // 图片id保存到session
                    if (result[0].id) {
                        appUtils.setSStorageInfo("imgId", result[0].id);
                    }
                    if (result[0].extend_branchno) {
                        appUtils.setSStorageInfo("extend_branchno", result[0].extend_branchno);
                    }
                    // 佣金套餐保存到session
                    if (result[0].commission) {
                        appUtils.setSStorageInfo("commission", result[0].commission);
                    }
                    // 佣金套餐名称保存到session
                    if (result[0].commname) {
                        appUtils.setSStorageInfo("commname", result[0].commname);
                    }
                    // 佣金率保存到session
                    if (result[0].commproportion) {
                        appUtils.setSStorageInfo("commproportion", result[0].commproportion);
                    }
                    // 营业部服务电话
                    if (result[0].servicephone) {
                        appUtils.setSStorageInfo("servicephone", result[0].servicephone);
                    }
                    // 营业部名称
                    if (result[0].branchname) {
                        appUtils.setSStorageInfo("branchname", result[0].branchname);
                    }
                    if (result[0].idbegindate) {
                        appUtils.setSStorageInfo("idBeginDate", result[0].idbegindate);
                    }
                    if (result[0].idenddate) {
                        appUtils.setSStorageInfo("idEndDate", result[0].idenddate);
                    }
                    // 签发机关保存到session
                    if (result[0].policeorg) {
                        appUtils.setSStorageInfo("policeorg", result[0].policeorg);
                    }
                    if (result[0].postid) {
                        appUtils.setSStorageInfo("postid", result[0].postid);
                    }
                    // isdownload，downloadname，downloadurl
                    if (result[0].isdownload) {
                        appUtils.setSStorageInfo("isdownload", result[0].isdownload);
                    }
                    if (result[0].downloadname) {
                        appUtils.setSStorageInfo("downloadname", result[0].downloadname);
                    }
                    if (result[0].downloadurl) {
                        appUtils.setSStorageInfo("downloadurl", result[0].downloadurl);
                    }
                    if (result[0].edu) {
                        appUtils.setSStorageInfo("edu", result[0].edu);
                    }
                    // added at 2016/03/10
                    if (result[0].ryfl_name) {
                        appUtils.setSStorageInfo("ryflName", result[0].ryfl_name);
                    } else {
                        appUtils.setSStorageInfo("ryflName", "经纪人");
                    }
                    if (result[0].recommendno) {
                        appUtils.setSStorageInfo("recommendno", result[0].recommendno);
                        appUtils.setSStorageInfo("rdno", result[0].recommendno);
                        appUtils.setSStorageInfo("isAgent", 1);
                    } else {
                        appUtils.setSStorageInfo("isAgent", 0);
                    }
                    if (result[0].last_recommendno) {
                        //added at 2015/08/09
                        appUtils.setSStorageInfo("isAgent", 1);
                        appUtils.setSStorageInfo("last_recommendno", result[0].last_recommendno);
                    }
                    if (result[0].profession_code) {
                        appUtils.setSStorageInfo("profession_code", result[0].profession_code);
                    }
                    if (result[0].industry_code) {
                        appUtils.setSStorageInfo("industry_code", result[0].industry_code);
                    }
                    if (result[0].branchno) {
                        isrecscanning_branchno = result[0].branchno;
                        appUtils.setSStorageInfo("branchno", result[0].branchno);
                        appUtils.setSStorageInfo("bid", result[0].branchno);
                    }
                    if (result[0].provinceno) {
                        appUtils.setSStorageInfo("provinceno", result[0].provinceno);
                    }
                    // 身份证号保存到session
                    if (result[0].idno) {
                        appUtils.setSStorageInfo("idCardNo", result[0].idno);
                    }
                    // 手机号保存到session
                    if (result[0].mobileno) {
                        appUtils.setSStorageInfo("mobileNo", result[0].mobileno);
                    }
                    // 渠道提示保存到session added at 2015/08/12
                    if (result[0].content) {
                        appUtils.setSStorageInfo("content", result[0].content);
                    }
                    // 将客户姓名保存到 session 中，用于在开户结果中做展示
                    if (result[0].custname) {
                        appUtils.setSStorageInfo("custname", result[0].custname);
                    }
                    // 将 provinceno 保存到 session
                    // 中，用于解决壳子上传照片的权限问题
                    if (result[0].provinceno) {
                        appUtils.setSStorageInfo("provinceno", result[0].provinceno);
                    }
                    // 将 cityno 保存到 session
                    // 中，用于解决壳子上传照片的权限问题
                    if (result[0].cityno) {
                        appUtils.setSStorageInfo("cityno", result[0].cityno);
                    }
                    if (result[0].clientinfo) {
                        appUtils.setSStorageInfo("clientinfo", result[0].clientinfo);
                    }
                    if (result[0].isrecscanning) {//获取二维码--经纪人

                        appUtils.setSStorageInfo("isrecscanning", result[0].isrecscanning);
                    }
                    if (result[0].extend_company) {//老钱庄合作渠道

                        appUtils.setSStorageInfo("extend_company", result[0].extend_company);
                    }
                    // 将 jsessionid 保存到 session
                    // 中，用于解决壳子上传照片的权限问题
                    if (result[0].jsessionid) {

                        appUtils.setSStorageInfo("jsessionid", result[0].jsessionid);
                    }
                    if (result[0].extend_branchno) {

                        extend_branchno = result[0].extend_branchno;
                    }
                    //员工预约信息
                    if (result[0].employee_no) {
                        appUtils.setSStorageInfo("employee_no", result[0].employee_no);
                    }
                    if (result[0].employee_name) {
                        appUtils.setSStorageInfo("employee_name", result[0].employee_name);
                    }
                    if (result[0].employee_phone) {
                        appUtils.setSStorageInfo("employee_phone", result[0].employee_phone);
                    }
                    // user_id保存到session
                    appUtils.setSStorageInfo("user_id", result[0].user_id);
                    // 营业部ID保存到session
                    appUtils.setSStorageInfo("branchno", result[0].branchno);

                    //是否是中焯的
                    if (global.isZhongZhuo) {
                        //add by fengxiang 2015-08-11 保存渠道数据
                        var param = {
                            "user_id": result[0].user_id,
                            "channela": channelValue,
                            "channelb": channelb,
                            "channelc": channelc
                        };
                        service.saveChannel(param, function (data) {
                            //只进行保存
                        });
                        //end by fengxiang 2015-08-11 保存渠道数据
                    }


                    // 判断是否驳回，若驳回则走驳回流程
                    if (addition(result[0])) {
                        return false;
                    } else { // 未驳回，则正常走流程
                        nextStep(result[0]);
                    }

                } else {
                    layerUtils.iMsg(-1, "抱歉，开户系统遇到了未知异常，请您重新登录!");
                    return false;
                }
            } else {
                layerUtils.iMsg(-1, error_info);
                layerUtils.iLoading(false);
            }
        }, false);
    }

    /* 处理驳回补全资料的情况 */
    function addition(res) {
        // 驳回情况：身份证正面、反面、大头像、交易密码、资金密码、三方存管、转户驳回到视频见证
        var photoParam = {
            "needFront": res.need_photo_front != undefined ? res.need_photo_front : "0",
            "needBack": res.need_photo_back != undefined ? res.need_photo_back : "0",
            "needNohat": res.need_photo_nohat != undefined ? res.need_photo_nohat : "0"
        };
        var pwdParam = {
            "needBusinessPwd": res.need_business_password != undefined ? res.need_business_password : "0",
            "needFundPwd": res.need_fund_password != undefined ? res.need_fund_password : "0"
        };
        var thirdParam = {
            "needThirdDeposit": res.need_third_deposit != undefined ? res.need_third_deposit : "0"
        };
        var videoParam = {
            "need_video": res.need_video != undefined ? res.need_video : "0"
        };
        // 1.补全照片
        if (photoParam["needFront"] == 1 || photoParam["needBack"] == 1 || photoParam["needNohat"] == 1) {
            appUtils.setSStorageInfo("videoParam", JSON.stringify(videoParam));
            appUtils.setSStorageInfo("photoparam", JSON.stringify(photoParam));
            appUtils.pageInit("account/msgVerify", "account/backUploadPhoto", photoParam);
            return true;
        }
        // 2.驳回密码设置
        if (pwdParam["needBusinessPwd"] == 1 || pwdParam["needFundPwd"] == 1) {

            appUtils.pageInit("account/msgVerify", "account/backSetPwd", pwdParam);
            return true;
        }
        // 3.驳回三方存管
        if (thirdParam["needThirdDeposit"] == 1) {
            appUtils.pageInit("account/msgVerify", "account/backThirdDepository", thirdParam);
            return true;
        }
        // 4.驳回视频见证
        if (videoParam["need_video"] == 1) {

            appUtils.setSStorageInfo("videoParam", JSON.stringify(videoParam));
            appUtils.pageInit("account/msgVerify", "account/vedioNotice", videoParam);
            return true;
        } else {
            return false;
        }
    }

    /* 下一步入口 */
    function nextStep(res) {
        var pageCode = "";
        // 断点——上次走的最后一步
        var currentStep = res["lastcomplete_step"];
        // 开户通道的标识，0 新开户，1 转户
        var opacctkind_flag = res["opacctkind_flag"];
        //  alert("opacctkind_flag"+opacctkind_flag);
        // 根据 opacctkind_flag 设置 session 中的 openChannel
        if (opacctkind_flag == 0 || opacctkind_flag == 9) {
            appUtils.setSStorageInfo("openChannel", "new");
        } else {
            appUtils.setSStorageInfo("openChannel", "change");
        }
        if (currentStep && currentStep.length > 0) {

            var index = steps.indexOf(currentStep);

            if (index < (steps.length - 1)) {

                currentStep = steps[index + 1];
            }
            if (opacctkind_flag == 0 || opacctkind_flag == 1 || opacctkind_flag == 9) {

                pageCode = stepMap[currentStep];
            } else {
                pageCode = stepMap0[currentStep];
                if (!(pageCode && pageCode.length > 0)) {
                    pageCode = stepMap[currentStep];
                }
            }
        }
        if (pageCode && pageCode.length > 0) {

            // 如果是直接跳转到 视频认证 页面，将 QQ 保存到 session 中
            if (pageCode == "account/vedioNotice") {
                appUtils.setSStorageInfo("qq", res.im_code);
            }
            // 如果是直接跳转到 开户结果 页面，将资金账号、股东账户保存到 session
            if (pageCode == "account/accountResult") {
                // 将返回的 资金账号 保存到 session
                var fundAccount = null;
                // 将当后台有返回资金账号时，才保存
                if (res.fund_account != undefined && res.fund_account != "") {
                    fundAccount = res.fund_account;
                    /*2014-09-1 am          // 不足 12 位补 0
                     if (fundAccount.length < 12) {
                     // 加 0 的个数
                     var addSum = 12 - fundAccount.length;
                     for (var i = 0; i < addSum; i++) {
                     fundAccount = "0" + fundAccount;
                     }
                     }*/
                    appUtils.setSStorageInfo("acct_fndacct", fundAccount);
                }
                // 将返回的股东账号存到 session 中，key 为 gdzh
                var gdzhArray = new Array(),
                    gdzhStr = "";
                // 深 A
                if (res.szaaccount != "" && res.szaaccount != undefined) {
                    gdzhArray.push("深A账号:" + res.szaaccount);
                }
                // 沪 A
                if (res.shaaccount != "" && res.shaaccount != undefined) {
                    gdzhArray.push("沪A账号:" + res.shaaccount);
                }
                // 沪 A 基金
                if (res.hacn_account != "" && res.hacn_account != undefined) {
                    gdzhArray.push("沪开放式基金:" + res.hacn_account);
                }
                // 深 A 基金
                if (res.zacn_account != "" && res.zacn_account != undefined) {
                    gdzhArray.push("深开放式基金:" + res.zacn_account);
                }
                //一码通
                if (res.ymt_code != "" && res.ymt_code != undefined) {
                    gdzhArray.push("一码通:" + res.ymt_code);
                }
                // 将数组 gdzhArray 转换为字符串，并以 - 连接各元素
                gdzhStr = gdzhArray.join("-");
                appUtils.setSStorageInfo("gdzh", gdzhStr);
            }
            appUtils.pageInit("account/msgVerify", pageCode, {});
        } else {
            //判断渠道是否为空，如果不为空则跳到上传影像页面
            // if (appUtils.getSStorageInfo("extend_company") != undefined) {
            if (extend_branchno.length > 0) {

                appUtils.setSStorageInfo("branchno", extend_branchno);
            } else {

                appUtils.setSStorageInfo("branchno", isrecscanning_branchno);
            }
            //   appUtils.pageInit("account/msgVerify", "account/uploadPhotoChange", {});
            //} else {
            appUtils.pageInit("account/msgVerify", "account/openVerify", {});
            // }
        }
    }

    //add by fengxiang 2015-08-11  从内存缓存获取数据
    function getMemoryInfo(key) {
        var param = {
            "funcNo": "50041",
            "key": key
        };
        var result = external.callMessage(param);
        if (result.error_no == "0") { //获取缓存成功
            var value = result.results[0].value;
            return value;
        } else {
            layerUtils.iAlert("获取内存数据失败");
        }
    }

    //end by fengxiang 2015-08-11  从内存缓存获取数据

    var msgVerify = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    // 暴露接口
    module.exports = msgVerify;
});