/**
 * 新开户(转户)须知
 */
define(function (require, exports, module) {
    // 私有业务模块的全局变量 begin
    var appUtils = require("appUtils"), _pageId = "#account_openAccount";

    var external = require("external");
    // 私有业务模块的全局变量 end

    function init() {
        if (appUtils.getSStorageInfo("openChannel") == "change") {
            $(_pageId + " .header h3").html("转户须知");
            $(_pageId + " .ness_box h5").html("转户前的准备：");
            $(_pageId + " .step_box h5").html("三步即可转户：");
        } else {
            $(_pageId + " .header h3").html("开户须知");
            $(_pageId + " .ness_box h5").html("开户前的准备：");
            $(_pageId + " .step_box h5").html("三步即可开户：");
        }
    }

    function bindPageEvent() {
        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"),
            function () {
                if (require("gconfig").platform != "1") {
                    //ios 获取软件是否安装
                    var param = {
                        "funcNo": "50200",
                        "moduleName": "open",
                        "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                    };
                    var result = external.callMessage(param);
                    if (result.error_no == 0) {
                        var isInstall = result.results[0].isInstall;
                        //是否安装(0：否，1：是）
                        if (isInstall == "1") {
                            var param = {
                                "funcNo": "50109",
                                "moduleName": "open",
                                "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                            };
                            external.callMessage(param);
                        } else {
                            layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                //进入appstore
                                var param = {
                                    "funcNo": "50109",
                                    "moduleName": "open",
                                    "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                };
                                external.callMessage(param);
                            }, null, "下载", "取消");
                        }
                    } else {
                        layerUtils.iAlert("检测QQ失败");
                    }
                } else {
                    var param = {
                        "funcNo": "50109",
                        "moduleName": "open",
                        //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                        "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                    };
                    external.callMessage(param);
                }
            });
        // 绑定返回首页处理
        appUtils.bindEvent($(_pageId + " .header .icon_back"),
            function () {
                appUtils.pageBack();
            });
        // 绑定下一步(我知道了)
        appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"),
            function () {
                appUtils.pageInit("account/openAccount",
                    "account/msgVerify", {});
            });
    }

    function destroy() {
    }

    // 对外暴露的模块方法 end

    var openAccount = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    // 暴露对外的接口
    module.exports = openAccount;
});