/**
 * 开户确认（问卷回访）
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"), service = require("serviceImp")
            .getInstance(), // 业务层接口，请求数据
        utils = require("utils"),
        global = require("gconfig").global, layerUtils = require("layerUtils"), _pageId = "#account_openConfirm";

    var external = require("external");
    /* 私有业务模块的全局变量 end */

    function init() {
        Map = require("map"), fristMap = new Map(), getOpenConfirmData(); // 获取问卷回访问题
    }

    function bindPageEvent() {
        /* 连接客服事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_link"), function () {
            var branchID = appUtils.getSStorageInfo("bid");
            var brokersno = appUtils.getSStorageInfo("recommendno");
            if (branchID == undefined) {
                branchID = "";
            }
            if (brokersno == undefined) {
                brokersno = "";
            }
            //如有选择了营业部或经纪人则需要传
            var param1 = {
                "userid": appUtils.getSStorageInfo("user_id"),
                "branchno": "",
                "brokersno": ""
            }
            /*  added at 2015/09/02
             *  入参： user_id （客户id）
             出参：调用成功有两种情况，
             1.如果属于中焯渠道 会返回 status=1
             2. 如果不属于中焯渠道或者没有渠道 会返回 status=0，servicephone（服务电话），branchno(营业部编号),branchname(营业部名称)。*/
            service.serachIsCompanyCustomer(param1, function (data) {
                var error_no = data.error_no,
                    error_info = data.error_info;
                if (error_no == "0") {
                    var status = data.results[0].status;
                    if (status == "0") {
                        $(".ly_shadow").show();
                        var branchname = data.results[0].branchname;
                        var brokersname = data.results[0].brokersname;
                        var servicephone = data.results[0].servicephone;
                        var brokersphone = data.results[0].brokersphone;
                        var address = data.results[0].address;
                        var info = "";
                        //有经纪人的
                        if (!!brokersname) {
                            info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                            branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                + "<p style='text-align:left;line-height:20px;'>经纪人姓名：" + brokersname + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>经纪人电话：<a style='color:orange' id='brokersphone'>" + brokersphone + "</a></p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='brokersphone'>95396</a></p>";
                            info += branchno_info;
                            $(".btn_bot p").html(info);
                            //监听营业部电话事件
                            appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            //监听经纪人电话事件
                            appUtils.bindEvent(".btn_bot #brokersphone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            //监听统一电话事件
                            appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            appUtils.bindEvent(".btn_box", function (e) {
                                $(".ly_shadow").hide();
                                e.stopPropagation(); // 阻止冒泡
                            });
                        } else {//无经纪人的
                            info = "<p style='text-align:left;line-height:20px;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;尊敬的客户：开户过程中如有疑问，您可以咨询营业部热线、专属经纪人（如有）或统一客服热线</p>";
                            branchno_info = "<br><p style='text-align:left;line-height:20px;'>营业部名称：" + branchname + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部热线：<a style='color:orange' id='branchnoPhone'>" + servicephone + "</a></p>"
                                + "<p style='text-align:left;line-height:20px;'>营业部地址：" + address + "</p>"
                                + "<p style='text-align:left;line-height:20px;'>统一客服热线：<a style='color:orange' id='publicPhone'>95396</a></p>";
                            info += branchno_info;
                            $(".btn_bot p").html(info);
                            //监听营业部电话事件
                            appUtils.bindEvent(".btn_bot #branchnoPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            //监听统一电话事件
                            appUtils.bindEvent(".btn_bot #publicPhone", function (e) {
                                var tel = $(this).text();
                                utils.call(tel); //打电话
                                e.stopPropagation(); // 阻止冒泡
                            });
                            appUtils.bindEvent(".btn_box", function (e) {
                                $(".ly_shadow").hide();
                                e.stopPropagation(); // 阻止冒泡
                            });
                        }
                    } else {
                        if (require("gconfig").platform != "1") {
                            //ios 获取软件是否安装
                            var param = {
                                "funcNo": "50200",
                                "moduleName": "open",
                                "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                            };
                            var result = external.callMessage(param);
                            if (result.error_no == 0) {
                                var isInstall = result.results[0].isInstall;
                                //是否安装(0：否，1：是）
                                if (isInstall == "1") {
                                    var param = {
                                        "funcNo": "50109",
                                        "moduleName": "open",
                                        "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                                        //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                                    };
                                    external.callMessage(param);
                                } else {
                                    layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                                        //进入appstore
                                        var param = {
                                            "funcNo": "50109",
                                            "moduleName": "open",
                                            "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                                        };
                                        external.callMessage(param);
                                    }, null, "下载", "取消");
                                }
                            } else {
                                layerUtils.iAlert("检测QQ失败");
                            }
                        } else {
                            var param = {
                                "funcNo": "50109",
                                "moduleName": "open",
                                //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                                "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                            };
                            external.callMessage(param);
                        }
                    }
                } else {
                    layerUtils.iAlert(error_info);
                }
            });
        });
        /* 问卷回访页面进入开户结果页面 */
        appUtils.bindEvent($(_pageId + " .ct_btn"), function () {
            postQuestionaireData();
        });

        // 问题卷选项绑定提示事件
        appUtils.preBindEvent($(_pageId + " .user_form"),
            " .icon_radio", function () {
                validateSelect(this);
            });
    }

    /**
     * 选项选中验证事件 若选择否 则按钮不可点击
     */
    function validateSelect(obj) {
        var selectid = $(obj).attr("que-choice");
        // 若当前点击没有选中，去除全部选中
        if (!$(obj).hasClass("checked")) {
            $(obj).parent().siblings().children("a").removeClass("checked");  // 选中当前答案，将其他答案标记未选择
            $(obj).parent().parent().prev("h5").css("color", "#666666");	 // 红色标记恢复黑色
        }
        else {
            $(obj).parent().parent().prev("h5").css("color", "red");  //未选择答案，则将该题标记为红色
        }
        $(obj).toggleClass("checked");
    }

    /**
     * 获取开户确认回访问卷 接口号 501541
     */
    function getOpenConfirmData() {
        var userid = appUtils.getSStorageInfo("user_id");
        $(_pageId + " .user_form").html("");
        var visitSubParam = {
            "user_id": userid,
            "sub_id": "5000"
        }
        // 获取回访问卷
        service.getVisitSub(visitSubParam, function (data) {
            var errorNo = data.error_no;
            var errorInfo = data.error_info;
            if (errorNo == 0 && data.results.length != 0) // 调用成功
            {
                var results = data.results;
                var questionHtml = "";
                for (var i = 0; i < results.length; i++)// 先遍历
                {
                    var oneEle = results[i];
                    var queid = oneEle.que_id;
                    var type = oneEle.type;
                    var qname = oneEle.q_name;
                    var str = type + "-" + queid + "-" + qname;
                    var secondMap = null;
                    if (!fristMap.containsKey(str))// 若map中没有对应的问题号，则存入问题号
                    {
                        secondMap = new Map();
                        secondMap.put(oneEle.ans_id, oneEle);
                        fristMap.put(str, secondMap); // fristMap每一个Key对应一个问题
                    } else {
                        fristMap.get(str).put(oneEle.ans_id,
                            oneEle);
                    }
                }
                var keys = fristMap.keys();
                for (var j = 0; j < keys.length; j++) {
                    var oneData = fristMap.get(keys[j]);// 取出一个问题
                    questionHtml += createOpenConfirmElement(
                        oneData, keys[j], j + 1);
                }
                $(_pageId + " .user_form").html(questionHtml);
                // 当题目过多，则设置下一步按钮悬浮底部
                if ($(document.body).height() < $(_pageId)
                    .height()) {
                    $(_pageId + " .fix_bot").css("position",
                        "fixed");
                } else {
                    $(_pageId + " .fix_bot").css("position",
                        "absolute");
                }
                // 设置默认值，默认选择正确答案
                // $(_pageId+" .user_form dl
                // a[ans-mark=1]").addClass("checked");
            } else {
                require("layerUtils").iAlert(errorInfo);
            }
        });
    }

    /* 创建一个问题项目 */
    function createOpenConfirmElement(oneData, key, index) {
        var type = key.split("-")[0];
        var queid = key.split("-")[1];
        var qname = key.split("-")[2];
        var oneDatakeys = oneData.keys();
        var itemHtml = "";
        var itemHead = "";
        var itemElem = "";
        for (var i = 0; i < oneDatakeys.length; i += 2)// 先遍历确定有多少题
        {
            var oneElem = oneData.get(oneDatakeys[i]);
            var mark = oneElem.mark;
            var aname = oneElem.a_name;
            var ansid = oneElem.ans_id;
            itemElem += "<dd><a href=\"javascript:;\" class=\"icon_radio\" que-choice='0' que-type ='" + type + "' ans-id='" + ansid + "' ans-mark=\"" + mark + "\" id ='" + queid + "'>" + aname + "</a></dd>";
            if (oneDatakeys.length >= 2) // 取第二条数据
            {
                var oneEleTwo = oneData.get(oneDatakeys[i + 1]);
                var markTwo = oneEleTwo.mark;
                var anameTwo = oneEleTwo.a_name;
                var ansidTwo = oneEleTwo.ans_id;
                itemElem += "<dd><a href=\"javascript:;\" class=\"icon_radio\" que-choice='1' que-type ='" + type + "' ans-id='" + ansidTwo + "' ans-mark=\"" + markTwo + "\" id ='" + queid + "'>" + anameTwo + "</a></dd>";
                if (oneDatakeys.length >= 3)  // 取第三条数据
                {
                    var oneEleThree = oneData.get(oneDatakeys[i + 2]);
                    var markThree = oneEleThree.mark;
                    var anameThree = oneEleThree.a_name;
                    var ansidThree = oneEleThree.ans_id;
                    itemElem += "<dd><a href=\"javascript:;\" class=\"icon_radio\" que-choice='1' que-type ='" + type + "' ans-id='" + ansidThree + "' ans-mark=\"" + markThree + "\" id ='" + queid + "'>" + anameThree + "</a></dd>";
                }
            }
        }
        itemHead = "<h5 class=\"title\">" + index + "、 " + qname + "</h5>";
        itemHtml = itemHead + "<dl class=\"radio_table\" id=" + queid + ">" + itemElem + "</dl>";
        return itemHtml;
    }

    /* 提交问卷回访数据（用户选择答案） */
    function postQuestionaireData() {
        oneQuestionaireData = ""; // 格式如：1_2_7|2_7_3| 问题ID_答案ID_答案分值
        oneQuestionaireData = validateIfQuestionisFinish();
        if (!oneQuestionaireData) {
            return false;
        }
        var userid = appUtils.getSStorageInfo("user_id");
        var submitParam = {
            "user_id": userid,
            "q_a_args": oneQuestionaireData,
            "sub_id": "5000"
        };
        $(_pageId + " .user_form h5").css("color", "#666666"); // 红色标记恢复黑色
        service.submitVisitAnswer(submitParam, function (data) {
            var errorNo = data.error_no;
            var errorInfo = data.error_info;
            if (errorNo == 0) // 调用成功,跳转到风险测评页面
            {
                appUtils.pageInit("account/openConfirm",
                    "account/accountResult", {}); // 直接跳到结果页
            } else {
                layerUtils.iAlert(errorInfo, -1);
            }
        });
    }

    /* 验证问题全部是否回答 */
    function validateIfQuestionisFinish() {
        var oneRiskAssessData = "";
        var countNoChoice = 0;// 没有选择问题数量
        var numNoChoice = ""; // 没有选择问题题号
        var keys = fristMap.keys();
        for (var j = 0; j < keys.length; j++) {
            var queid = keys[j].split("-")[1];
            var isChoice = false;
            $(_pageId + " .radio_table dd #" + queid).each(function () {
                if ($(this).hasClass("checked")) {
                    isChoice = true;
                    var ansid = $(this).attr("ans-id");
                    var mark = $(this).attr("ans-mark");
                    oneRiskAssessData += (queid + "_" + ansid + "_"
                        + mark + "|");
                }
            });
            if (!isChoice) // 没有选中 则记录未提交的题目编号
            {
                countNoChoice++;
                numNoChoice += (j + 1) + "、";
            }
        }

        if (countNoChoice > 0)// 您的答题尚未完成
        {
            numNoChoice = numNoChoice.substring(0, numNoChoice.length
                - 1); // 去掉最后一个逗号
            layerUtils.iAlert("您的答题尚未完成，未完成题目编号：" + numNoChoice);
            return false;
        }
        // 有选择 否的答案就无法切换页面
        var hasNo = null;
        $(_pageId + " .user_form dl").each(function () {
            // 如果有回访问题的答案是否
            if ($(this).children("dd").children("a[ans-mark=0]").hasClass("checked")) {
                $(this).prev("h5").css("color", "red");  //未选择答案，则将该题标记为红色
                hasNo = true;
            }
        });
        if (hasNo) {
//			layerUtils.iAlert("亲！您的选择可能无法通过回访，账户无法激活");
            layerUtils.iAlert("此次开户必须是本人自愿且已经阅读相关协议和风险提示！");
            return false;
        }
        return oneRiskAssessData;
    }

    function destroy() {
        service.destroy();
    }

    var questionnaireReturn = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    module.exports = questionnaireReturn;
});