﻿/**
 * 手机开户2.0
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(), // 业务层接口，请求数据
        layerUtils = require("layerUtils"),
        gconfig = require("gconfig"),
        global = gconfig.global,
        platform = require("gconfig").platform,
        shellPlugin = require("shellPlugin"),
        utils = require("utils"),
        _pageId = "#account_openVerify";

    var external = require("external");
    /* 私有业务模块的全局变量 end */

    function init() {
        layerUtils.iLoading(false);
    }

    function bindPageEvent() {

        /* 绑定返回事件 */
        appUtils.bindEvent($(_pageId + " .header .icon_back"),
            function () {
                appUtils.pageBack();
            });


        /* 绑定新开账户 */
        appUtils.bindEvent($(_pageId + " .gz_zjnav div:eq(0)"), function () {
            // 设置标识'new',表示新开户,并且存到local
            var param = {
                "user_id": appUtils.getSStorageInfo("user_id"),
                "opacctkind_flag": 9
            }
            service.checkOpenVerify(param, function (data) {
                var error_no = data.error_no;
                var error_info = data.error_info;
                var result = data.results;
                if (error_no == "0") {
                    appUtils.pageInit("account/openVerify", "account/selDepartment", {});
                } else {
                    layerUtils.iLoading(false);
                }
            });
        });

        /*绑定转账户*/
        appUtils.bindEvent($(_pageId + " .gz_zjnav div:eq(1)"), function () {

            var param = {
                "user_id": appUtils.getSStorageInfo("user_id"),
                "opacctkind_flag": 0
            }
            service.checkOpenVerify(param, function (data) {
                var error_no = data.error_no;
                var error_info = data.error_info;
                var result = data.results;
                if (error_no == "0") {
                    appUtils.pageInit("account/openVerify", "account/selDepartment", {});
                } else {
                    layerUtils.iMsg(-1, error_info);
                    layerUtils.iLoading(false);
                }
            });
        });


        /*QQ客服*/
        appUtils.bindEvent($(_pageId + " .clearfix li:eq(3)"), function () {
            if (require("gconfig").platform != "1") {
                //ios 获取软件是否安装
                var param = {
                    "funcNo": "50200",
                    "moduleName": "open",
                    "scheme": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                };
                var result = external.callMessage(param);
                if (result.error_no == 0) {
                    var isInstall = result.results[0].isInstall;
                    //是否安装(0：否，1：是）
                    if (isInstall == "1") {
                        var param = {
                            "funcNo": "50109",
                            "moduleName": "open",
                            "url": "mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"    //ios qq地址
                            //							"url":"mqqwpa://im/chat?chat_type=wpa&uin=800005188"	//android qq地址
                        };
                        external.callMessage(param);
                    } else {
                        layerUtils.iConfirm("检测到您的手机未安装QQ，请先下载并安装QQ客户端", function () {
                            //进入appstore
                            var param = {
                                "funcNo": "50109",
                                "moduleName": "open",
                                "url": "https://itunes.apple.com/cn/app/id444934666?mt=8"    //qq的appstore地址
                            };
                            external.callMessage(param);
                        }, null, "下载", "取消");
                    }
                } else {
                    layerUtils.iAlert("检测QQ失败");
                }
            } else {
                var param = {
                    "funcNo": "50109",
                    "moduleName": "open",
                    //					"url":"mqq://im/chat?chat_type=wpa&uin=800005188&version=1&src_type=web"
                    "url": "mqqwpa://im/chat?chat_type=wpa&uin=800005188"
                };
                external.callMessage(param);
            }
        });

    }

    function destroy() {


    }

    /* 动态加载css */
    function loadCSS(id, fileUrl) {
        var cssTag = document.getElementById(id), oHead = document
            .getElementsByTagName('head').item(0), ocss = document
            .createElement("link");
        if (id == "#blue") {
            oHead.removeChild(document.getElementById("#yellow"));
        } else {
            if (cssTag)
                oHead.removeChild(cssTag);
            ocss.id = id;
            ocss.href = fileUrl;
            ocss.rel = "stylesheet";
            ocss.charset = "uf-8";
            oHead.appendChild(ocss);
        }
    }


    /* 自动测速，选择最佳地址 */
    function setBestAddress() {
        // 检测更新最新版本
        detectUpdate();
    }

    /* 检测更新最新版本 */
    function detectUpdate() {
        var queryParam = {
            "terminal_type": gconfig.platform == "1" ? "android" : "ios"
        };
        service.getVersion(queryParam, function (data) {
            if (data.error_no == 0) {
                layerUtils.iLoading(false);
                // 服务器有数据返回时
                if (data.results.length != 0
                    && data.results[0].update_url != undefined) {
                    execUpdate(data.results); // 执行更新
                }
            } else // 查询地址失败
            {
                layerUtils.iLoading(false);
                layerUtils.iAlert("版本检查失败，请稍后重试！");
            }
        }, true, false);
    }

    // 执行更新操作
    function execUpdate(results) {
        /*var length = results.length,
         updateParam = {
         "url" : results[0].update_url, // 更新地址
         "versionLatest" : results[0].version, // 最新版本号
         // 只有一条记录取 0
         "versionLowest" : results[0].version == results[length - 1].version
         ? "0"
         : results[length - 1].version,
         "firstEnforcement" : results[0].enforcement
         // 第一条记录是否是强制更新
         };
         shellPlugin.callShellMethod("updateManagerPlugin", null, function() {
         layerUtils.iAlert("调用版本更新插件失败！");
         }, updateParam);*/

        //add by fengxiang 2015-07-17 升级
        var length = results.length,
            updateParam = {
                "url": results[0].update_url,  // 更新地址
                "type": "1",
                "version": results[0].version,  // 最新版本号
                // 只有一条记录取 0
                "versionSn": results[0].version,
                "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
                "funcNo": "50201",
                "moduleName": "open"
            };
//		shellPlugin.callShellMethod("updateManagerPlugin",null,function(){
//			layerUtils.iAlert("调用版本更新插件失败！");
//		},updateParam);
        var result = external.callMessage(updateParam);
        //end by fengxiang 2015-07-17 升级
    }


    var openVerify = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    // 暴露对外的接口
    module.exports = openVerify;
});