/**
 * 上传身份证照片
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"), service = require("serviceImp")
            .getInstance(), // 业务层接口，请求数据
        layerUtils = require("layerUtils"), gconfig = require("gconfig"), global = gconfig.global, serverPath = global.serverPath, _pageId = "#account_uploadPhoto",
    // 填写资料的页面入参，属性由 imgState 方法赋值
        fillInformationInParam = {
            "idNo": "", // 身份证号
            "custname": "", // 客户姓名
            "ethnicname": "", // 民族
            "native": "", // 证件地址
            "policeorg": "", // 签发机关
            "borthday": "", // 出生日期
            "idBeginDate": "", // 证件开始日期
            "idEndDate": "", // 证件结束日期
            "gender": "", // 用户性别
            "imgPath": "", // 图片的显示地址
            "imgId": "", // 图片 id
            "branchno": "", // 营业部Id
            "commission": "", // 佣金套餐
            "zipCode": "" // 邮编
        };
    var checkSubmitFlg;

    var external = require("external");

    /* 私有业务模块的全局变量 end */

    function init() {
        layerUtils.iLoading(false);
        /* 照片上传完成后自动调用该方法 */
        window.imgState = imgState;
        // 清理页面元素
        cleanPageElement();
        checkSubmitFlg = false;
        // 设置营业部Id
        fillInformationInParam.branchno = appUtils
            .getPageParam("branchno");
        // 设置佣金套餐
        fillInformationInParam.commission = appUtils
            .getPageParam("commission");
        // 默认选中签署协议
        $(_pageId + " .icon_check").addClass("checked");
        // 获取数字证书申请责任书协议信息
        queryCertAgreement();
    }

    function bindPageEvent() {
        /* 点击页面隐藏按钮 */
        appUtils.bindEvent($(_pageId), function () {
            // 将按钮的自定义属性 last-media-id 设为 当前的 media-id
            $(_pageId + " .upload_btn li").attr(
                "last-media-id",
                $(_pageId + " .upload_btn li:eq(0)")
                    .attr("media-id"));
            // 将按钮的自定义属性 media-id 设为 null
            $(_pageId + " .upload_btn li").attr("media-id",
                "null");
            // 隐藏照片上传按钮
            $(_pageId + " .upload_btn").slideUp("fast");
            $(_pageId + " .upload_box").removeClass("active");
        });

        /* 绑定返回 */
        appUtils.bindEvent($(_pageId + " .header .icon_back"), function () {
            appUtils.pageBack();
        });

        /* 绑定上传正面身份证照 */
        appUtils.bindEvent($(_pageId + " .upload_main .positive"), function (e) {
            $(_pageId + " .upload_main .negative")
                .removeClass("active");
            var isActive = $(this).hasClass("active");
            switchCss($(_pageId + " .upload_main .positive"),
                isActive, 4);
            $(_pageId + " .upload_btn h5").html("上传身份证正面");
            // 阻止冒泡
            e.stopPropagation();
        });

        /* 绑定上传反面身份证照 */
        appUtils.bindEvent($(_pageId + " .upload_main .negative"), function (e) {
            $(_pageId + " .upload_main .positive")
                .removeClass("active");
            var isActive = $(this).hasClass("active");
            switchCss($(_pageId + " .upload_main .negative"),
                isActive, 5);
            $(_pageId + " .upload_btn h5").html("上传身份证反面");
            // 阻止冒泡
            e.stopPropagation();
        });

        /* 点击相册 */
        appUtils.bindEvent($(_pageId + " .upload_btn li:eq(0)"), function (e) {
            // 如果更换图片，要将 fillInformationInParam 中对应的值置空
            // 更换正面照
            if ($(_pageId + " .positive").attr("uploaded") == "true"
                && $(this).attr("media-id") == "4") {
                fillInformationInParam.idNo = "";
                fillInformationInParam.custname = "";
                fillInformationInParam.borthday = "";
                fillInformationInParam.native = "";
                fillInformationInParam.gender = "";
                fillInformationInParam.ethnicname = "";
            }
            // 更换反面照
            if ($(_pageId + " .negative").attr("uploaded") == "true"
                && $(this).attr("media-id") == "5") {
                fillInformationInParam.policeorg = "";
                fillInformationInParam.idBeginDate = "";
                fillInformationInParam.idEndDate = "";
            }
            // 相册上传的参数
            var phoneConfig = {
                "funcNo": "60002",
                "moduleName": "open",
                "funcNum": $(this).attr("media-id") == "3"
                    ? "501526"
                    : "501525",
                "uuid": "index",
                "r": Math.random(),
                "userId": appUtils.getSStorageInfo("user_id"),
                "photoType": $(this).attr("media-id") == "3"
                    ? "人像正面"
                    : "身份证", // 影像名称
                "action": "phone", // 照片来源类别，phone 相册，pai 相机
                "imgType": $(this).attr("media-id"),
                "key": "index", // key 和 uuid 只需要写一个
                "url": global.serverPath,
                "needUpload": "",
                "clientInfo": appUtils.getSStorageInfo("clientinfo"),
                "jsessionId": appUtils.getSStorageInfo("jsessionid")
            };
            if (checkSubmit()) {
                //require("shellPlugin").callShellMethod("carmeraPlugin", null, null, phoneConfig);
                external.callMessage(phoneConfig);
            }
            // 隐藏照片上传按钮
            $(_pageId + " .upload_btn").slideUp("fast");
            $(_pageId + " .upload_box").removeClass("active");
            // 将按钮的自定义属性 last-media-id 设为 当前的 media-id
            $(_pageId + " .upload_btn li").attr(
                "last-media-id",
                $(_pageId + " .upload_btn li:eq(0)")
                    .attr("media-id"));
            // 将按钮的自定义属性 media-id 设为 null
            $(_pageId + " .upload_btn li").attr("media-id",
                "null");
            // 阻止冒泡
            e.stopPropagation();
        });

        /* 点击拍照 */
        appUtils.bindEvent($(_pageId + " .upload_btn li:eq(1)"),
            function (e) {
                // 如果更换图片，要将 fillInformationInParam 中对应的值置空
                // 更换正面照
                if ($(_pageId + " .positive").attr("uploaded") == "true"
                    && $(this).attr("media-id") == "4") {
                    fillInformationInParam.idNo = "";
                    fillInformationInParam.custname = "";
                    fillInformationInParam.borthday = "";
                    fillInformationInParam.native = "";
                    fillInformationInParam.gender = "";
                    fillInformationInParam.ethnicname = "";
                }
                // 更换反面照
                if ($(_pageId + " .negative").attr("uploaded") == "true"
                    && $(this).attr("media-id") == "5") {
                    fillInformationInParam.policeorg = "";
                    fillInformationInParam.idBeginDate = "";
                    fillInformationInParam.idEndDate = "";
                }
                // 相机上传的参数
                var paiConfig = {
                    "funcNo": "60002",
                    "moduleName": "open",
                    "funcNum": $(this).attr("media-id") == "3"
                        ? "501526"
                        : "501525",
                    "uuid": "index",
                    "r": Math.random(),
                    "userId": appUtils.getSStorageInfo("user_id"),
                    "photoType": $(this).attr("media-id") == "3"
                        ? "人像正面"
                        : "身份证", // 影像名称
                    "action": "pai", // 照片来源类别，phone 相册，pai 相机
                    "imgType": $(this).attr("media-id"),
                    "key": "index", // key 和 uuid 只需要写一个
                    "url": global.serverPath,
                    "needUpload": "",
                    "clientInfo": appUtils.getSStorageInfo("clientinfo"),
                    "jsessionId": appUtils.getSStorageInfo("jsessionid")
                    // 从 session 中将 jsessionid 取出
                };
                if (checkSubmit()) {
                    //require("shellPlugin").callShellMethod("carmeraPlugin", null, null, paiConfig);
                    external.callMessage(paiConfig);
                }
                // 隐藏照片上传按钮
                $(_pageId + " .upload_btn").slideUp("fast");
                $(_pageId + " .upload_box").removeClass("active");
                // 将按钮的自定义属性 last-media-id 设为 当前的 media-id
                $(_pageId + " .upload_btn li").attr(
                    "last-media-id",
                    $(_pageId + " .upload_btn li:eq(0)")
                        .attr("media-id"));
                // 将按钮的自定义属性 media-id 设为 null
                $(_pageId + " .upload_btn li").attr("media-id",
                    "null");
                // 阻止冒泡
                e.stopPropagation();
            });

        /* 绑定同意签署协议 */
        appUtils.bindEvent($(_pageId + " .upload_main .icon_check"),
            function () {
                $(this).toggleClass("checked");
            });

        /* 绑定下一步 */
        appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"),
            function () {
                // 验证完成步骤
                var ischecked = $(_pageId
                    + " .upload_main .icon_check")
                    .hasClass("checked");
                // 隐藏照片按钮
                $(_pageId + " .upload_btn").hide();
                if ($(_pageId + " .positive img").length == 0) {
                    layerUtils.iMsg(-1, "请先上传正面照！");
                    return false;
                }
                if ($(_pageId + " .negative img").length == 0) {
                    layerUtils.iMsg(-1, "请先上传反面照！");
                    return false;
                }
                // 检查是否勾选签署协议
                if (ischecked) {
                    // 反面照片上传成功之后，才跳转页面
                    // 如果 补全资料 是补全照片，返回到上一个页面
                    if (appUtils.getSStorageInfo("_prePageCode") == "account/accountResult") {
                        var notifyParam = {
                            "userid": appUtils
                                .getSStorageInfo("user_id"),
                            // 通知图片已补全
                            "fieldname": "photo"
                        };
                        service.rejectStep(notifyParam, function (data) {
                            if (data.error_no == 0) {
                                appUtils.pageBack();
                            }
                        });
                    } else {
                        // 获取邮编
                        var postnumParam = {
                            "addr": fillInformationInParam.native
                        };
                        service.queryPostid(postnumParam, function (data) {
                            var error_no = data.error_no;
                            var postnum = ""; // 邮编号码
                            if (error_no == 0
                                && data.results.length != 0) {
                                postnum = data.results[0].post;
                                fillInformationInParam.zipCode = postnum;
                            }
                            /**
                             * 在切换页面之前，将图片的 base64 编码和图片识别数据保存到
                             * session 中
                             * 转户走新开户流程时，在提交资料的时候跳转到照片上传页面，此时用户不需要上传正面照和反面照，只需补全人脸正像
                             */
                            var photosInfo = {
                                // 正面照 photo4，反面照 photo5
                                "photo4": "",
                                "photo5": "",
                                // 填写资料的页面入参
                                "fillInformationInParam": fillInformationInParam,
                                // 设置 photosInfo 的 isChangeProcess
                                // 属性，true 是更改流程，初始值为 false
                                "isChangeProcess": false
                            };
                            photosInfo.photo4 = $(_pageId
                                + " .positive img").attr("src");
                            photosInfo.photo5 = $(_pageId
                                + " .negative img").attr("src");
                            // 将数据保存到 session 中
                            appUtils.setSStorageInfo("photosInfo",
                                JSON.stringify(photosInfo));
                            appUtils.pageInit(
                                "account/uploadPhoto",
                                "account/personInfo",
                                fillInformationInParam);
                        });
                    }
                } else {
                    layerUtils.iMsg(-1, "请先签署协议！");
                }
            });
    }

    /**
     * added at 2015/07/01 解决重复提交问题
     */
    function checkSubmit() {
        if (checkSubmitFlg == true) {
            return false; //当表单被提交过一次后checkSubmitFlg将变为true,根据判断将无法进行提交。
        }
        checkSubmitFlg == true;
        return true;
    }

    function destroy() {
        service.destroy();
    }

    /* 处理点击上传身份证正面、反面效果 */
    function switchCss(ele, isActive, media) {
        if (isActive) {
            $(_pageId + " .upload_btn").slideUp("fast");
            $(_pageId + " .upload_btn li").attr("media-id", "null");
        } else {
            $(_pageId + " .upload_btn").slideDown("fast");
            $(_pageId + " .upload_btn li").attr("media-id", media);
        }
        $(ele).toggleClass("active");
    }

    /*
     * 清理界面元素 不能写在 destroy 方法里面，写在 destroy 里面，查看协议的时候，界面的元素也会被清理掉
     */
    function cleanPageElement() {
        // 取消勾选协议
        $(_pageId + " .rule_check .icon_check").removeClass("checked");
        // 设置 uploaded 属性为 false
        $(_pageId + " .upload_box").attr("uploaded", false);
        // 恢复照片 li 的内容
        $(_pageId + " .positive").text("");
        $(_pageId + " .negative").text("");
        $(_pageId + " .positive")
            .append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
        $(_pageId + " .negative")
            .append("<dd><p>点击上传身份证</p><h5>背 面</h5></dd>");
    }

    /**
     * 照片上传完成后，会自动调用 imgState 方法，但是该方法只能写在 m/index.html 或者暴露给 window
     * ，否则无法调用 已在 init 中暴露给 window
     */
    function imgState(data) {
        // 返回的是 json 串
        var base64Str = (data.base64).replace(/[\n\r]*/g, "");
        // 只有当返回的数据不为空时，才设置 fillInformationInParam 的属性，确保取识别出来的并集
        // 身份证号
        if (data.idNo.length != 0) {
            fillInformationInParam.idNo = data.idNo;
        }
        // 客户姓名
        if (data.custName.length != 0) {
            fillInformationInParam.custname = data.custName;
        }
        // 证件地址
        if (data.native.length != 0) {
            fillInformationInParam.native = data.native;
        }
        // 民族
        if (data.ethnicName.length != 0) {
            fillInformationInParam.ethnicname = data.ethnicName;
        }
        // 签发机关
        if (data.policeOrg.length != 0) {
            fillInformationInParam.policeorg = data.policeOrg;
        }
        // 出生日期
        if (data.birthday.length != 0) {
            fillInformationInParam.borthday = data.birthday;
        }
        // 证件开始日期
        if (data.idbeginDate.length != 0) {
            fillInformationInParam.idBeginDate = data.idbeginDate;
        }
        // 证件结束日期
        if (data.idendDate.length != 0) {
            fillInformationInParam.idEndDate = data.idendDate;
        }
        // 用户性别
        if (data.userSex.length != 0) {
            fillInformationInParam.gender = data.userSex;
        }
//		// 图片的显示地址
//		if (data.results[0].img_path.length != 0) {
//			fillInformationInParam.imgPath = data.results[0].img_path;
//		}
//		// 图片 id
//		if (data.results[0].id.length != 0) {
//			fillInformationInParam.imgId = data.results[0].id;
//		}
        var maxheight = $(_pageId + " .upload_box").height() + "px";
        $(_pageId + " .upload_box").css("height", maxheight); // 设置回显照片区域高度不变
        switch (Number($(_pageId + " .upload_btn li:eq(0)")
            .attr("last-media-id"))) {
            // 正面照
            case 4 :
                if (fillInformationInParam.idNo.length == 0) {
                    layerUtils.iAlert("身份证号码识别失败，需重新拍摄，请注意拍摄的角度和光线！",
                        -1);
                    // 先将 li 置空
                    $(_pageId + " .positive").text("");
                    // 设置 uploaded 属性，标识图片是否已经上传
                    $(_pageId + " .positive").attr("uploaded", "false");
                    // 显示上传照片
                    $(_pageId + " .positive")
                        .append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
                    return;
                } else if (fillInformationInParam.gender.length == 0) {
                    layerUtils.iAlert("性别识别失败，需重新拍摄，请注意拍摄的角度和光线！", -1);
                    // 先将 li 置空
                    $(_pageId + " .positive").text("");
                    // 设置 uploaded 属性，标识图片是否已经上传
                    $(_pageId + " .positive").attr("uploaded", "false");
                    // 显示上传照片
                    $(_pageId + " .positive")
                        .append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
                    return;
                }
                // 先将 li 置空
                $(_pageId + " .positive").text("");
                // 设置 uploaded 属性，标识图片是否是否已经上传
                $(_pageId + " .positive").attr("uploaded", "true");
                // 显示照片
                $(_pageId + " .positive").append("<dd><img src=\""
                    + base64Str + "\"/></dd>");
                break;
            // 反面照
            case 5 :
                if (fillInformationInParam.idBeginDate.length == 0) {
                    layerUtils.iAlert(
                        "身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！", -1);
                    // 先将 li 置空
                    $(_pageId + " .negative").text("");
                    // 设置 uploaded 属性，标识图片是否是否已经上传
                    $(_pageId + " .negative").attr("uploaded", "false");
                    // 显示上传照片
                    $(_pageId + " .negative")
                        .append("<dd><p>点击上传身份证</p><h5>反 面</h5></dd>");
                    return;
                } else if (fillInformationInParam.idEndDate.length == 0) {
                    layerUtils.iAlert(
                        "身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！", -1);
                    // 先将 li 置空
                    $(_pageId + " .negative").text("");
                    // 设置 uploaded 属性，标识图片是否已经上传
                    $(_pageId + " .negative").attr("uploaded", "false");
                    // 显示上传照片
                    $(_pageId + " .negative")
                        .append("<dd><p>点击上传身份证</p><h5>反 面</h5></dd>");
                    return;
                }
                // 先将 li 置空
                $(_pageId + " .negative").text("");
                // 设置 uploaded 属性，标识图片是否已经上传
                $(_pageId + " .negative").attr("uploaded", "true");
                // 显示照片
                $(_pageId + " .negative").append("<dd><img src=\""
                    + base64Str + "\"/></dd>");
                break;
        }
        // 设置图片展示大小
        $(_pageId + " .upload_box img").css("max-height", maxheight);
    }

    /* 获取数字证书协议 */
    function queryCertAgreement() {
        // category_englishname
        // 中登证书协议：certprotcl 自建证书协议：zjcertprotcl
        var getDigitalParam = {
            "category_englishname": "certprotcl"
        };

        service.queryProtocolList(getDigitalParam, function (data) {
            $(_pageId + " #icon_Check").html("已阅读并同意");
            var error_no = data.error_no, error_info = data.error_info;
            if (error_no == 0 && data.results) {
                // 《中登个人数字证书申请责任书》
                if (data.results[0] != undefined) {
                    $(_pageId + " #icon_Check")
                        .append("<a href=\"javascript:void(0)\" id=\"protocol00\">《"
                            + data.results[0].econtract_name
                            + "》</a>");
                }
                // 《电子签名约定书》
                if (data.results[1] != undefined) {
                    $(_pageId + " #icon_Check")
                        .append("<a href=\"javascript:void(0)\" id=\"protocol01\">《"
                            + data.results[1].econtract_name
                            + "》</a>");
                }

                // 预绑定查看协议的事件
                appUtils.preBindEvent($(_pageId + " #icon_Check"),
                    "#protocol00", function (e) {
                        // 阻止冒泡
                        e.stopPropagation();
                        appUtils.pageInit("account/uploadPhoto",
                            "account/showDigitalProtocol", {
                                "protocolId": data.results[0].econtract_no
                            });
                    });
                // 预绑定查看协议的事件
                appUtils.preBindEvent($(_pageId + " #icon_Check"),
                    "#protocol01", function (e) {
                        // 阻止冒泡
                        e.stopPropagation();
                        appUtils.pageInit("account/uploadPhoto",
                            "account/showDigitalProtocol", {
                                "protocolId": data.results[1].econtract_no
                            });
                    });
            } else {
                layerUtils.iAlert(data.error_info);
            }
        });
    }

    var uploadPhoto = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy,
        "imgState": imgState

    };

    /* 暴露对外的接口 */
    module.exports = uploadPhoto;
});