﻿/**
 * 手机开户2.0
 */
define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(), // 业务层接口，请求数据
        layerUtils = require("layerUtils"),
        gconfig = require("gconfig"),
        global = gconfig.global,
        platform = require("gconfig").platform,
        utils = require("utils"),
        times = null,
        _pageId = "#business_index";
    var HIscroll = require("hIscroll");
    var myHIscroll = null;
    var external = require("external");
    /* 私有业务模块的全局变量 end */

    function init() {
        //如果是中焯的 显示返回 和 退出按钮
        if (global.isZhongZhuo) {
            $(_pageId + " .header .icon_back").show();
            $(_pageId + " .header .icon_quit").show();
        }

        //start by 2015-04-11 16:32  解决完成后 返回首页 出现白屏
        myHIscroll = null;
        /*start by 2015-04-01 20:56添加滑动*/
        selectresluts();
        //设置10s调用一次
//		times=setInterval(function(){
//            myHIscroll = null;
//			selectresluts();
//		}, 100000);
        /*start by 2015-04-01 20:56添加滑动*/

//		layerUtils.iAlert("测试更新个人信息和创业板，已屏蔽自动更新");
//		appUtils.setSStorageInfo("started","true",true)
//		return;

        window.getInput = utils.getInput; // 暴露调用密码键盘给window
        window.onFinish = utils.onFinish; // 暴露关闭密码键盘给window
        if (appUtils.getSStorageInfo("backIndex") == 1) {

            appUtils.clearSStorage();  // 清空所有的session
            appUtils.clearLStorage();
            appUtils.setSStorageInfo("started", "true", true);
        }
        // 自动测速，选择最佳地址
        // 启动时，检查当前客户端的版本号与服务器上最新的是否一致，根据需要更新客户端，只在启动时检查，started 为 true
        // 表示已启动，已启动就不检查
        if (appUtils.getSStorageInfo("started", true) != "true") {
            // 设置 session 中的 started 为 true ，表示已启动

            var param = {
                "moduleName": "open",
                "funcNo": "50030"
            };
            //判断是否有网络
            var result = external.callMessage(param);
            var error_no = result.error_no;
            var result = result.results[0];
            if (error_no == "0") { //查询网络成功
                if (result.network != "0") {	//判断是否有网络  0：断网，1：2G，2：3G，3：4G，4：WIFI，9：未定义
                    appUtils.setSStorageInfo("started", "true", true);
                    layerUtils.iLoading(true, "正在检查版本...");
                    setBestAddress(); // 设置最佳地址
                } else {
                    layerUtils.iAlert("请连接网络！");
                }
            } else {
                layerUtils.iAlert("查询网络失败,请稍后重试！");
            }
        }

    }

    function bindPageEvent() {
        /*返回*/
        appUtils.bindEvent($(_pageId + " .header .icon_back"), function () {
            var param = {
                "funcNo": "50101",
                "moduleName": "open"
            };
            external.callMessage(param);
            appUtils.clearSStorage(true);
            $(_pageId).remove();
        });

        /*退出*/
        appUtils.bindEvent($(_pageId + " .header .icon_quit"), function () {
            var param = {
                "funcNo": "50101",
                "moduleName": "open"
            };
            external.callMessage(param);
            appUtils.clearSStorage(true);
            $(_pageId).remove();
        });

        /* 绑定新开账户 */
        appUtils.bindEvent($(_pageId + " .clearfix li:eq(0)"), function () {
            // 设置标识'new',表示新开户,并且存到local
            appUtils.setSStorageInfo("openChannel", "new");
            appUtils.setSStorageInfo("preModule", "main", true);
            appUtils.pageInit("business/index", "account/accountFor", {});
        });
        /*港股通*/
        appUtils.bindEvent($(_pageId + " .clearfix li:eq(1)"), function () {
            //标识 从开户跳转到港股通
            appUtils.setSStorageInfo("preModule", "main", true);
            appUtils.sendDirect("../ggt/index.html");
        });

        /*增开*/
        appUtils.bindEvent($(_pageId + " .clearfix li:eq(2)"), function () {
            appUtils.setSStorageInfo("preModule", "main", true);
            appUtils.sendDirect("../addopen/index.html");
            return false;
        });

        /*修改个人信息*/
        appUtils.bindEvent($(_pageId + " .clearfix li:eq(3)"), function () {
            appUtils.setSStorageInfo("preModule", "main", true);
            appUtils.sendDirect("../modifyInfo/index.html");
        });

        /* 创业板改签 added at 2016-02-26*/
        appUtils.bindEvent($(_pageId + " .clearfix li:eq(4)"), function () {
            appUtils.setSStorageInfo("preModule", "main", true);
            appUtils.sendDirect("../cyb/index.html");
        });


    }

    function destroy() {

        myHIscroll.destroy();
        myHIscroll = null;
    }

    /* 动态加载css */
    function loadCSS(id, fileUrl) {
        var cssTag = document.getElementById(id), oHead = document
            .getElementsByTagName('head').item(0), ocss = document
            .createElement("link");
        if (id == "#blue") {
            oHead.removeChild(document.getElementById("#yellow"));
        } else {
            if (cssTag)
                oHead.removeChild(cssTag);
            ocss.id = id;
            ocss.href = fileUrl;
            ocss.rel = "stylesheet";
            ocss.charset = "uf-8";
            oHead.appendChild(ocss);
        }
    }

    var index = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };

    /* 自动测速，选择最佳地址 */
    function setBestAddress() {
        // 检测更新最新版本
        detectUpdate();
    }

    /* 检测更新最新版本 */
    function detectUpdate() {
        var queryParam = {
            "by_type": "1",
            "terminal_type": gconfig.platform == "1" ? "android" : "ios"
        };
        //是否是中焯的  // by_type 1: 中焯版本   2： 单独
        if (global.isZhongZhuo) {
            queryParam.by_type = "1";
        } else {
            queryParam.by_type = "2";
        }
        service.getVersion(queryParam, function (data) {
            //alert("8888:"+JSON.stringify(data));
            if (data.error_no == 0) {
                layerUtils.iLoading(false);
                // 服务器有数据返回时
                if (data.results.length != 0 && data.results[0].update_url != undefined) {
                    if (platform == "1") {
                        execUpdateAndroid(data.results); // 执行安卓更新
                    } else {
                        execUpdateIOS(data.results); // 执行IOS更新
                    }

                }
            } else // 查询地址失败
            {
                layerUtils.iLoading(false);
                layerUtils.iAlert("版本检查失败，请稍后重试！");
            }
        }, true, false);
    }

    // 执行安卓更新操作
    function execUpdateAndroid(results) {
        var param = {
            "funcNo": "50010",
            "moduleName": "common",
            "source": "open"
        };
        //获取当前版本
        var result1 = external.callMessage(param);
        if (result1.error_no == "0") {
            //如果当前版本不是最新的 则下载更新
            var version = results[0].version; // 最新版本
            var version_now = result1.results[0].versionSn; // 当前版本
            if (version > version_now) {
                //add by fengxiang 2015-07-17 升级
                var updateParam = {
                    "url": results[0].update_url,  // 更新地址
                    "type": "1",
                    "version": results[0].version,  // 最新版本号
                    // 只有一条记录取 0
                    "versionSn": results[0].version,
                    "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
                    "funcNo": "50201",
                    "moduleName": "common",
                    "source": "open"
                };
                external.callMessage(updateParam);
                //end by fengxiang 2015-07-17 升级
            }
        }
    }

    // 执行IOS更新操作
    function execUpdateIOS(results) {
        //add by fengxiang 2015-07-17 升级
        var updateParam = {
            "url": results[0].update_url,  // 更新地址
            "type": "1",
            "version": results[0].version,  // 最新版本号
            // 只有一条记录取 0
            "versionSn": results[0].version,
            "firstEnforcement": results[0].enforcement,  // 第一条记录是否是强制更新
            "funcNo": "50201",
            "moduleName": "open"
        };
        external.callMessage(updateParam);
        //end by fengxiang 2015-07-17 升级

    }

    /*add by start 2015-04-01 20:58 */

    function selectresluts() {
        if (!myHIscroll) {
            var config = {
                wrapper: $(_pageId + ' #wrapper_yourname'), //wrapper对象
                scroller: $(_pageId + ' #scroller_yourname'), //scroller对象
                perCount: 1,  //每个可视区域显示的子元素，就是每个滑块区域显示几个子元素
                showTab: true, //是否有导航点
                tabDiv: $(_pageId + ' #tag_yourname'), //导航点集合对象
                auto: true //是否自动播放
            };
            myHIscroll = new HIscroll(config);
            $(' #wrapper_yourname  #scroller_yourname li').show();
        }

    }

    /*add by start 2015-04-01 20:58 */
    // 暴露对外的接口
    module.exports = index;
});