/**
 * @author JiangXiaolong
 * 利用ichart绘图
 */
define(function (require, exports, module) {
	require("./icharts");
	//【面积图】
	function draw2DArea(container_id,data,options)
	{
		$(function(){
		var chart = new iChart.Area2D({
				render : container_id,
				data: data,
				title : options.title,
				width : options.width,
				height : options.height,
				tip:{
					enable:true,
					shadow:true,
					listeners:{
						parseText:function(tip,name,value,text,i){
							return "<span style='color:#005268;font-size:16px;font-weight:600;'>"+value+"</span>";
						}
					  }
					},
				crosshair:{
					enable:true,
					line_width:2,
					line_color:'#6cc4f4'//十字线的颜色
				},
				coordinate:{
					height:'90%',
					background_color:'#edf8fa',
					scale:[{				//y轴刻度数据
						position:'left',	
						start_scale:options.scale.start,	//设置开始刻度
						end_scale:options.scale.end,		//设置结束刻度
						scale_space:options.scale.space,	//设置刻度间距
						scale_size : 2,
						scale_enable : false,
						label : {font : 'Helvetica, Arial, sans-serif',fontsize:14},
						scale_color:'#9f9f9f'
						},
						{					//x轴数据
						 position:'bottom',	
						 scale_enable : false,
						 label : {font : 'Helvetica, Arial, sans-serif',fontsize:14},
						 labels:options.labels
					  }]
				},
				sub_option : {
					smooth : false,	//曲线是否平滑
					label : false,	
					point_hollow : true,//数据点是否实心
					intersection:false,	//线段是否在的结合点处突出显示
					gradient:true//True表示开启渐变效果.(默认为false)
				}
			});
		
		chart.draw();
	});
	}
	
	//【2D环形图】
	/**
	 * @param {Object} data 数据[
	 *  {name : '农林牧渔',value : 36.2,color:'#fedd74'},
	 *	{name : '食品饮料',value : 30.1,color:'#82d8ef'},
	 *	{name : '建筑建材',value : 23.8,color:'#f76864'},
	 *	{name : '信息设备',value : 13.7,color:'#80bd91'},
	 *	{name : '其他',value : 8.9,color:'#fd9fc1'}	];
	 * @param {Object} container_id 画板id
	 * @param {Object} options	其他数据
	 */	
	function draw2DAnnular(container_id,data,options)
	{
		$(function(){
			var chart = new iChart.Donut2D({
				render : container_id,
				data: data,
				center : {
					color:'#3e576f',
					shadow:true,
					shadow_blur : 2,
					shadow_color : '#557797',
					shadow_offsetx : 0,
					shadow_offsety : 0,
					fontsize : 20
				},
				sub_option : {			//圈外图标
					label : {
						background_color:null,
						sign:false,//设置禁用label的小图标
						padding:'0 1',
						fontsize:15,
						fontweight:600,
						color : '#4572a7'
					},
					border : {
						width : 2,
						color : '#ffffff'
					}
				},
				shadow : false,
				shadow_blur : 6,
				shadow_color : '#aaaaaa',
				shadow_offsetx : 0,
				shadow_offsety : 0,
				background_color:'#fefefe',
				animation:true,		//设置过渡动画
				offset_angle:-120,	//逆时针偏移120度
				showpercent:true,	//是否显示百分号
				decimalsnum:1,		//百分比小数点精度
				donutwidth:30,				//环形的宽度
				width : options.width,	//图片宽度
				height :options.height,	//图片高度
				radius:options.radius	//外圆半径
			});
			
			chart.draw();
		});
	}
	var chartsUtils = {
		"draw2DAnnular":draw2DAnnular,
		"draw2DArea":draw2DArea
	};
	module.exports = chartsUtils;
});