/**************************************************************
 @author liaohl
 @date: 2013-10-08
 @description 上下滑动，只有平滑过渡效果，增加滚动条
 @param config 配置参数
	config.wrapper wrapper元素，必传
	config.container container元素，必传
	config.containerHeight 滑动组件的高度，非必传，不传为屏幕高度
	config.containerWidth 滑动组件的宽度，非必传，不传为屏幕宽度
   
\/***********************使用案例***********************\/
1、定义
	var SVIscroll = require("svIscroll");
	var mySvIscroll = null;
2、初始化
	if(!mySvIscroll){
		var config = {
			wrapper: $('wrapper对象选择器'), //wrapper对象
			container: $('container对象选择器') //container对象
		}
		mySvIscroll = new SVIscroll(config); //初始化
	}
3、销毁（看情况而定是否需要销毁）
	mySvIscroll.destroy();
	mySvIscroll = null;
******************************************************************/
define(function (require, exports, module) {

	function SVIscroll(config)
	{
		var This = this;
		var wrapperObj = null;
		
		/**
		 * 设置相关css样式
		 */
		this.setCssHW = function() {
			var wrapper = config.wrapper;
			var scroller = wrapper.children();
			var container = config.container;
			var containerHeight = config.containerHeight;
			var containerWidth = config.containerWidth;
			if(containerHeight) {
				wrapper.height(containerHeight);
			} else {
				wrapper.height($(window).height());
			}
			if(containerWidth) {
				wrapper.width(containerWidth);
			} else {
				wrapper.width($(window).width());
			}
			wrapper.css({
				"position": "absolute"
			});
			scroller.css({
				"position": "absolute",
				"width": "100%",
				"padding": "0px"
			});
			container.css({
				"padding": "0px",
				"margin": "0px",
				"width": "100%"
			});
		};

		/**
		 * 刷新
		 */
		this.refresh = function(len) {
			
		};
		
		/**
		 * 滑动组件初始化
		 * 在初始化滑动组件前，滑动组件的DOM结构已完备，即如果dom节点是动态添加的，则在添加完成之后再初始化
		 */
		this.init = function()
		{
			//先设置相关css样式
			this.setCssHW();
			
			//初始化滑动对象
			var iScroll = require("iscroll");
			wrapperObj = new iScroll(config.wrapper[0], {
				onScrollMove: function() {
					config.wrapper.children("div").eq(1).show(); //滚动条处理
				},
				onScrollEnd: function() {
					config.wrapper.children("div").eq(1).hide(); //滚动条处理
				}
			});
			setTimeout(function () { config.wrapper.children("div").eq(1).hide(); }, 200);
		};
		
		/**
		 * 销毁引用，待释放内存
		 */
		this.destroy = function() {
			if(wrapperObj != null) {
				wrapperObj.destroy();
				wrapperObj = null;
			}
		};
		
		This.init();
	};
	//暴露对外的接口
	module.exports = SVIscroll;
});