/**
 * 这里是通用的消息处理，跟业务无关
 * 59开头表示H5与原生之间的交互，其中590开头表示H5调用原生，591开头表示原生调用H5
 */
define(function(require,exports,module){
	
	var	gconfig = require("gconfig");
	var	global = gconfig.global;
	var appUtils = require("appUtils");
	var	layerUtils = require("layerUtils");
	
	var backBtnMarkTime = 0;
	var KEYBOARDCODE = {"CLEAR":-2, "DONE": -3, "DEL": -5}; //常量，键盘上面的按键对应编码（-2表示清空，-3表示完成，-5表示删除）
	
	/**
	 * 退出应用程序
	 */
	function exitApp() {
		if(true) { //退出应用程序效果的开关
			if(new Date().getTime() - backBtnMarkTime < 2000) { //短时间第二次点击返回键，则确认退出app
				backBtnMarkTime = 0;
				//require("external").callMessage({"funcNo":"59000"}); //退出app
				
				//add by fengxiang 2015-07-31  按两次返回 跳转到中焯交易
				require("external").callMessage({"funcNo":"50101","moduleName":"open"}); //退出app
				appUtils.clearSStorage(true);
				var pageId = $("body .page[data-display='block']").attr("id");
				$("#"+pageId).remove();
				//end by fengxiang 2015-07-31  按两次返回 跳转到中焯交易
				
			} else { //相隔时间大于2秒，则只提示是否退出app
				require("external").callMessage({"funcNo":"59001", "content":"再按一次退出应用程序", "type":0}); //提示是否退出app
				backBtnMarkTime = new Date().getTime();
			}
		} else {
			layerUtils.iConfirm("确认退出应用程序？", function(){
				require("external").callMessage({"funcNo":"59000"}); //退出app
			});
		}
	}
	
	/**
	 * Android手机的返回键消息处理
	 * @param paramMap json格式参数
	 */
	function function59100(paramMap) {
		//判断是否直接退出
		if(!require("gconfig").isDirectExit) {
			//弹出层消失，弹出层抽象利于处理，返回上一级页面，page增加上一级页面
			var pageLevel = $(".page[data-display=block]").attr("data-pageLevel");
			if(pageLevel == "1") {
				exitApp();
			} else {
				var curPageCode = require("appUtils").getSStorageInfo("_curPageCode");
				curPageCode = (!curPageCode || curPageCode=="null")?"":curPageCode;
				require.async(require("gconfig").scriptsPath+curPageCode, function(page) {
					if(page.pageBack) {
						page.pageBack();
					} else {
						require("appUtils").pageBack();
					}
				});
			}
		} else {
			exitApp();
		}
	}
	
	/**
	 * 键盘操作的响应事件，通知H5调用者，键盘的点击情况
	 * @param paramMap json格式参数
	 */
	function function50212(paramMap) {
		console.log("入参"+JSON.stringify(paramMap));
		var pageId = paramMap.pageId;
		var eleId = paramMap.eleId;
		var keyCode = paramMap.keyCode; //对于H5来说，keyCode除了表示完成和删除的编码，其他都是直接用来操作的字符
		
		var $targetEle = $("#"+pageId + " #"+eleId);
		var curEleVal = $targetEle.val();
        
		if(keyCode == KEYBOARDCODE.DONE) { //完成
			console.log("键盘操作的响应事件，通知H5调用者，键盘的点击情况~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~完成");
			$("#"+pageId).css("height",$(window).height()+"px");
		} else {
			//获取输入域光标的当前索引
			var cursurPosition = getTxtCursorPosition($targetEle);
			//将输入域分成光标前后2个分部的值
			var prePositionVal = curEleVal.substring(0, cursurPosition);
			var nextPositionVal = curEleVal.substring(cursurPosition, curEleVal.length);
			console.log(cursurPosition+"~~~"+curEleVal+"~~~"+prePositionVal+"~~~"+nextPositionVal);

			if(keyCode == KEYBOARDCODE.DEL) { //删除，则将光标前面部分的输入域内容删除一个字符
				//删除最后一位
				if(curEleVal.length>0) {
					$targetEle.val(curEleVal.substring(0,curEleVal.length-1));
				}
			} else if(keyCode == KEYBOARDCODE.CLEAR) { //清空输入域的内容
				$targetEle.val("");
			} else { //既不是删除又不表示完成，表示直接字符输入，则直接拼接字符
				//按的是数字且输入框val值长度小于6
				if(keyCode && keyCode.length>0 && curEleVal.length<6){
					$targetEle.val(curEleVal+keyCode);
				}
			}
		}
	}
	
	/**
	 * 获取输入input域的光标索引位置
	 * @param jQEle input元素
	 */
	function getTxtCursorPosition(jQEle) {
		var ele = $(jQEle)[0];
		var cursurPosition = 0;
		if(ele.selectionStart) { // 非IE浏览器
			cursurPosition= ele.selectionStart;
		} else { // IE
			if(document.selection) {
				var range = document.selection.createRange();
				range.moveStart("character",-ele.value.length);
				cursurPosition = range.text.length;
			}
		}
		return cursurPosition;
	}
	
	/*
	 * 设置输入域(input/textarea)光标的位置
	 * @param jQEle jquery元素
	 * @param index 要设置的索引位置
	 */
	function setCursorPosition(jQEle, index) {
		var ele = $(jQEle)[0];
	    var val = jQEle.val();
	    var len = val.length;
	 
	    //超过文本长度直接返回
	    if (len < index) return false;

        ele.focus();
        if (ele.setSelectionRange) { // 标准浏览器
            ele.setSelectionRange(index, index);
        } else { // IE9-
            var range = ele.createTextRange();
            range.moveStart("character", -len);
            range.moveEnd("character", -len);
            range.moveStart("character", index);
            range.moveEnd("character", 0);
            range.select();
        }
	}
	
	
	var commsg = {
		"function59100": function59100,
		"function50212": function50212
	};
	module.exports = commsg;
});
