/**
 * 替换phonegap后，用于与原生交互的模块
 */
define(function(require, exports, module) {

	var	gconfig = require("gconfig");
	var	global = gconfig.global;
	var appUtils = require("appUtils");
	var	layerUtils = require("layerUtils");
//	var	msgFunction = require("msgFunction");
	
	/**
	 * H5调用原生的方法，并且现在只有一个入口，没有sendMessage和callFunction两个入口方法，
	 * 如果有异步就通过H5暴露给原生的js方法-callMessage，回调过来！！
	 * @param paramMap json格式参数
	 * @returns returnVal 有值则返回
	 */
	function callMessage(paramMap) 
	{
		console.log("调用原生插件入口！"+JSON.stringify(paramMap));
		var returnVal;
		try {
			paramMap = paramMap?paramMap:{};
			if(gconfig.platform == "1"){ //Android
				returnVal = external.callMessage(JSON.stringify(paramMap));
				if(returnVal){
				    returnVal = eval("("+returnVal+")");
				}
			} else if(gconfig.platform == "2"){ //IOS
	            //利用ajax同步请求和IOS的js-invoke协议实现同步调用原生代码
	            var xhr = new  XMLHttpRequest();
	            xhr.open("GET", "js-invoke://external:callMessage@"+encodeURIComponent(JSON.stringify(paramMap)),false); //这里还是callMessage
	            xhr.send("");
	            returnVal = JSON.parse(xhr.responseText);
			}
		} catch (e) {
			layerUtils.iAlert("H5调用原生external.callMessage方法出错："+e.message);
		}
		return returnVal?returnVal:{};
	}
	
	/**
	 * 原生调用H5的业务消息
	 * paramMap json格式参数
	 * @returns 原生调用H5，无返回值
	 */
	window.callMessage = function (paramMap)
	{
		paramMap = paramMap?paramMap:{};
		try {
			var funcName = "function" + paramMap.funcNo;
			require.async("msgFunction", function(msgFunction){
				if(msgFunction[funcName]) {
					msgFunction[funcName](paramMap);
				} else {
					layerUtils.iAlert("原生调用H5的msgFunction模块中"+funcName+"方法不存在！");
				}
			});
		} catch (e) {
			layerUtils.iAlert("原生调用H5的callMessage（功能号-"+paramMap.funcNo+"）出错："+e.message);
		}
	};
	
	module.exports = {
		"callMessage": callMessage
	};
});
