/**
 * 消息接收处理模块，提供给原生调用H5，
 * 经过window.callMessage方法，传入功能号，最后调用这个模块的对象方法
 */
define(function(require,exports,module){
	
	var	gconfig = require("gconfig");
	var	global = gconfig.global;
	var appUtils = require("appUtils");
	var	layerUtils = require("layerUtils");
	var platform = gconfig.platform;
	
	/**
	 * 登录成功、失败后发送消息到所有模块
	 * @param paramMap json格式参数
	 */
	function function50000(paramMap) {
		
	}

	/**
	* 拍照回调
	*/
	function function60050(paramMap) {
		console.log(JSON.stringify(paramMap));
		var pageId = $("body .page[data-display='block']").attr("id");
		var pageCode = pageId.replace("_", "/");
		require.async(gconfig.scriptsPath+pageCode, function(page){
			page.imgState(paramMap);
		});
	}

	/**
	* 视频回调
	*/
	function function60051(paramMap) {
		var pageId = $("body .page[data-display='block']").attr("id");
		var pageCode = pageId.replace("_", "/");
		require.async(gconfig.scriptsPath+pageCode, function(page){
			page.videoFlag(paramMap);
		});
	}

	/**
	* 人脸识别回调
	*/
	function function60053(paramMap) {
		var pageId = $("body .page[data-display='block']").attr("id");
		var pageCode = pageId.replace("_", "/");
		require.async(gconfig.scriptsPath+pageCode, function(page){
			page.imgState(paramMap);
		});
	}

	/**
	* 单向视频回调
	*/
	function function60054(paramMap) {
		var pageId = $("body .page[data-display='block']").attr("id");
		var pageCode = pageId.replace("_", "/");
		require.async(gconfig.scriptsPath+pageCode, function(page){
			page.videoOfflineSuccess(paramMap);
		});
	}

	/**
	* 活体识别回调
	*/
	function function60055(paramMap) {
		var pageId = $("body .page[data-display='block']").attr("id");
		var pageCode = pageId.replace("_", "/");
		require.async(gconfig.scriptsPath+pageCode, function(page){
			page.verifyInfo(paramMap);
		});
	}
	/**
	* 日期插件回调
	*/
	function function50251(paramMap) {
		var pageId = $("body .page[data-display='block']").attr("id");
		var pageCode = pageId.replace("_", "/");
		require.async(gconfig.scriptsPath+pageCode, function(page){
			page.calendarCallback(paramMap);
		});
	}
	/**
	* 获取经纬度原生回调
	*/
	function function60056(paramMap) {
		var pageId = $("body .page[data-display='block']").attr("id");
		var pageCode = pageId.replace("_", "/");
		require.async(gconfig.scriptsPath+pageCode, function(page){
			page.getjwd(paramMap);
		});
	}

	var msgFunction = {
		"function50000": function50000,
		"function60050": function60050,
		"function60051": function60051,
		"function60053": function60053,
		"function60054": function60054,
		"function60055": function60055,
		"function50251": function50251,
		"function60056": function60056
	};
	//加载通用消息处理，放到msgFunction模块里面，即msgFunction包含commsg
	var commsg = require("./commsg");
	if(commsg) {
		for(var item in commsg){
			msgFunction[item] = commsg[item];
		}
	}
	module.exports = msgFunction;
});
