﻿define(function(require,exports,module){
	var layerUtils = require("layerUtils");
	
	/**
	 * 调用AIR插件
	 * @param {} pluginName
	 * @param {} success
	 * @param {} fail
	 * @param {} config
	 * @returns {} 
	 */
	function callShellMethod(pluginName,success,fail,config)
	{
		try
		{
			if(config==null||config==undefined){
				config = new Object();
			}
			else{
				config = encodeCNParam(config);
			}
	  		StageWebViewBridge.call('callAirPlugin',function(data) {
	  			data = parseAirObject(data);
	  			var error_no = data.error_no;
	  			if(error_no=="0"){
	  				if(success){
	  					if(pluginName=="initZsPlugin"||pluginName=="importCertWithPwdPlugin"){
	  						success('OK');
	  					}
	  					else if(pluginName=="getIpMacPLugin"){
							success(data.ip);
						}
	  					else{
		  					success(data);
	  					}
	  				}
	  			}
	  			else{
	  				if(fail){
	  					fail(data);
	  				}
	  			}
			},pluginName,config);
		}
		catch(e)
		{
			layerUtils.iLoading(false);
			layerUtils.iAlert("不支持StageWebView！");
		}
	}
	
	/**
	 * 将传入air的参数编码
	 **/
	function encodeCNParam(param)
	{
	 	for ( var key in param) {
			var value = param[key] + "";
			if (value === null || value === undefined || value === ""
					|| value.trim().toLowerCase() === "null"
					|| value.trim().toLowerCase() === "undefined") {
				param[key] = "";
			} else {
				value = escape(value);
				param[key] = value;
			}
		}
		return param;
	}
	
	/**
	 * 解析OBJECT空字符
	 **/
	function parseAirObject(param)
	{
		for ( var key in param) {
			var value = param[key] + "";
			if (value === null || value === undefined || value === ""
					|| value.trim().toLowerCase() === "null"
					|| value.trim().toLowerCase() === "undefined") {
				param[key] = "";
			} 
		}
		return param;
	}
	  
	var airPlugin = {
		"callShellMethod": callShellMethod
	};
	module.exports =  airPlugin;
});
